SystemOrganization addCategory: #'OpenDBX-Core-Structure'!
SystemOrganization addCategory: #'OpenDBX-Core-API'!
SystemOrganization addCategory: #'OpenDBX-Core-Tests'!
SystemOrganization addCategory: #'OpenDBX-Core-Description'!
SystemOrganization addCategory: #'OpenDBX-Core-Benchmark'!
SystemOrganization addCategory: #'OpenDBX-Core-Tests-Extras'!
SystemOrganization addCategory: #'OpenDBX-Core-Encoding-Tests'!
SystemOrganization addCategory: #'OpenDBX-Core-Encoding'!

!ByteArray class methodsFor: '*OpenDBX-Core' stamp: 'MarianoMartinezPeck 2/12/2010 20:24'!
fromDbxString: aString 
	^ aString asByteArray ! !

!ByteArray methodsFor: '*OpenDBX-Core' stamp: 'MarianoMartinezPeck 2/13/2010 15:27'!
asDbxString
	self asString! !

!Number class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:10'!
fromDbxString: aString
	^self readFrom: aString readStream! !

!TimeStamp methodsFor: '*OpenDBX-Core' stamp: 'MMP 10/13/2008 19:14'!
yyyymmddhhmmss
"It returns a String with tha timestamp in yyyy-mm-dd hh:mm:ss format.
Example: 

(TimeStamp 
			year: 2008 
			month: 1 
			day: 20 
			hour: 10 
			minute: 20 
			second: 30) yyyymmddhhmmss.

shows: '2008-01-20 10:20:30'  "

	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents! !

Error subclass: #DBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:50'!
header
	self subclassRisponsability! !

!DBXError class methodsFor: 'exceptionInstantiator' stamp: 'HMC 10/14/2008 23:40'!
signal: signalerText 
	super signal: self header , signalerText! !

DBXError subclass: #OpenDBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

OpenDBXError subclass: #DBXFatalError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXFatalError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:52'!
header
	^'FATAL OpenDBX: '! !

OpenDBXError subclass: #DBXRecoverableError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXRecoverableError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:53'!
header
	^ 'RECOVERABLE OpenDBX: '! !

DBXError subclass: #SqueakDBXError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!SqueakDBXError class methodsFor: 'private' stamp: 'HMC 10/14/2008 23:53'!
header
	^ 'SqueakDBX: '! !

!UndefinedObject methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 12:49'!
asDbxString
	^'NULL'! !

!UndefinedObject methodsFor: '*OpenDBX-Core' stamp: 'TestRunner 12/8/2009 22:21'!
isResultSet
	^ false.! !

TextConverter subclass: #DBXNullTextConverter
	instanceVariableNames: ''
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding'!

!DBXNullTextConverter commentStamp: '<historical>' prior: 0!
I don't do any conversion between the Strings (ByteArrays) I receive. I simply pass the data as it.
Basically I am used to remove isNil checks.!

!DBXNullTextConverter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/25/2010 19:33'!
instance
	^instance ifNil:[instance:=DBXNullTextConverter basicNew].! !

!DBXNullTextConverter methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/30/2010 21:36'!
convertFromSystemString: aString
	^aString.! !

!DBXNullTextConverter methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/30/2010 21:41'!
convertToSystemString: aString
	^aString.! !

!DBXNullTextConverter methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/31/2010 14:29'!
nextFromStream: aStream
	^aStream next.! !

!DBXNullTextConverter methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/30/2010 21:51'!
nextPut: aChar toStream: aStream
	aStream nextPut: aChar.! !

!String class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:11'!
fromDbxString: aString
	^aString! !

!String methodsFor: '*OpenDBX-Core' stamp: 'MMP 2/4/2009 23:46'!
asDbxString
	^self class new writeStream
		nextPut: $';
		nextPutAll: self;
		nextPut: $';
		contents! !

!Boolean class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:55'!
fromDbxString: aString
	aString = '1' ifTrue: [ ^true ].
	aString = '0' ifTrue: [ ^false ].
	DBXError signal: 'Invalid boolean input: ', aString! !

Notification subclass: #DBXNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!False methodsFor: '*OpenDBX-Core' stamp: 'EL 8/14/2008 09:18'!
asDbxString
	^'false'! !

!True methodsFor: '*OpenDBX-Core' stamp: 'EL 8/14/2008 09:18'!
asDbxString
	^'true'! !

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Time class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:11'!
readDbxFrom: aStream
	| hour minute second |

	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.

	^self hour: hour  
		minute: minute 
		second:  second! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.	
	^ stream contents asDbxString! !

!Time methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:24'!
printDbxOn: aStream
	aStream
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

ExternalStructure subclass: #DBXTimeSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 7/1/2009 21:50'!
defaultTimeSpec
	^ self seconds: 0 nseconds: 1! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 6/4/2009 23:39'!
fields
	^#(
		(seconds 'long')
		(nseconds 'long'))! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 9/29/2008 22:26'!
initialize
	super initialize.
	self defineFields! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 4/6/2009 19:49'!
seconds: seconds 
	^ self new
		seconds: seconds;
		nseconds: 0;
		yourself! !

!DBXTimeSpec class methodsFor: 'field definition' stamp: 'MMP 4/6/2009 19:48'!
seconds: seconds nseconds: nseconds 
	^ self new
		seconds: seconds;
		nseconds: nseconds;
		yourself! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'tbn 9/3/2010 12:02'!
nseconds
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'tbn 9/3/2010 12:02'!
nseconds: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'tbn 9/3/2010 12:02'!
seconds
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!DBXTimeSpec methodsFor: 'accessing' stamp: 'tbn 9/3/2010 12:02'!
seconds: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:36'!
fromDbxString: aString 
	^ self readDbxFrom: aString readStream! !

!Date class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 10:09'!
readDbxFrom: aStream
	| year month day |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upToEnd) asInteger.

	^self year: year 
		month: month 
		day: day! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString ! !

!Date methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:27'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0).! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:29'!
fromDbxString: aString 
	^self readDbxFrom: aString readStream! !

!DateAndTime class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 11:30'!
readDbxFrom: aStream
	| year month day hour minute second |

	year := (aStream upTo: $-) asInteger.
	month := (aStream upTo: $-) asInteger.
	day := (aStream upTo: Character space) asInteger.
	hour := (aStream upTo: $:) asInteger.
	minute := (aStream upTo: $:) asInteger.
	second := (aStream upToEnd) asInteger.
	
	^ self
		year: year
		month: month
		day: day
		hour: hour
		minute: minute
		second: second.! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:29'!
asDbxString
	| stream |
	stream := String new writeStream.
	self printDbxOn: stream.
	^ stream contents asDbxString! !

!DateAndTime methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:30'!
printDbxOn: aStream
	aStream
		nextPutAll: self year asString;
		nextPut: $-;
		nextPutAll: (self monthIndex asString padded: #left to: 2 with: $0);
		nextPut: $-;
		nextPutAll: (self dayOfMonth asString padded: #left to: 2 with: $0);
		nextPut: Character space;	
		nextPutAll: (self hour asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self minutes asString padded: #left to: 2 with: $0);
		nextPut: $:;
		nextPutAll: (self seconds asString padded: #left to: 2 with: $0).
! !

TestResource subclass: #FacilityTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!FacilityTestResource methodsFor: 'as yet unclassified' stamp: 'MMP 5/10/2009 17:14'!
setUp
	| selectedBackendIndex backendsToChose |	
	DBXBaseTest facility ifNotNil: [ ^ self ].
	backendsToChose := (DBXBackendFacility allSubclasses collect: [ :each | each name ] ) asOrderedCollection.
	selectedBackendIndex := (UIManager default chooseFrom: backendsToChose).
	DBXBaseTest facility: (Smalltalk at: (backendsToChose at: selectedBackendIndex)) facilityForTest.
! !

TestCase subclass: #DBXAutomaticEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding-Tests'!

TestCase subclass: #DBXBaseTest
	instanceVariableNames: 'facility connection connectionsToRelease'
	classVariableNames: 'Facility'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 8/5/2008 01:19'!
facility
	^ Facility! !

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 8/5/2008 01:19'!
facility: anObject
	Facility := anObject! !

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 5/18/2009 11:43'!
packageNamesUnderTest
	^ #('OpenDBX-Core')! !

!DBXBaseTest class methodsFor: 'accessing' stamp: 'MMP 5/10/2009 16:59'!
resources
	^Array with: FacilityTestResource! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/14/2009 22:17'!
addConnectionToRelease: aConnection
	"We add the connection so that it can be disconnected in the tearDown if there was a problem and wasnt disconnected."
	self connectionsToRelease add: aConnection! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2009 22:15'!
connectionsToRelease
	^ connectionsToRelease! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/14/2009 22:17'!
doConnect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.	
	conn connect.
	self addConnectionToRelease: conn.
	^conn! !

!DBXBaseTest methodsFor: 'helpers' stamp: 'MMP 5/15/2009 18:29'!
doConnectAndDisconnect
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/14/2009 22:17'!
doConnectAndOpen
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.
	conn connect.
	conn open.
	self addConnectionToRelease: conn.
	^ conn! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'MMP 5/22/2008 00:15'!
doDisconnect: aConnection 
	aConnection disconnect.! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 12/1/2008 00:09'!
dropScript: aConnection 
	"Here we catch the errors because the first time the tests are run, if you didn't create the tables by hand before, you will have an error here (because de table doesn't exist') and it won't continue to the create statements."
	
	self facility scriptsDrops 
		do: [:script | [ aConnection execute: script ] 
			on: DBXError
			do: [ :e |  Transcript show: e.  ].]
	! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility
	^ facility! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
facility: anObject
	facility := anObject! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:44'!
platform
	^ facility platform! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 17:53'!
platformCall: aSelector
	self platformCall: aSelector withArguments: #()! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 13:35'!
platformCall: aSelector with: anObject
	self platformCall: aSelector withArguments: (Array with: anObject)! !

!DBXBaseTest methodsFor: 'as yet unclassified' stamp: 'EL 8/19/2008 17:52'!
platformCall: aSelector withArguments: anArray
	| platformSelector |
	
	platformSelector := ('platform', 
		self facility platform backend capitalized, 
		aSelector capitalized) 
			asSymbol.
	(self class allSelectors includes: platformSelector)
		ifTrue: [ self perform: platformSelector withArguments: anArray ]! !

!DBXBaseTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 10/14/2009 22:47'!
releaseConnections
	self connectionsToRelease do:[ :aConn | aConn disconnect ].
	connectionsToRelease := nil.! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 9/17/2008 23:44'!
runDDLSetUpScript: aConnection 
	"The database structure is the same for all tests and most of them will
	need to have the structure generated. So, this method do exactly that,"
	"Here we catch the errors because the first time the tests are run, if
	you didn't create the tables by hand before, you will have an error
	here (because de table doesn't exist') and it won't continue to the create
	statements."
	self dropScript: aConnection.
	"Now I create all tables, fks, indexes, and so on."
	self facility scriptsDDL
		do: [:script | aConnection execute: script]! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 9/17/2008 23:18'!
runDDLTearDownScript: aConnection
	"Till now, nothing is done here"! !

!DBXBaseTest methodsFor: 'running' stamp: 'MMP 7/9/2008 02:20'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	self subclassResponsibility! !

!DBXBaseTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 10/14/2009 22:24'!
setUp
	"The setUp of this DBXBaseTest lets the database clear to tests. It runs the
	DDL and the common DML script for testing. Then each subclass should
	inserter, delete or whatever it need"
	super setUp.
	"this should be done from outside"
	connectionsToRelease := OrderedCollection new. 
	facility := self class facility.
	connection := self doConnectAndOpen.
	self runDDLSetUpScript: connection.
	self runDMLSetUpScript: connection.
	connection disconnect.
! !

!DBXBaseTest methodsFor: 'accessing' stamp: 'EL 7/1/2008 15:19'!
settings
	^ facility connectionSettings! !

!DBXBaseTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 10/14/2009 22:21'!
tearDown
	"This method run a DDL script to free results and close the connection used in the setUp and in here"
	super tearDown.
	connection := self doConnectAndOpen.
	self runDDLTearDownScript: connection.
	self doDisconnect: connection.
	self releaseConnections.
	connection := nil.! !

DBXBaseTest subclass: #DBXCompleteExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:13'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:'INSERT INTO student (id, name_surname, age) VALUES (2, ''Hernan Squeak'', 23) '.! !

!DBXCompleteExamplesTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/14/2009 22:17'!
testACompleteExample
	| conn connectionSettings result result2 |
	connectionSettings := self facility connectionSettings deepCopy.
	conn := DBXConnection platform: self platform deepCopy settings: connectionSettings.
	conn connect.
	conn open.
	self addConnectionToRelease: conn.
	result := conn execute: 'select * from signature'.
	DBXTranscript show: result.
	conn execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (59, ''TADP'', ''Tecnicas Av'', 1) '.
	conn execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'', 2) '.
	result := conn execute: 'select * from signature'.
	DBXTranscript show: result.
	result := conn execute: 'delete from signature where name = ''TADP'''.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from signature'.
	DBXTranscript show: result2.
	result := conn execute: 'update signature set observations = ''something'' where code = 60'.
	DBXTranscript show: result.
	result2 := conn execute: 'select * from signature'.
	DBXTranscript show: result2.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXConnectionBadSettingsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionBadSettingsTest methodsFor: 'tests' stamp: 'TestRunner 11/27/2009 16:38'!
doConnectAndOpenWithSettings: settings 
	"as doConnectAndOpen but allows us to specify different settings"
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: settings.
	self addConnectionToRelease: conn.		
	conn connect.
	conn open.
	^ conn	
	! !

!DBXConnectionBadSettingsTest methodsFor: 'tests' stamp: 'aaa 11/27/2009 16:35'!
doesCurrentBackendSupportsHosts 
	^ (self platform class = DBXSqlitePlatform) not! !

!DBXConnectionBadSettingsTest methodsFor: 'tests' stamp: 'StefanKapusniak 11/26/2009 19:54'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	

	
! !

!DBXConnectionBadSettingsTest methodsFor: 'tests' stamp: 'aaa 11/27/2009 16:36'!
testConnectBadHost
	"tests that we get an error when connecting to a host that doesn't exist"
	| settings |
	
	self doesCurrentBackendSupportsHosts ifFalse: [^ self].
	
	"we'll use the existing settings but change the host to some nonsense"
	settings := (self settings) copy.
	settings host: '@:[]sdafasgnimang&*k'.
	
	"try to connect and open, this should raise an error"
	self 
		should: [ self doConnectAndOpenWithSettings: settings ]
		raise: DBXError.! !

!DBXConnectionBadSettingsTest methodsFor: 'as yet unclassified' stamp: 'aaa 11/27/2009 16:35'!
testConnectBadPassword
	"tests that we get an error when connecting with an invalid password"
	| settings |
	
	self doesCurrentBackendSupportsHosts ifFalse: [^ self].
	
	"we'll use the existing settings but change the password to some nonsense"
	settings := (self settings) copy.
	settings userPassword: '@:[]sdafasgnimang&*k'.
	
	"try to connect and open, this should raise an error"
	self 
		should: [ self doConnectAndOpenWithSettings: settings ]
		raise: DBXError.
	
! !

!DBXConnectionBadSettingsTest methodsFor: 'tests' stamp: 'aaa 11/27/2009 16:35'!
testConnectBadUsername
	"tests that we get an error when connecting with a username that doesn't exist"
	| settings |
	
	self doesCurrentBackendSupportsHosts ifFalse: [^ self].
	
	"we'll use the existing settings but change the username to some nonsense"
	settings := (self settings) copy.
	settings userPassword: '@:[]sdafasgnimang&*k'.
	
	"try to connect and open, this should raise an error"
	self 
		should: [ self doConnectAndOpenWithSettings: settings ]
		raise: DBXError.
	
	
! !

DBXBaseTest subclass: #DBXConnectionCleanUpTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionCleanUpTest methodsFor: 'running' stamp: 'Mariano 3/27/2010 21:16'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:' INSERT INTO student (id, name_surname, age) VALUES (2, ''Hernan Squeak'', 23) '.
	! !

!DBXConnectionCleanUpTest methodsFor: 'tests' stamp: 'Mariano 3/27/2010 23:06'!
testNoTransactionNoCleanUp
	| conn select result |

	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	self deny: conn transactionOpened.
	self deny: conn result isNil.
	conn close.
	self assert: conn result isNil.
	self assert: conn result isNil.
	conn disconnect.

	! !

!DBXConnectionCleanUpTest methodsFor: 'tests' stamp: 'Mariano 3/28/2010 16:21'!
testWithTransactionWithCleanUp
	| conn select result |
	
	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	conn startTransaction.
	result := conn execute: select.
	self assert: conn transactionOpened.
	self deny: conn result isNil.
	conn cleanUp.
	self deny: conn transactionOpened.
	self assert: conn result isNil.
	conn disconnect.
	
	
	conn := self doConnectAndOpen.
	conn startTransaction.
	conn execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	self assert: conn transactionOpened.
	self deny: conn result isNil.
	conn cleanUp.
	self deny: conn transactionOpened.
	self assert: conn result isNil.
	result := conn execute: select.
	self assert: result rows isEmpty.
	! !

!DBXConnectionCleanUpTest methodsFor: 'tests' stamp: 'Mariano 3/28/2010 16:21'!
testWithTransactionWithoutCleanUp
	| conn select result |
	
	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	conn startTransaction.
	result := conn execute: select.
	self assert: conn transactionOpened.
	conn commit.
	self deny: conn transactionOpened.
	self deny: conn result isNil.
	conn close.
	self assert: conn result isNil.
	conn disconnect.
	
	
	conn := self doConnectAndOpen.
	conn startTransaction.
	result := conn execute: select.
	self assert: conn transactionOpened.
	self deny: conn result isNil.
	conn close.
	self deny: conn transactionOpened.
	self assert: conn result isNil.
	conn disconnect.
	

	
	! !

DBXBaseTest subclass: #DBXConnectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionTest methodsFor: 'running' stamp: 'MMP 6/17/2008 22:56'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 22:18'!
testCloseIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.
		
	self addConnectionToRelease: conn.
	
	"I have not do a open so this should rise an error"
	self 
		should: [ conn close ]
		raise: DBXError.
	"The same if i Try to do a query"
	self 
		should: [ conn execute: 'SELECT * from student where id = 1' ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn close.
	"now, as I have already done a close, this shoud rise an error"
	self 
		should: [ conn close ]
		raise: DBXError.
		
	conn disconnect.! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 22:18'!
testCloseWithoutOpen
	| conn |
	conn := DBXConnection 
				platform: self platform
				settings: self settings.
				
	self addConnectionToRelease: conn.		
	self should: [ conn close ] raise: DBXError.! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 6/1/2009 21:00'!
testConnectAndOpen
	| conn |
	conn := self doConnectAndOpen.
	conn disconnect.
	^ conn! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'Mariano 9/24/2009 21:54'!
testConnectIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"As I have already done a connect: it should raise an error"
	self 
		should: [ conn connect ]
		raise: DBXError.
		
	conn disconnect.! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/9/2008 02:39'!
testConnectOpenCloseOpen
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn close.
	self assert: conn isOpen not.
	conn open.
	self assert: conn isOpen.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'Mariano 3/27/2010 21:16'!
testConnectionWithCleanUp
	| conn  |
	conn := self doConnectAndOpen.
	conn cleanUp.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'Mariano 3/27/2010 21:15'!
testConnectionWithoutCleanUp
	| conn  |
	conn := self doConnectAndOpen.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 22:19'!
testDisconnectIncorrect
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.

	self addConnectionToRelease: conn.

	"I have not do a connect first so this shouldnt rise an error"
	self 
		shouldnt: [ conn disconnect ]
		raise: DBXError.
	conn := self doConnectAndOpen.
	"The first time should work well"
	conn disconnect.
	"now, as I have already done a disconnect, this shoudnt rise an error"
	self 
		shouldnt: [ conn disconnect ]
		raise: DBXError! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 22:19'!
testDisconnectWithoutConnect
	| conn | 
	conn := DBXConnection 
				platform: self platform
				settings: self settings.	
	
	self addConnectionToRelease: conn.	
	self shouldnt: [ conn disconnect ] raise: DBXError.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/9/2008 02:33'!
testManualDisconnection
	| conn conn2 |
	conn := self doConnect.
	conn disconnect.
	conn2 := self doConnectAndOpen.
	conn2 close.
	conn2 disconnect! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'Mariano 9/24/2009 21:56'!
testMultipleConnectionsPerThread
	| conn1 conn2 conn3 conn4 conn5|
	conn1 := self doConnectAndOpen.
	conn2 := self doConnectAndOpen.
	conn3 := self doConnectAndOpen.
	conn4 := self doConnectAndOpen.
	conn5 := self doConnectAndOpen.
	
	conn1 disconnect.
	conn2 disconnect.
	conn3 disconnect.
	conn4 disconnect.
	conn5 disconnect.
! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'Mariano 9/24/2009 21:56'!
testOpenIncorrect
	| conn |
	conn := self doConnectAndOpen.

	"as I have already open the connection this should rise a DBXError"
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError.
	self 
		should: [ conn open ]
		raise: DBXError.
		
	conn disconnect.! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 8/4/2008 23:57'!
testReOpen
	| conn connectionSettings |
	conn := self doConnectAndOpen.
	connectionSettings := self settings.
	"Actually I should test this with a different database, username and password. "
	conn reOpen: connectionSettings.
	conn close.
	conn disconnect.
	! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/8/2008 20:57'!
testShutDownAndStartUp
	| conn  |
	conn := self doConnectAndOpen.
	self assert: conn isOpen.
	conn shutDown.
	self assert: conn isOpen not.
	conn startUp.
	self assert: conn isOpen not.
! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 7/8/2008 20:59'!
testShutDownDisconnection
	| conn  |
	conn := self doConnectAndOpen.
	conn shutDown.
	self assert: conn isOpen not
! !

!DBXConnectionTest methodsFor: 'tests' stamp: 'MMP 4/25/2008 02:01'!
testShutDownManualDisconnection
	| conn  |
	conn := self doConnectAndDisconnect.
	self assert: conn isOpen not.
	conn shutDown.
	self assert: conn isOpen not
! !

DBXBaseTest subclass: #DBXDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/18/2008 19:17'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/29/2009 14:01'!
testGetColumnDescription
	| conn select result aRow |
	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	self
		should: [result description columnDescriptionAt: 0]
		raise: Error.
	self
		should: [result description columnDescriptionAt: 7]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 1]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 2]
		raise: Error.
	self assert: ((result description columnDescriptionAt: 1) name sameAs: 'code').
	aRow := result nextRow.
	self assert: aRow isNil.
	select := 'SELECT code FROM signature'.
	result := conn execute: select.
	self
		should: [result description columnDescriptionAt: 2]
		raise: Error.
	self
		shouldnt: [result description columnDescriptionAt: 1]
		raise: Error.
	self assert: ((result description columnDescriptionAt: 1) name sameAs: 'code').
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:16'!
testGetColumnDescriptionWithName
	| conn select result aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT code FROM signature'.
	result := conn execute: select.
	self
		should: [result columnDescriptionWithName: 'noexist']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'name']
		raise: DBXError.
	self
		shouldnt: [result columnDescriptionWithName: 'code']
		raise: DBXError.
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

!DBXDescriptionTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:16'!
testGetColumnDescriptionWithNameAlias
	| conn select result aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT code as aCode FROM signature'.
	result := conn execute: select.
	self
		should: [result columnDescriptionWithName: 'noexist']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'name']
		raise: DBXError.
	self
		should: [result columnDescriptionWithName: 'code']
		raise: DBXError.
	self
		shouldnt: [result columnDescriptionWithName: 'aCode']
		raise: DBXError.
	
	aRow := result nextRow.
	self assert: aRow isNil.
	conn close.
	conn disconnect! !

DBXBaseTest subclass: #DBXGarbageCollectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXGarbageCollectorTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 22:39'!
doConnectAndOpen
	"I override this method because I dont want the connection to be set in connectionsToRelease because in this case the GC wont remove them."
	| conn |
	conn := DBXConnection 
		platform: self platform
		settings: self settings.
	conn connect.
	conn open.
	^ conn! !

!DBXGarbageCollectorTest methodsFor: 'as yet unclassified' stamp: 'MMP 5/15/2009 18:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXGarbageCollectorTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 9/1/2010 20:12'!
testGCDisconnection
	"I have to call garbageCollect because maybe there are previous
	connections that are inconsistence or maybe they just have references
	and because of this the GC doesn't clean them. We assume there aren't
	created new connections at the same time of running the test from
	elsewhere"
	| connectionInstancesSizeBeforeTest weakRegistrySizeBeforeTest |
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
	weakRegistrySizeBeforeTest := SqueakDBXSmalltalkDialect current connectionsToGarbageCollect size.
	self doConnectAndOpen.
	1
		to: 3
		do: [:i | Smalltalk garbageCollect].
	
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.
	DBXPlatform isAutomaticConnectionReleaseOnGC 
		ifTrue: [
			self assert: SqueakDBXSmalltalkDialect current connectionsToGarbageCollect notEmpty.] 
		ifFalse: [
			self assert: SqueakDBXSmalltalkDialect current connectionsToGarbageCollect isEmpty.] 
	
	
! !

!DBXGarbageCollectorTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 22:38'!
testManualAndGCDisconnection

	"I have to call garbageCollect because maybe there are previous connections that are inconsistence or maybe they 	just have references and because of this the GC doesn't clean them. We assume there aren't created new connections 	at the same time of running the test from elsewhere "
	
	| connectionInstancesSizeBeforeTest |
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	connectionInstancesSizeBeforeTest := DBXConnection allInstances size.
		
	self doConnectAndDisconnect.
	1 to: 3 do: [ :i | Smalltalk garbageCollect ].
	self assert: DBXConnection allInstances size = connectionInstancesSizeBeforeTest.
! !

DBXBaseTest subclass: #DBXLargeObjectsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXLargeObjectsTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/12/2010 20:31'!
platformMysqlPrepareLargeObjects: aConnection

	| resultSet row |
	[ aConnection execute: 'DROP TABLE test_large_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_large_columns (
			large_clob 		TEXT,
			large_blob        BLOB)'.
	
	aConnection execute: '
          INSERT INTO test_large_columns (large_clob, large_blob)
		VALUES (''large_clob_data'', ''large_blob_data'')'.
		
	self shouldnt: [ resultSet := aConnection execute: 'SELECT * FROM test_large_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	
	self assert: (row valueNamed: 'large_clob') = 'large_clob_data'.
	self assert: (row valueNamed: 'large_blob') = 'large_blob_data' asByteArray .
! !

!DBXLargeObjectsTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/13/2010 20:10'!
platformOraclePrepareLargeObjects: aConnection

	| resultSet row |
	[ aConnection execute: 'DROP TABLE test_large_columns' ]
	on: Error do: [ :e| "table exists" ].
	self halt.
	aConnection execute: '
		CREATE TABLE test_large_columns (
			large_clob 		CLOB,
			large_nclob       NCLOB,
			large_blob        BLOB)'.
	
	aConnection execute: '
          INSERT INTO test_large_columns (large_clob, large_nclob, large_blob)
		VALUES (''large_clob_data'' , ''large_nclob_data'' , EMPTY_BLOB() )'.
		
	self shouldnt: [ resultSet := aConnection execute: 'SELECT * FROM test_large_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	
	self assert: (row valueNamed: 'large_clob') = 'large_clob_data'.
	self assert: (row valueNamed: 'large_nclob') = 'large_nclob_data' .
! !

!DBXLargeObjectsTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/12/2010 18:36'!
platformPgsqlPrepareLargeObjects: aConnection

	| resultSet row |
	[ aConnection execute: 'DROP TABLE test_large_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_large_columns (
			large_clob 		TEXT)'.
	
	aConnection execute: '
          INSERT INTO test_large_columns (large_clob)
		VALUES (''large_clob_data'')'.
		
	self shouldnt: [ resultSet := aConnection execute: 'SELECT * FROM test_large_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	
	self assert: (row valueNamed: 'large_clob') = 'large_clob_data'.
! !

!DBXLargeObjectsTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/13/2010 18:19'!
platformSqlite3PrepareLargeObjects: aConnection

	| resultSet row |
	[ aConnection execute: 'DROP TABLE test_large_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_large_columns (
			large_clob 		CLOB,
			large_blob        BLOB)'.
	
	aConnection execute: '
          INSERT INTO test_large_columns (large_clob, large_blob)
		VALUES (''large_clob_data'', ''large_blob_data'')'.
		
	self shouldnt: [ resultSet := aConnection execute: 'SELECT * FROM test_large_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	
	self assert: (row valueNamed: 'large_clob') = 'large_clob_data'.
	self assert: (row valueNamed: 'large_blob') = 'large_blob_data' asByteArray .
! !

!DBXLargeObjectsTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/12/2010 17:48'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXLargeObjectsTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/12/2010 20:31'!
testReadLargeObjects
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [ self platformCall: #prepareLargeObjects: with: conn ]
		raise: DBXError.
		
"	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_datetime_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	
"
	conn disconnect.
	! !

DBXBaseTest subclass: #DBXMultiStatementResultSetIteratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMultiStatementResultSetIteratorTest methodsFor: 'as yet unclassified' stamp: 'HMC 9/1/2009 00:08'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:' INSERT INTO student (id, name_surname, age) VALUES (2, ''Hernan Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (3, ''German Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	
	"aConnection execute: 'INSERT INTO course(id_course, id_student, signature_code, starting_hour) VALUES (5, 5, 5, null);'."! !

!DBXMultiStatementResultSetIteratorTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:21'!
testIsOpen
	| conn insert iterator supportsMultipleStatements select aResult insert2 select2 iterator2 |
	
	"When the connection is disconected, the resultset must be closed"
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (11, ''Something'', ''Nothing'', 2)'.
	select := 'SELECT * FROM student'.
	iterator := conn executeMultiStatement: (insert, '; ', select).
	self assert: iterator isOpen.
	self assert: iterator next notNil.
	self assert: iterator isOpen.
	[ aResult := iterator next ] doWhileTrue: [ aResult notNil ].
	self assert: iterator isOpen.
	"Even after retrieving all results, the MultiStatementResultSet doesn't update its state to closed"
	conn disconnect.
	self deny: iterator isOpen.
	
	
	"When the connection is closed, the MultiStatementResultSet must be closed"
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	insert2 := 'INSERT INTO signature(code, name, observations, id_student) VALUES (12, ''Something'', ''Nothing'', 2)'.
	select2 := 'SELECT * FROM student'.
	iterator := conn executeMultiStatement: (insert2, '; ', select2).
	self assert: iterator isOpen.
	self assert: iterator next notNil.
	self assert: iterator isOpen.
	[ aResult := iterator next ] doWhileTrue: [ aResult notNil ].
	self assert: iterator isOpen.
	"Even after retrieving all results, the MultiStatementResultSet doesn't update its state to closed"
	conn close.
	self deny: iterator isOpen.
	conn disconnect.
	self deny: iterator isOpen.

	"When a new query is executed the previous query in the same conncion, must be closed."
		"When the connection is closed, the MultiStatementResultSet must be closed"
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	iterator := conn executeMultiStatement: 'INSERT INTO signature(code, name, observations, id_student) VALUES (14, ''Something'', ''Nothing'', 2); SELECT * FROM student'.
	self assert: iterator isOpen.
	self assert: iterator next notNil.
	self assert: iterator isOpen.
	[ aResult := iterator next ] doWhileTrue: [ aResult notNil ].
	self assert: iterator isOpen.
	"Even after retrieving all results, the MultiStatementResultSet doesn't update its state to closed"
	iterator2 := conn executeMultiStatement: 'INSERT INTO signature(code, name, observations, id_student) VALUES (15, ''Something'', ''Nothing'', 2); SELECT * FROM student'.
	self deny: iterator isOpen.
	self assert: iterator2 isOpen.
	conn close.
	self deny: iterator2 isOpen.
	conn disconnect.
	self deny: iterator2 isOpen.! !

DBXBaseTest subclass: #DBXMultiStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/16/2009 22:53'!
expectedFailures
	^ (DBXBaseTest facility class = DBXMsSQLFacility) 
		ifTrue: [ #(testSQLThenDML testSQLWithoutIteratingAllRowsInAResult)]
		ifFalse: [ #()].
	
	! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:22'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:' INSERT INTO student (id, name_surname, age) VALUES (2, ''Hernan Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (3, ''German Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	
	aConnection execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (59, ''TADP'', ''Tecnicas Av'', 1) '.
	aConnection execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'', 2) '.
	
	"aConnection execute: 'INSERT INTO course(id_course, id_student, signature_code, starting_hour)  VALUES (5, 5, 5, null);'."! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'Mariano 9/24/2009 21:58'!
testDMLThenSQL
	| conn insert select iterator dmlResult sqlResult aRow supportsMultipleStatements |
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (11, ''Something'', ''Nothing'', 2)'.
	select := 'SELECT * FROM student'.
	
	iterator := conn executeMultiStatement: (insert, '; ', select).
	
	dmlResult := iterator next.
	self assert: dmlResult class = DBXResult.
	self assert: dmlResult rowsAffected = 1.

	sqlResult := iterator next.
	self assert: sqlResult class = DBXResultSet.
	self shouldnt: [ sqlResult nextRow ] raise: DBXError.
	[ aRow := sqlResult nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	
	self assert: iterator next isNil.
	
	conn close.
	conn disconnect.
! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:23'!
testMultiStatementTranscript
	| conn insert select iterator supportsMultipleStatements |
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (11, ''Something'', ''Nothing'', 2)'.
	select := 'SELECT * FROM student'.
	
	iterator := conn executeMultiStatement: (insert, '; ', select).
	DBXTranscript show: iterator.	

	conn close.
	conn disconnect.! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:24'!
testSQLThenDML
	| conn insert select iterator dmlResult sqlResult aRow supportsMultipleStatements |
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (11, ''Something'', ''Nothing'', 2)'.
	select := 'SELECT * FROM student'.
	
	iterator := conn executeMultiStatement: (select, '; ', insert).

	sqlResult := iterator next.
	self assert: sqlResult class = DBXResultSet.
	self shouldnt: [ sqlResult nextRow ] raise: DBXError.
	[ aRow := sqlResult nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	
	dmlResult := iterator next.
	self assert: dmlResult class = DBXResult.
	self assert: dmlResult rowsAffected = 1.

	self assert: iterator next isNil.

	conn close.
	conn disconnect.
! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:24'!
testSQLThenSQL
	| conn select iterator sqlResult supportsMultipleStatements select2 |
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	
	select := 'SELECT code FROM signature'.
	select2 := 'SELECT id, name_surname FROM student'.
	
	iterator := conn executeMultiStatement: (select, '; ', select2).

	sqlResult := iterator next.
	self assert: sqlResult class = DBXResultSet.
	self assert: sqlResult columnCount = 1.
	DBXTranscript show: sqlResult.
	
	sqlResult := iterator next.
	self assert: sqlResult class = DBXResultSet.
	self assert: sqlResult columnCount = 2.
	DBXTranscript show: sqlResult.

	self assert: iterator next isNil.

	conn close.
	conn disconnect.! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:25'!
testSQLWithoutIteratingAllResults
	| conn insert select iterator sqlResult aRow supportsMultipleStatements iterator2 sqlResult2 |
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (11, ''Something'', ''Nothing'', 2)'.
	select := 'SELECT * FROM student'.
	
	iterator := conn executeMultiStatement: (select, '; ', insert).

	sqlResult := iterator next.
	self assert: sqlResult class = DBXResultSet.
	self shouldnt: [ sqlResult nextRow ] raise: DBXError.
	[ aRow := sqlResult nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	
	"I don't call iterator next for the following resultset"
	iterator2 := conn executeMultiStatement: ('SELECT * FROM student; INSERT INTO signature(code, name, observations, id_student) VALUES (19, ''Something'', ''Nothing'', 2)').
	sqlResult2 := iterator2 next.
	self assert: sqlResult2 class = DBXResultSet.
	self shouldnt: [ sqlResult2 nextRow ] raise: DBXError.
	[ aRow := sqlResult2 nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	
	conn close.
	conn disconnect.
! !

!DBXMultiStatementTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:26'!
testSQLWithoutIteratingAllRowsInAResult
	| conn insert select iterator dmlResult supportsMultipleStatements |
	conn := self doConnect.
	supportsMultipleStatements := conn enableMultipleStatements.
	conn open.
	
	supportsMultipleStatements ifFalse: [
		conn disconnect.
		^ self].
	
	
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (11, ''Something'', ''Nothing'', 2)'.
	select := 'SELECT * FROM student'.
	
	iterator := conn executeMultiStatement: (select, '; ', insert).

	iterator next.
	"I don't iterate all rows"
	
	dmlResult := iterator next.
	self assert: dmlResult class = DBXResult.
	self assert: dmlResult rowsAffected = 1.

	conn close.
	conn disconnect.
! !

DBXBaseTest subclass: #DBXOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:26'!
executeEncryptionWithOption: anEncrytionValue 
	| conn result |
	conn := self doConnect.
	result := conn enableEncryption: anEncrytionValue.
	conn open.
	result
		ifTrue: [ Transcript show: 'Encryption supported' ; cr.
				self shouldnt: [ conn execute: 'select code from signature' ] raise: Error .
				].
	result
		ifFalse: [ Transcript show: 'Encryption not supported' ; cr.
				self shouldnt: [ conn execute: 'select code from signature' ] raise: Error .
				].	
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:27'!
insertRows:  aNumberOfRows
	| conn |

	Transcript show: 'Inserting ', aNumberOfRows asString, ' rows'; cr.
	conn := self doConnectAndOpen.
	conn startTransaction.
	1
		to: aNumberOfRows
		do: [:i | conn
				execute: ('INSERT INTO student (id, name_surname, age) VALUES ( {1} ,''Esteban
	Squeak'', 42)' format: (OrderedCollection new add: i asInteger asDbxString;
							 yourself))].
	conn commit.
	conn disconnect.
	Transcript show: aNumberOfRows asString, ' rows were inserted'; cr.	! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2008 02:16'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:27'!
selectRowsWithPageSize: aPageSize onConnection: aConnection 
	| resultQuery timeBefore timeAfter querySettings |
	
	querySettings := DBXQuerySettings pageSize: aPageSize timeout: DBXQuerySettings defaultTimeout.
	
	timeBefore := Time current asSeconds.
	Transcript show: 'PagedResults supported. Test with page size ' , aPageSize asString;
		 cr.
	
	resultQuery := aConnection execute: 'select * from student' querySettings: querySettings.
		
		
	"self
		shouldnt: [resultQuery := aConnection execute: 'select * from student' querySettings: querySettings]
		raise: Error."
		
		
	resultQuery
		rowsDo: [:row | row].
	timeAfter := Time current asSeconds.
	Transcript show: 'Time consumed: ' , (timeAfter - timeBefore) asString, ' seconds';
		 cr! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:27'!
testCompression
	| conn result |
	conn := self doConnect.
	result := conn enableCompression.
	conn open.
	result ifTrue: 
		[ Transcript
			show: 'Compression supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from student' ]
			raise: Error ].
	result ifFalse: 
		[ Transcript
			show: 'Compression doesnt supported';
			cr.
		self 
			shouldnt: [ conn execute: 'select * from student' ]
			raise: Error ].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 16:53'!
testEncryption
	"self executeEncryptionWithOption: DBXEncryptionValues never.
	self executeEncryptionWithOption: DBXEncryptionValues try.
"
	self executeEncryptionWithOption: DBXEncryptionValues always.
	"self executeEncryptionWithOption: '-1'.
	self
		should: [self executeEncryptionWithOption: '-1']
		raise: DBXError. 
	
self executeEncryptionWithOption: '3'.

	self should: [self executeEncryptionWithOption: '3']
		raise: DBXError Unmatched comment quote ->"! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/18/2008 01:57'!
testGetOption
	| conn isSupported |
	conn := self doConnect.
	isSupported := conn isOptionSupportedByPlattform: DBXSpecialOptions multipleStatements.
	conn open.
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:29'!
testMultipleStatments
	| conn result iterator iterator2 |
	"In ODBC case, as you cannot know trought ODBC if the current backends supports or not certain option, this 	features is disable. But, if you are using a backend that support its, the multistatement will work ok. 	Suppose 	you are using ODBC with a PostgeSQL server. ODBC doesn't	support this feature, but PostgreSQL will. 	So, If you 	actually use multistatement, it will work. Because of this, this test is disable for ODBC"
	(self platform class = DBXOdbcPlatform) ifTrue: [ ^ self ].
	conn := self doConnect.
	result := conn enableMultipleStatements.
	conn open.
	
	conn execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	conn execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (59, ''TADP'', ''Tecnicas Av'', 5) '.
	
	result ifTrue: 
		[ Transcript show: 'MultipleStatments supported'; cr.
		self 
			shouldnt: 
				[ iterator := conn executeMultiStatement: 'select id from student; select code, name from signature'.
				DBXTranscript show: iterator. ]
			raise: DBXError.
		 ].
	
	result ifFalse: 
		[ Transcript show: 'MultipleStatments doesnt supported'; cr.	
		self 
			should: 
				[ iterator2 := conn executeMultiStatement: 'select id from student; select code, name from signature'.
				DBXTranscript show: iterator2. ]
			raise: DBXError.	
				
		].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:30'!
testMultipleStatmentsDMLAndSQL
	| conn result iterator iterator2 |
	"In ODBC case, as you cannot know trought ODBC if the current backends supports or not certain option, this 	features is disable. But, if you are using a backend that support its, the multistatement will work ok. 	Suppose 	you are using ODBC with a PostgeSQL server. ODBC doesn't	support this feature, but PostgreSQL will. 	So, If you 	actually use multistatement, it will work. Because of this, this test is disable for ODBC"
	(self platform class = DBXOdbcPlatform) ifTrue: [ ^ self ].
	conn := self doConnect.
	result := conn enableMultipleStatements.
	conn open.
	
	conn execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	conn execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (59, ''TADP'', ''Tecnicas Av'', 5) '.
	
	result ifTrue: 
		[ Transcript
			show: 'MultipleStatments supported';
			cr.
		self 
			shouldnt: 
				[ iterator := conn executeMultiStatement: 'select id from student; update student set age = ''23'' '.
				DBXTranscript show: iterator.
				 ]
			raise: DBXError.

	].
	
	
	result ifFalse: 
		[ Transcript
			show: 'MultipleStatments doesnt supported';
			cr.
			
			self 
			should: 
				[ iterator2 := conn executeMultiStatement: 'select id from student; update student set age = ''23'' '.
				DBXTranscript show: iterator2. ]
			raise: DBXError.

		].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'MMP 8/24/2008 23:55'!
testPagedResults
	| conn result rows |
	rows := 5000.
	self insertRows: rows.
	conn := self doConnect.
	result := conn enablePagedResults.
	conn open.
	result
		ifTrue: [self selectRowsWithPageSize: 0 onConnection: conn.
			self selectRowsWithPageSize: 1 onConnection: conn.
			self selectRowsWithPageSize: rows onConnection: conn.
			self selectRowsWithPageSize: rows / 10 onConnection: conn.
			self selectRowsWithPageSize: rows / 100 onConnection: conn].
	conn close.
	conn disconnect.
	conn := nil! !

!DBXOptionsTest methodsFor: 'as yet unclassified' stamp: 'Mariano 9/24/2009 22:00'!
testScpeialModes
	| conn result update |
	self platform class = DBXMySQLPlatform ifFalse: [ ^ nil ].
	conn := self doConnect.
	result := conn enableSpecialModes: 'ANSI,TRADITIONAL'.
	conn open.
	conn execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	result ifTrue: 
		[ Transcript
			show: 'ScpecialMySQLModes supported';
			cr.
		update := 'update student set age = ''should be numeric'' '.
		self 
			should: [ conn execute: update ]
			raise: DBXError ].
	result ifFalse: 
		[ Transcript
			show: 'ScpecialMySQLModes supported';
			cr.
		update := 'update student set age = ''should be numeric'' '.
		self 
			shouldnt: [ conn execute: update ]
			raise: DBXError ].
	conn close.
	conn disconnect.
	conn := self doConnectAndOpen.
	conn execute: 'INSERT INTO student (id, name_surname, age) VALUES (2, ''Mariano Squeak'', 23) '.
	update := 'update student set age = ''should be numeric'' '.
		self 
			shouldnt: [ conn execute: update ]
			raise: DBXError.
	conn disconnect.
	conn := nil. 
! !

DBXBaseTest subclass: #DBXQueryBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryBaseTest methodsFor: 'running' stamp: 'HMC 8/25/2009 00:33'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:' INSERT INTO student (id, name_surname, age) VALUES (2, ''Hernan Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (3, ''German Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	
	aConnection execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (59, ''TADP'', ''Tecnicas Av'', 1) '.
	aConnection execute: 'INSERT INTO signature(code, name, observations, id_student) VALUES (60, ''APIT'', ''ARQUITECTURA DE PROYECTOS DE IT'', 2) '.
	
	"aConnection execute: 'INSERT INTO course(id_course, id_student, signature_code, styarting_hour) VALUES (5, 5, 5, null);'."! !

DBXQueryBaseTest subclass: #DBXQueryDDLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryDDLTest class methodsFor: '*OpenDBX-Core' stamp: 'MMP 8/9/2008 19:27'!
fromDbxString: aString 
	self shouldBeImplemented! !

!DBXQueryDDLTest methodsFor: 'running' stamp: 'MMP 8/9/2008 19:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	! !

!DBXQueryDDLTest methodsFor: 'as yet unclassified' stamp: 'Mariano 9/24/2009 22:01'!
testExecuteDDLScript
	| conn |
	conn := self doConnectAndOpen.
	conn executeDDLScript: 'DROP TABLE course;
		DROP TABLE signature;
		DROP TABLE student'.
		
	conn disconnect.
		
	"scriptsDDL := self facility scriptsDDL.
	fullScript := String new writeStream.
	scriptsDDL do: [ :script | fullScript nextPutAll: script ]."
	
! !

DBXQueryBaseTest subclass: #DBXQueryDMLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'Mariano 9/24/2009 22:03'!
testDelete
	| conn delete result |
	conn := self doConnectAndOpen.

	"SQLite implements the command 'DELETE FROM table' without a WHERE clause by dropping and recreating the 	table. (This is much faster than going through and deleting individual elements from the table.) Because of this 	optimization, the deletions in 'DELETE FROM table' are not row changes and will not be counted by the 	sqlite3_changes() or sqlite3_total_changes() functions, regardless of the number of elements that were originally 	in the table. To get an accurate count of the number of rows deleted, use 'DELETE FROM table WHERE 1' instead."


	delete := 'delete from signature WHERE 1=1'.
	result := conn execute: delete.
	self assert: result rowsAffected isZero not.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'Mariano 9/24/2009 22:03'!
testDeleteFollowedByAnotherDelete
	| conn aResult anotherResult aDelete anotherDelete |
	conn := self doConnectAndOpen.
	aDelete  := 'delete from signature where code = 59'.
	anotherDelete  := 'delete from signature where code = 60'.
	aResult := conn execute: aDelete.
	self shouldnt: [ anotherResult := conn execute: anotherDelete ] raise: DBXError.
	self assert: aResult rowsAffected isZero not.
	self assert: anotherResult rowsAffected isZero not.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'Mariano 9/24/2009 22:04'!
testDeleteIsClosedAfterExecute
	| conn delete |
	conn := self doConnectAndOpen.
	delete := 'delete from signature'.
	conn execute: delete.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'Mariano 9/24/2009 22:04'!
testDeleteWithBadData
	| conn delete |
	conn := self doConnectAndOpen.
	delete := 'delete from student where id = should be numeric'.
	self should: [ conn execute: delete  ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'deleteTests' stamp: 'Mariano 9/24/2009 22:04'!
testDuplicateDelete
	| conn delete |
	conn := self doConnectAndOpen.
	delete := 'delete from signature'.
	conn execute: delete.
	self shouldnt: [ conn execute: delete ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'Mariano 9/24/2009 22:05'!
testDuplicateInsert
	| conn insert |
	
	"SQLite client library has a problem with duplicated inserts. So, we skip that tests for sqlite"
	(self platform class = DBXSqlitePlatform) ifTrue: [^ nil]. 
	
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	conn execute: insert.
	self should: [ conn execute: insert ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'Mariano 9/24/2009 22:05'!
testDuplicateUpdate
	| conn update |
	conn := self doConnectAndOpen.
	update := 'update student set age = ''25'' '.
	conn execute: update.
	self shouldnt: [ conn execute: update ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'Mariano 9/24/2009 22:05'!
testInsert
	| conn result insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	result := conn execute: insert.
	self assert: result rowsAffected isZero not.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'Mariano 9/24/2009 22:05'!
testInsertFollowedByAnotherInsert
	| conn aResult anotherResult AnInsert anotherInsert |
	conn := self doConnectAndOpen.
	AnInsert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	anotherInsert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (56,''TADP2'',''Nothing'', 2)'.
	aResult := conn execute: AnInsert.
	self shouldnt: [ anotherResult := conn execute: anotherInsert ] raise: DBXError.
	self assert: aResult rowsAffected isZero not.
	self assert: anotherResult rowsAffected isZero not.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'Mariano 9/24/2009 22:05'!
testInsertIsClosedAfterExecute
	| conn insert |
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	conn execute: insert.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'insertTests' stamp: 'Mariano 9/24/2009 22:06'!
testInsertWithBadData
	| conn insert |
	
	"SQLite does not enforce data type constraints. Any data can be inserted into any column. You can put arbitrary length strings into integer columns, floating point numbers in boolean columns, or dates in character columns. The datatype you assign to a column in the CREATE TABLE command does not restrict what data can be put into that column. Every column is able to hold an arbitrary length string. (There is one exception: Columns of type INTEGER PRIMARY KEY may only hold a 64-bit signed integer. An error will result if you try to put anything other than an integer into an INTEGER PRIMARY KEY column.)
    But SQLite does use the declared type of a column as a hint that you prefer values in that format. So, for example, if a column is of type INTEGER and you try to insert a string into that column, SQLite will attempt to convert the string into an integer. If it can, it inserts the integer instead. If not, it inserts the string. This feature is sometimes call type or column affinity. "
	(self platform class = DBXSqlitePlatform ) ifTrue: [ ^ self ].
	
	
	conn := self doConnectAndOpen.
	insert := 'INSERT INTO signature(code, name, observations) VALUES ("should be numeric", 1, 1) '.
	self should: [ conn execute: insert  ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'Mariano 9/24/2009 22:06'!
testMultipleUpdate
	| conn update |
	conn := self doConnectAndOpen.
	update := 'update student set age = ''25'' '.
	conn execute: update.
	conn execute: update.
	conn execute: update.
	conn execute: update.
	conn execute: update.
	conn execute: update.
	conn execute: update.
	
	conn disconnect.
! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'MMP 1/21/2009 01:06'!
testTimeout
"	| conn |
	conn := self doConnectAndOpen.
	
	MessageTally time: [
	10000 timesRepeat: [ 
		conn execute: 
			'INSERT INTO tiny_benchmark_insert
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].].
	
	
	self break.
	Transcript show: 'tiempo final: ',
	(MessageTally time: [
	(conn execute: 'SELECT * FROM tiny_benchmark_insert')
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ]  ].
	]) asString.

	self break."! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'Mariano 9/24/2009 22:06'!
testUpdate
	| conn result update |
	conn := self doConnectAndOpen.
	update := 'update student set age = ''25'' '.
	result := conn execute: update.
	self assert: result rowsAffected isZero not.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'Mariano 9/24/2009 22:06'!
testUpdateFollowedByAnotherUpdate
	| conn aResult anotherResult anUpdate anotherUpdate |
	conn := self doConnectAndOpen.
	anUpdate := 'update student set age = ''25'' '.
	anotherUpdate := 'update student set age = ''23'' '.
	aResult := conn execute: anUpdate.
	self shouldnt: [ anotherResult := conn execute: anotherUpdate ] raise: DBXError.
	self assert: aResult rowsAffected isZero not.
	self assert: anotherResult rowsAffected isZero not.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'Mariano 9/24/2009 22:06'!
testUpdateIsClosedAfterExecute
	| conn update |
	conn := self doConnectAndOpen.
	update := 'update student set age = ''25'' '.
	conn execute: update.
	
	conn disconnect.! !

!DBXQueryDMLTest methodsFor: 'updateTests' stamp: 'Mariano 9/24/2009 22:07'!
testUpdateWithBadData
	| conn update |	
	
	"SQLite does not enforce data type constraints. Any data can be inserted into any column. You can put arbitrary length strings into integer columns, floating point numbers in boolean columns, or dates in character columns. The datatype you assign to a column in the CREATE TABLE command does not restrict what data can be put into that column. Every column is able to hold an arbitrary length string. (There is one exception: Columns of type INTEGER PRIMARY KEY may only hold a 64-bit signed integer. An error will result if you try to put anything other than an integer into an INTEGER PRIMARY KEY column.)
    But SQLite does use the declared type of a column as a hint that you prefer values in that format. So, for example, if a column is of type INTEGER and you try to insert a string into that column, SQLite will attempt to convert the string into an integer. If it can, it inserts the integer instead. If not, it inserts the string. This feature is sometimes call type or column affinity. "
	(self platform class = DBXSqlitePlatform ) ifTrue: [ ^ self ].
	

	conn := self doConnect.
	self flag: #todo.
	"Only for MySQL, I need to enable ansi and traditional mode in order to get an error in this query. We need the tests refactor for special backends"
	(self platform class = DBXMySQLPlatform) ifTrue: [ conn enableSpecialModes: 'ANSI,TRADITIONAL'. ].
	
	
	
	
	conn open.
	update := 'update student set age = ''should be numeric'' '.
	self
		should: [conn execute: update]
		raise: DBXError.
		
	conn disconnect.! !

DBXQueryBaseTest subclass: #DBXQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:36'!
testCloseBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn close.
	select := 'SELECT * FROM signature'.
	self
		should: [conn execute: select]
		raise: DBXError.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:37'!
testCloseResultsByClosingConnection
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature'.
	result := conn execute: select.
	conn disconnect.
	self deny: result isOpen.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testCorrectResult
	| conn select result aRow delete update insert drop |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM course'.
	result := conn execute: select.
	self
		should: [result class = DBXResultSet].
	aRow := result nextRow.
	self assert: aRow isNil.
	delete := 'delete from course'.
	result := conn execute: delete.
	self
		should: [result class = DBXResult].
	update := 'update signature set name = ''XXX'' '.
	result := conn execute: update.
	self
		should: [result class = DBXResult].
	insert := 'INSERT INTO signature(code, name, observations, id_student) VALUES (55, ''TADP'', ''Nothing'', 1) '.
	result := conn execute: insert.
	self
		should: [result class = DBXResult].
	drop := 'drop table course'.
	result := conn execute: drop.
	self
		should: [result class = DBXResult].
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testDisconnectBeforeQuery
	| conn select |
	conn := self doConnectAndOpen.
	conn disconnect.
	select := 'SELECT * FROM signature'.
	self
		should: [conn execute: select]
		raise: DBXError.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testEmptyResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature where code = 99999'.
	result := conn execute: select.	
	aRow := result nextRow.	
	self assert: aRow isNil.
	result releaseResult.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testEmptyResultSetRows
	| conn result select rows |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM course'.
	result := conn execute: select.	
	rows := result nextRow.	
	self assert: rows isNil.
	result releaseResult.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testHasRowsEmptyResultSet
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature where code = 99999'.
	result := conn execute: select.	
	result nextRow.	
	result releaseResult.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testIterateResultSet
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM student'.
	result := conn execute: select.
	[ aRow := result nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: aRow isNil.
	result releaseResult.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:38'!
testMultipleSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM signature'.
	result := conn execute: select.
	result releaseResult.
	result := conn execute: select.
	result releaseResult.
	result := conn execute: select.
	DBXTranscript show: result.
	result releaseResult.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result releaseResult.
	result := conn execute: select.
	result releaseResult.
	result := conn execute: select.
	result releaseResult.
	result releaseResult.
	result := conn execute: select.
	result := conn execute: select.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	DBXTranscript show: result.
	result := conn execute: select.
	result := conn execute: select.
	conn close.
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:39'!
testNextRowAfterCloseResultSet
	| conn select result |

	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn close.
	self should: [ result nextRow ] raise: DBXError.
	conn disconnect.
	
	
	
	! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:39'!
testNextRowAfterDisconnect
	| conn select result |
	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	"I have closed de connection, so this should rise an error"
	self
		should: [result nextRow]
		raise: DBXError! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:39'!
testNextRowAfterFinalizeResultSet
	| conn select result |

	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	result releaseResult.
	
	"I have closed de resultSet, so this should rise an error"	
	self should: [ result nextRow ] raise: DBXError.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 00:07'!
testOrderBy
	| conn result select aRow|
	
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM student'.
	result := conn execute: select.
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Mariano Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Hernan Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'German Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Alejandro Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Esteban Squeak' asString).


	select:= 'SELECT * FROM student order by name_surname'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Alejandro Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Esteban Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'German Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Hernan Squeak' asString).
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'name_surname') = 'Mariano Squeak' asString).
	
	self assert: result nextRow isNil.

	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:40'!
testPrintARow
	| conn aResult select aRow stream |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM student'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	stream := String new writeStream.
	aRow values
	do: [:each | stream nextPutAll: each asString]
	separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
	cr.	
		
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:40'!
testQueryAfterQueryWithPartialResutlIteration
	| conn aResult select aRow |
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM student'.
	aResult := conn execute: select.
	aRow := aResult nextRow.	
	aRow := aResult nextRow.
	
	select := 'SELECT * FROM signature'.
	aResult := conn execute: select.
	aRow := aResult nextRow.
	aRow := aResult nextRow.

	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:41'!
testQueryAfterQueryWithPartialResutlIterationWithFinalize
	| conn aResult select|
	conn := self doConnectAndOpen.

	select := 'SELECT * FROM student'.
	aResult := conn execute: select.
	aResult nextRow.	
	aResult nextRow.

	aResult releaseResult.
	select := 'SELECT * FROM signature'.
	aResult := conn execute: select.
	aResult nextRow.	
	aResult nextRow.
	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 00:13'!
testQueryAfterQueryWithTotalResutlIteration
	| conn aResult select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM student'.
	aResult := conn execute: select.
	aResult
		rowsDo: [:row | Transcript
				show: (row valueNamed: 'age') asString].
	select := 'SELECT * FROM signature'.
	aResult := conn execute: select.
	aResult
		rowsDo: [:row | Transcript
				show: (row valueNamed: 'code') asString].
	conn disconnect! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:41'!
testQueryFollowedByAnotherQuery
	| conn aRresult select |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM course'.
	aRresult := conn execute: select.
	self
		shouldnt: [conn execute: select]
		raise: DBXError.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:41'!
testReleaseAllQueryResultsAfterDisconnectResultSet
	| conn select result |

	select := 'SELECT * FROM signature'.
	conn := self doConnectAndOpen.
	result := conn execute: select.
	conn disconnect.
	self shouldnt: [ result releaseResult ] raise: DBXError.
	
	! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:41'!
testReleaseAllQueryResultsTwiceResultSet
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature'.
	result := conn execute: select.
	result releaseResult .
	self shouldnt: [ result releaseResult ] raise: DBXError.	
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:42'!
testResultSetNextRow
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature'.
	result := conn execute: select.
	self shouldnt: [ result nextRow ] raise: DBXError.
	result releaseResult.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/12/2009 14:36'!
testResultSetWithData
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM student where id = 1'.
	result:= conn execute: select.
	aRow := result nextRow.
	self assert: aRow notNil.
	[ aRow notNil ] whileTrue: [ aRow := result nextRow ].
	result releaseResult.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:42'!
testSelect
	| conn result select |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature'.
	result := conn execute: select.	
	self shouldnt: [ result nextRow ] raise: DBXError.
	result releaseResult.
	conn disconnect.
	
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM signature'.
	result := conn execute: select.	
	DBXTranscript show: result.
	self assert: result nextRow isNil.
	result releaseResult.
	conn disconnect.! !

!DBXQueryTest methodsFor: 'tests' stamp: 'HMC 8/10/2008 17:07'!
testWrongSQL
	| conn select |
	conn := self doConnectAndOpen.
	select:= 'THIS IS NOT VALID SQL'.
	self should: [ conn execute: select. ] raise: DBXError.
	conn disconnect.! !

DBXQueryBaseTest subclass: #DBXRowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:43'!
testRawValueAt
	| conn result select aRow value |
	conn := self doConnectAndOpen.
	select := 'SELECT * FROM student where id = 1'.
	result := conn execute: select.
	aRow := result nextRow.
	self
		shouldnt: [value := aRow rawValueAt: 1]
		raise: DBXError.
	self assert: value class = ByteString.
	Transcript show: 'raw value: ' , value asString.
	self
		shouldnt: [value := aRow valueAt: 1]
		raise: DBXError.
	self assert: value class = SmallInteger.
	Transcript show: 'raw value: ' , value asString.
	result releaseResult.
	conn disconnect! !

!DBXRowTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 00:08'!
testRawValueNamed
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM student where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: ((aRow rawValueNamed: 'id') = 1 asString).
	result releaseResult.
	conn disconnect.
! !

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:43'!
testRawValueNamedNotFound
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT name_surname FROM student where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self should: [ (aRow rawValueNamed: 'id')] raise: DBXError.
	result releaseResult.
	conn disconnect.
! !

!DBXRowTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:43'!
testRawValues
	| conn result select aRow |
	conn := self doConnectAndOpen.
	select:= 'SELECT id, name_surname,age FROM student where id = 1'.
	result := conn execute: select.	
	aRow := result nextRow.
	self assert: aRow rawValues size = 3.
	result releaseResult.
	conn disconnect.
! !

DBXQueryBaseTest subclass: #DBXTransactionalManageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:44'!
testTransactionCommit
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from signature'.
	result := conn execute: delete.
	result releaseResult.
	conn commit.
	select := 'SELECT * FROM signature'.
	result := conn execute: select.
	self assert: result nextRow isNil.
	result releaseResult.
	conn disconnect! !

!DBXTransactionalManageTest methodsFor: 'tests' stamp: 'HMC 8/25/2009 00:44'!
testTransactionRollback
	| conn result delete select |
	conn := self doConnectAndOpen.
	conn startTransaction.
	delete := 'delete from signature'.
	conn execute: delete.
	conn rollback.
	select := 'select * from signature'.
	result := conn execute: select.
	self assert: result nextRow notNil.
	result releaseResult.
	conn disconnect! !

DBXBaseTest subclass: #DBXQueryTimeoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXQueryTimeoutTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:44'!
insertRows:  aNumberOfRows
	| conn |

	Transcript show: 'Inserting ', aNumberOfRows asString, ' rows'; cr.
	conn := self doConnectAndOpen.
	conn startTransaction.
	1
		to: aNumberOfRows
		do: [:i | conn
				execute: ('INSERT INTO student (id, name_surname, age) VALUES ( {1} ,''Esteban
	Squeak'', 42)' format: (OrderedCollection new add: i asInteger asDbxString;
							 yourself))].
	conn commit.
	conn disconnect.
	Transcript show: aNumberOfRows asString, ' rows were inserted'; cr.	! !

!DBXQueryTimeoutTest methodsFor: 'as yet unclassified' stamp: 'MMP 4/6/2009 00:59'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXQueryTimeoutTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:45'!
test1000MicrosecondsTimeout
	| conn aQuerySettings rows aTimeSpec |
	
	rows := 5000.
	self insertRows: rows.
	
	conn := self doConnectAndOpen.
	aTimeSpec := DBXQueryTimeout seconds: 0 microseconds: 150.
	
	aQuerySettings := DBXQuerySettings timeout: aTimeSpec.
	conn execute: 'select * from student' querySettings: aQuerySettings.
	conn disconnect.
	
	! !

!DBXQueryTimeoutTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:45'!
test3SecondsTimeout
	| conn aQuerySettings rows aTimeSpec |
	
	rows := 5000.
	self insertRows: rows.
	
	conn := self doConnectAndOpen.
	aTimeSpec := DBXQueryTimeout seconds: 3 microseconds: 0.
	
	aQuerySettings := DBXQuerySettings timeout: aTimeSpec.
	conn execute: 'select * from student' querySettings: aQuerySettings.
	conn disconnect.
	
	! !

!DBXQueryTimeoutTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:45'!
testDefaultTimeout
	| conn aQuerySettings rows |
	
	rows := 5000.
	self insertRows: rows.
	
	conn := self doConnectAndOpen.
	aQuerySettings := DBXQuerySettings default.
	conn execute: 'select * from student' querySettings: aQuerySettings.
	conn disconnect.
	
	
	
	! !

!DBXQueryTimeoutTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:45'!
testNoTimeout
	| conn aQuerySettings rows |
	
	rows := 5000.
	self insertRows: rows.
	
	conn := self doConnectAndOpen.
	aQuerySettings := DBXQuerySettings timeout: nil.
	conn execute: 'select * from student' querySettings: aQuerySettings.
	conn disconnect.
	
	
	
	
	! !

DBXBaseTest subclass: #DBXResultSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXResultSetTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:46'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "
	
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (1, ''Mariano Squeak'', 23) '.
	aConnection execute:' INSERT INTO student (id, name_surname, age) VALUES (2, ''Hernan Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (3, ''German Squeak'', 23) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	
	"aConnection execute: 'INSERT INTO course(id_course, id_student, signature_code, styarting_hour) VALUES (5, 5, 5, null);'."! !

!DBXResultSetTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:46'!
testIsOpen
	| conn result select aRow result2 |
	
	"When the connection is disconected, the resultset must be closed"
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM student'.
	result := conn execute: select.
	self assert: result isOpen.
	self assert: result nextRow notNil.
	[ aRow := result nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: result isOpen.
	"Even after retrieving all rows, the resultset doesn't update its state to closed"
	conn disconnect.
	self deny: result isOpen.
	
	"When the connection is closed, the resultset must be closed"
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM student'.
	result := conn execute: select.
	self assert: result isOpen.
	self assert: result nextRow notNil.
	[ aRow := result nextRow ] doWhileTrue: [ aRow notNil ].
	self assert: result isOpen.
	conn close.
	self deny: result isOpen.
	conn disconnect.
	self deny: result isOpen.
	
	"When a new query is executed the previous query in the same conncion, must be closed."
	conn := self doConnectAndOpen.
	select:= 'SELECT * FROM student'.
	result := conn execute: select.
	self assert: result isOpen.
	result2 := conn execute: 'SELECT * FROM signature'.
	self deny: result isOpen.
	self assert: result2 isOpen.
	conn disconnect.

! !

DBXBaseTest subclass: #DBXSecuenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXSecuenceTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2009 19:50'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on each test. Each test may need different data. Because of this, it should be implemented by the subclass. "! !

!DBXSecuenceTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/5/2009 19:53'!
testPostgreSQLSecuence
	| conn result row secuence1 secuence2 |

	(self platform class = DBXPostgresPlatform) ifFalse: [^ self].
		
	conn := self doConnectAndOpen.
	result := conn execute: 'SELECT nextval(''sequence_1'')'.
	row := result nextRow.
	self assert: row notNil.
	secuence1 := row valueAt: 1.
	result := conn execute: 'SELECT nextval(''sequence_1'')'.
	row := result nextRow.
	self assert: row notNil.
	secuence2 := row valueAt: 1.
	self assert: ((secuence1 + 1) = secuence2 ).
	
	conn disconnect.! !

DBXBaseTest subclass: #DBXSetUpTearDownTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXSetUpTearDownTest methodsFor: 'running' stamp: 'MMP 9/13/2008 17:53'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXSetUpTearDownTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 00:50'!
testSetUpTearDOwn
! !

DBXBaseTest subclass: #DBXStoredProceduresTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXStoredProceduresTest methodsFor: 'as yet unclassified' stamp: 'HMC 8/25/2009 00:47'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (4, ''Alejandro Squeak'', 30) '.
	aConnection execute: 'INSERT INTO student (id, name_surname, age) VALUES (5, ''Esteban Squeak'', 42) '.
	! !

!DBXStoredProceduresTest methodsFor: 'as yet unclassified' stamp: 'Mariano 9/24/2009 22:09'!
testMySQLFunctions
	| conn result resultSet |
	
	(self platform = DBXMySQLPlatform ) ifFalse: [ ^self ].
	
	conn := self doConnect.
	result := conn enableMultipleStatements.
	conn open.
	result ifFalse: 
		[ conn disconnect.
		^ self ].

	"CREATE DEFINER=`sodbxtest`@`%` PROCEDURE  `sodbxtest`.`allAlumnos`()
	BEGIN
   SELECT *
   FROM alumno;
	END"
	resultSet := conn executeMultiStatement: 'call allAlumnos()'.
	DBXTranscript show: resultSet.
	
	conn disconnect.! !

!DBXStoredProceduresTest methodsFor: 'as yet unclassified' stamp: 'Mariano 9/24/2009 22:09'!
testPostgreSQLFunctions
	| conn result resultSet |
	
	(self platform = DBXPostgresPlatform ) ifFalse: [ ^self ].
	
	conn := self doConnect.
	result := conn enableMultipleStatements.
	conn open.
	
	result ifFalse: [
		conn disconnect.
		^ self].

	"CREATE FUNCTION one (OUT sum int)
	AS 'SELECT 1'
	LANGUAGE SQL;"
	resultSet := conn executeMultiStatement: 'SELECT * FROM one()'.
	DBXTranscript show: resultSet.
	
	conn disconnect.

	! !

DBXBaseTest subclass: #DBXTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTypeTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/20/2009 20:45'!
platformFirebirdPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	TIMESTAMP);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'test 12/1/2008 01:45'!
platformMssqlPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATETIME,
			datetime_time 			DATETIME,
			datetime_timestamp 		DATETIME);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:24'!
platformMysqlPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	DATETIME);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
	! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:28'!
platformMysqlTestCharacter: aRow
	self assert: (aRow valueNamed: 'char_char') = 'test'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 23:19'!
platformMysqlTestDatetime: aRow
	self assert: (aRow valueNamed: 'datetime_time') = (Time hour: 10 minute: 20 second: 30).
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 23:16'!
platformOraclePrepareDatetime: aConnection 
	[aConnection execute: 'DROP TABLE test_datetime_columns']
		on: Error do: [:e | "table exists" e].
	aConnection execute: '
	CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_timestamp 	TIMESTAMP)'.

	aConnection execute: '
          INSERT INTO test_datetime_columns
			(datetime_date, datetime_timestamp)
		VALUES (to_date(''2008-01-20 01:01:01'', ''yyyy-mm-dd hh:mi:ss''), to_date(''2008-01-20 10:20:30'', ''yyyy-mm-dd hh:mi:ss''))'! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 17:57'!
platformPgsqlPrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	TIMESTAMP);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:27'!
platformPgsqlTestBoolean
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [
		conn execute: 'DROP TABLE IF EXISTS test_boolean_columns;'.
		conn execute: '
			CREATE TABLE test_boolean_columns (
				bool_boolean 	BOOLEAN);'.
		conn execute: '		
			INSERT INTO test_boolean_columns
				(bool_boolean)
				VALUES (true);' ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_boolean_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.
	self assert: (row valueNamed: 'bool_boolean').
		
	conn close.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:28'!
platformPgsqlTestCharacter: aRow
	self assert: (aRow valueNamed: 'char_char') = 
		('test' padded: #right to: 10 with: Character space).
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 23:19'!
platformPgsqlTestDatetime: aRow
	self assert: (aRow valueNamed: 'datetime_time') = (Time hour: 10 minute: 20 second: 30).
! !

!DBXTypeTest methodsFor: 'tests' stamp: 'MMP 9/25/2008 23:06'!
platformSqlite3PrepareDatetime: aConnection
	[ aConnection execute: 'DROP TABLE test_datetime_columns;' ]
	on: Error do: [ :e| "table exists" ].

	aConnection execute: '
		CREATE TABLE test_datetime_columns (
			datetime_date 			DATE,
			datetime_time 			TIME,
			datetime_timestamp 	TIMESTAMP);'.

	aConnection execute: '
		INSERT INTO test_datetime_columns
			(datetime_date, datetime_time, datetime_timestamp)
		VALUES (''2008-01-20'', ''10:20:30'', ''2008-01-20 10:20:30'');'.
! !

!DBXTypeTest methodsFor: 'running' stamp: 'EL 8/2/2008 12:27'!
runDMLSetUpScript: aConnection 
	"The DMLScript depends on the relational database engine. Because of this, it should be implemented by the subclass. Thi subclass is associated with a particular RDBMS"
	! !

!DBXTypeTest methodsFor: 'tests' stamp: 'EL 8/19/2008 18:26'!
testBoolean
	"Not all paltforms have Boolean type support"
	self platformCall: #testBoolean! !

!DBXTypeTest methodsFor: 'tests' stamp: 'Mariano 9/24/2009 22:10'!
testCharacter
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self
		shouldnt: [[conn execute: 'DROP TABLE test_character_columns']
				on: Error
				do: [:e | "table exists"
					e].
		]
		raise: DBXError.
		conn execute: '
			CREATE TABLE test_character_columns (
				char_char		CHAR(10),
				char_varchar	VARCHAR(10))'.
			conn execute: '
			INSERT INTO test_character_columns
				(char_char, char_varchar)
				VALUES (''test'', ''test'')'.
	self
		shouldnt: [resultSet := conn execute: 'SELECT * FROM test_character_columns']
		raise: DBXError.
	row := resultSet rows first.
	self platformCall: #testCharacter: with: row.
	self assert: (row valueNamed: 'char_varchar')
			= 'test'.
			
	conn disconnect.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'Mariano 9/24/2009 22:10'!
testDatetime
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self shouldnt: [ self platformCall: #prepareDatetime: with: conn ]
		raise: DBXError.
		
	self shouldnt: [ resultSet := conn execute: 'SELECT * FROM test_datetime_columns' ]
		raise: DBXError.
			
	row := resultSet rows first.

	"Sqlite3 doesn't store time and dates values in specific types but uses CLOB instead. We map CLOB with String, yo for Sqlite3 we have to compare the date with the string'"
	
	(self platform class = DBXSqlitePlatform) ifTrue:[
		
		self assert: (row valueNamed: 'datetime_date') = (Date year: 2008 month: 1 day: 20) yyyymmdd.
		
		self assert: (row valueNamed: 'datetime_timestamp') = 
			(TimeStamp 
				year: 2008 
				month: 1 
				day: 20 
				hour: 10 
				minute: 20 
				second: 30) yyyymmddhhmmss.	
		
	] ifFalse:[

	self assert: (row valueNamed: 'datetime_date') = (Date year: 2008 month: 1 day: 20).
	self assert: (row valueNamed: 'datetime_timestamp') = 
		(TimeStamp 
			year: 2008 
			month: 1 
			day: 20 
			hour: 10 
			minute: 20 
			second: 30).
			
	].


	"Not all platforms has the same behaivor (or types) for date-time, then I check specific 
	 behaivor separately"
	self platformCall: #testDatetime: with: row.
	
	conn disconnect.! !

!DBXTypeTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/20/2009 20:45'!
testNumeric
	| conn resultSet row |
	conn := self doConnectAndOpen.
	self
		shouldnt: [[conn execute: 'DROP TABLE test_numeric_columns']
				on: Error
				do: [:e | "table exists"
					e]]
		raise: DBXError.
	conn execute: '
			CREATE TABLE test_numeric_columns (
				number_decimal 	DECIMAL(5,2),
				number_real 		REAL,
				number_float 		FLOAT,
				number_smallint 	SMALLINT,
				number_integer 		INTEGER)'.
	conn execute: '
			INSERT INTO test_numeric_columns
				(number_decimal, number_real, number_float, number_smallint, number_integer)
				VALUES (42.2, 42.2, 42.2, 42, 42)'.
	self
		shouldnt: [resultSet := conn execute: 'SELECT * FROM test_numeric_columns']
		raise: DBXError.
	row := resultSet rows first.
	self assert: (row valueNamed: 'number_decimal')
			= 42.2.
	"Some databases, like ODBC with postgres and Firebird return 42.20001 instead of 42.2. Because of this the roundTo."
	self assert: ((row valueNamed: 'number_real') roundTo: 0.01) = 42.2.
			
	self assert: ((row valueNamed: 'number_float') roundTo: 0.01)
			= 42.2.
	self assert: (row valueNamed: 'number_smallint')
			= 42.
	self assert: (row valueNamed: 'number_integer')
			= 42.
	
	conn disconnect.! !

TestCase subclass: #DBXConnectionSettingsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXConnectionSettingsTest class methodsFor: 'as yet unclassified' stamp: 'MMP 5/18/2009 11:50'!
packageNamesUnderTest
	^ #('OpenDBX-Core')! !

!DBXConnectionSettingsTest class methodsFor: 'as yet unclassified' stamp: 'MMP 5/10/2009 16:48'!
resources
	^Array with: FacilityTestResource! !

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 7/10/2008 23:30'!
testValidateMethod
	"The method is distinct to zero"
	| settings |
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: -5.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 'nothing'.
	self
		should: [settings validateMethod]
		raise: DBXError.
	"The method is distinct to zero"
	settings := DBXConnectionSettings host: '123.4.7.2' port: '54'.
	settings method: 0.
	self
		shouldnt: [settings validateMethod]
		raise: DBXError! !

!DBXConnectionSettingsTest methodsFor: 'tests' stamp: 'MMP 8/19/2008 21:18'!
xtestValidatePort
	| settings |
	
	self flag: #todo. "Validate port is not working with Pharo... so we are disabling this test for a while"
	
	"The port is negative but must be positive"
	settings := DBXConnectionSettings host: '127.0.0.1' port: '-1'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is zero but must be positive"
	settings := DBXConnectionSettings host: '127.0.0.1' port: '0'. 
	self shouldnt: [settings validatePort] raise: DBXError.
	
	"The not a number but must be positive number"
	settings := DBXConnectionSettings host: '127.0.0.1' port: 'invalidPort'. 
	self should: [ settings validatePort ] raise: DBXError.
	
	"The port is correct"
	settings := DBXConnectionSettings host: '127.0.0.1' port: '88'. 
	self shouldnt: [settings validatePort] raise: DBXError.
		
! !

TestCase subclass: #DBXExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Extras'!

!DBXExamples methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/14/2009 22:19'!
testExampleConnection
	| conn connectionSettings |
	connectionSettings := DBXConnectionSettings
			host: '127.0.0.1'
			port: '5432'
			database: 'sodbxtest'
			userName: 'sodbxtest'
			userPassword: 'sodbxtest'.
	conn := DBXConnection platform: DBXPostgresPlatform new settings: connectionSettings.
	conn connect.
	conn open.
	self addConnectionToRelease: conn.
	conn close.
	conn disconnect.
! !

!DBXExamples methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/14/2009 22:19'!
testExampleWithDML
	| conn connectionSettings resultUpdate resultDelete |
	connectionSettings := DBXConnectionSettings
			host: '127.0.0.1'
			port: '5432'
			database: 'sodbxtest'
			userName: 'sodbxtest'
			userPassword: 'sodbxtest'.
	conn := DBXConnection platform: DBXPostgresPlatform new settings: connectionSettings.
	conn connect.
	conn open.
	self addConnectionToRelease: conn.
	conn execute: 'delete from student'.
	conn execute: 'INSERT INTO student (id, name_surname, age) VALUES (100, ''Mariano Squeak'', 23) '.
	resultUpdate := conn execute: 'update student set name_surname = ''something'' where id = 100'.
	self assert: resultUpdate class = DBXResult.
	self assert: resultUpdate rowsAffected = 1.
	resultDelete := conn execute: 'delete from student where id = 100'.
	self assert: resultDelete class = DBXResult.
	self assert: resultDelete rowsAffected = 1.
	conn startTransaction.
	conn execute: 'INSERT INTO student (id, name_surname, age) VALUES (101, ''Mariano Squeak'', 23) '.
	conn commit. 
	conn close.
	conn disconnect.
! !

TestCase subclass: #DBXFullTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Extras'!

!DBXFullTestRunner class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/30/2009 21:26'!
backendsToTest
	| backends |
	backends := Set new.
	backends 
		add: DBXMsSQLFacility;
		add: DBXMySQLFacility;
		add: DBXOracleFacility;	
		add: DBXPostgreFacility;
		add: DBXSqliteFacility.
	^backends
! !

!DBXFullTestRunner class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/16/2009 22:53'!
testsToTest
	| tests |
	tests := Set new.
	tests 
		add: DBXCompleteExamplesTest;
		add: DBXConnectionBadSettingsTest;
		add: DBXConnectionTest;
		add: DBXDescriptionTest;
		add: DBXGarbageCollectorTest;
		add: DBXMultiStatementResultSetIteratorTest;
		add: DBXMultiStatementTest;
		add: DBXOptionsTest;
		add: DBXQueryDDLTest;
		add: DBXQueryDMLTest;
		add: DBXQueryTest;
		add: DBXRowTest;
		add: DBXTransactionalManageTest;
		add: DBXQueryTimeoutTest;
		add: DBXResultSetTest;
		add: DBXSetUpTearDownTest;
		add: DBXStoredProceduresTest;
		add: DBXSecuenceTest;
		add: DBXTypeTest;
		add: DBXConnectionSettingsTest.
^ tests! !

!DBXFullTestRunner methodsFor: 'tests' stamp: 'MMP 3/10/2009 22:30'!
test: aBackend times: aNumber
	| result resultTest testsCount |
	testsCount := 0.
	aNumber timesRepeat:[ 
		Transcript show: aBackend name ; cr.
		
	 	[result := aBackend suite run.]
			on: Error do:[ 'nothing' ].
		
		(result hasFailures or: [result hasErrors] ) ifTrue: [self fail].
		testsCount := testsCount + result passedCount.
		
		self class testsToTest do:[ :eachTest | [resultTest := eachTest suite run] on: Error do:['nothing'].
			
		(resultTest hasFailures or: [result hasErrors] ) ifTrue: [self fail].	
		testsCount := testsCount + resultTest passedCount.
			 ].
		].
	
		Transcript open.
		Transcript show: ('Total tests: ' , testsCount asString); cr.
		Transcript show: 'Tested backend: '; cr.
		Transcript show: (aBackend name); cr.
! !

!DBXFullTestRunner methodsFor: 'tests' stamp: 'MarianoMartinezPeck 9/30/2009 21:40'!
testAllBackendsWithAllTests
	| resultTest testsCount |
	testsCount := 0.
	self class backendsToTest do:[ :each |

		Transcript show: each name ; cr.
	
		DBXBaseTest facility: each facilityForTest.
		
		self class testsToTest do:[ :eachTest | [resultTest := eachTest suite run] on: Error do:['nothing'].
			
		(resultTest hasFailures) ifTrue: [self fail].	
		testsCount := testsCount + resultTest passedCount.
			 ].
		].
	
		Transcript open.
		Transcript show: ('Total tests: ' , testsCount asString); cr.
		Transcript show: 'Tested backends: '; cr.
		self class backendsToTest do:[ :each | Transcript show: (each name); cr. ].
		Transcript show: ('Total tests per backend: ' , (testsCount / self class backendsToTest size) asString ); cr.! !

TestCase subclass: #DBXNoEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding-Tests'!

!DBXNoEncodingTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/25/2010 19:33'!
testEncoderFor
	| encoder result string |
	string := String with: (Character value: 1234).
	encoder := DBXNoEncoding new encoderFor: Object new.
	result := encoder convertToSystemString: (String with: (Character value: 1234)).
	self should: [string = result]. 
! !

TestCase subclass: #DBXNullTextConverterTest
	instanceVariableNames: 'converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding-Tests'!

!DBXNullTextConverterTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/25/2010 19:33'!
setUp
	converter := DBXNullTextConverter new.! !

!DBXNullTextConverterTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 18:00'!
testConvertFromSystemString
	| string result |
	string := '!!%/'.
	result := converter convertFromSystemString: string.
	self should: [string = result] value.! !

!DBXNullTextConverterTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 17:56'!
testConvertToSystemString
	| string result |
	string := '!!%/'.
	result := converter convertToSystemString: string.
	self should: [string = result] value.! !

!DBXNullTextConverterTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 17:56'!
testNextFromStream
	| string |
	string := ''.
	self should: [$ = (converter nextFromStream: (ReadStream on: string))].! !

!DBXNullTextConverterTest methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 17:56'!
testNextPutToStream
	| string |
	string := String new: 1.
	converter nextPut: $ toStream: (WriteStream on: string).
	self should: [string = ''] value.! !

TestCase subclass: #DBXResetTestBackend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests-Extras'!

!DBXResetTestBackend methodsFor: 'as yet unclassified' stamp: 'MMP 5/10/2009 17:14'!
testResetSelectedBackend
	DBXBaseTest facility: nil.! !

TestCase subclass: #DBXStaticEncodingTest
	instanceVariableNames: 'converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding-Tests'!

!DBXStaticEncodingTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/25/2010 19:33'!
testEncodingFor 
	| strategy encoder encoded |
	strategy := DBXStaticEncoding newForEncoding: #utf8.
	encoder :=strategy encoderFor: (Object new). "any object will do"
	encoded := encoder convertToSystemString: ''.
	self should: [encoded = (String fromByteArray: (ByteArray with: 16rC3 with: 16rA4))].
	! !

Object subclass: #DBXAuthenticationMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXAuthenticationMethod class methodsFor: 'methods' stamp: 'MMP 8/16/2008 22:45'!
usernamePassword
	"Returns the method number of openDBX for username and password"
	^0.! !

Object subclass: #DBXBackendFacility
	instanceVariableNames: 'platform connectionSettings scriptsDDL scriptsDrops'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/9/2009 12:26'!
facilityForBenchmark
	^(self basicNew)
	createConnection;
	"addBenchmarkScripts"			
	yourself.! !

!DBXBackendFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:40'!
facilityForTest
	^(self basicNew)
	createConnection;
	addTestScripts;			
	yourself.! !

!DBXBackendFacility methodsFor: 'tests' stamp: 'HMC 1/8/2009 17:24'!
addTestScripts
		""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptSelect
	""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings
	^ connectionSettings! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
connectionSettings: anObject
	connectionSettings := anObject! !

!DBXBackendFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:22'!
createConnection
		""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform
	^ platform! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 6/17/2008 23:04'!
platform: anObject
	platform := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 8/7/2008 02:52'!
scriptsDDL
	^ scriptsDDL! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 8/7/2008 02:52'!
scriptsDDL: anObject
	scriptsDDL := anObject! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 10/5/2008 23:32'!
scriptsDrops
	^ scriptsDrops! !

!DBXBackendFacility methodsFor: 'accessing' stamp: 'MMP 10/5/2008 23:32'!
scriptsDrops: anObject
	scriptsDrops := anObject! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:15'!
tinyBenchmarkScript
		""
	self subclassResponsibility! !

!DBXBackendFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:15'!
tinyBenchmarkScript: aNumber
		""
	self subclassResponsibility! !

DBXBackendFacility subclass: #DBXFirebirdFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXFirebirdFacility class methodsFor: 'as yet unclassified' stamp: 'mariano 12/19/2009 20:15'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXFirebirdFacility methodsFor: 'tests' stamp: 'mariano 12/19/2009 20:43'!
addTestScripts
| scriptDDL scriptDrops |
scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE student(
   	   id INTEGER,
	   name_surname VARCHAR(50),	
	   mail VARCHAR(50),
      regular CHAR(1),
	   age SMALLINT,	   
	   average_grade DECIMAL(9,3),
	   sex CHARACTER(3),
	   description VARCHAR(200),
	   starting_hour TIME,
	   sign_up_date TIMESTAMP,
	   born_date DATE,
	   CONSTRAINT pk_students_id PRIMARY KEY (id)
	)'.
	
	scriptDDL add: 'CREATE TABLE signature(
	code INTEGER,
	id_student INTEGER, 
	name CHAR(100),
	observations VARCHAR(255),
	course_grade INTEGER,
	final_grade INTEGER,
	CONSTRAINT pk_signatures_code PRIMARY KEY (id_student, code)
)'.

	scriptDDL add: 'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	signature_code INTEGER,
	starting_date DATE,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, signature_code)
)'.

"	scriptDDL add: 'ALTER TABLE course
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_student) REFERENCES student(id)'.
	scriptDDL add: 'ALTER TABLE course
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (signature_code) REFERENCES signature(code)'."
	scriptDDL add: 'ALTER TABLE signature
	ADD CONSTRAINT se_st_fk FOREIGN KEY (id_student) REFERENCES student(id)'.
	
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE course'.
	scriptDrops add: 'DROP TABLE signature'.
	scriptDrops add: 'DROP TABLE student'.
	self scriptsDrops: scriptDrops.! !

!DBXFirebirdFacility methodsFor: 'benchmarks' stamp: 'mariano 12/19/2009 20:15'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXFirebirdFacility methodsFor: 'benchmarks' stamp: 'mariano 12/19/2009 20:15'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXFirebirdFacility methodsFor: 'connection' stamp: 'mariano 12/19/2009 20:45'!
createConnection
	self	connectionSettings: (DBXConnectionSettings
				host: ''
				port: ''
				database: 'c:/mariano/firebird/sodbxtest.fdb'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest').
	self platform: DBXFirebirdPlatform new! !

!DBXFirebirdFacility methodsFor: 'benchmarks' stamp: 'mariano 12/19/2009 20:15'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXFirebirdFacility methodsFor: 'benchmarks' stamp: 'mariano 12/19/2009 20:15'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXMsSQLFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMsSQLFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:39'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'! !

!DBXMsSQLFacility methodsFor: 'tests' stamp: 'HMC 9/2/2009 22:27'!
addTestScripts
| scriptDDL scriptDrops |
scriptDDL := OrderedCollection new. 
	scriptDrops := OrderedCollection new. 
	
	scriptDDL add: 'CREATE TABLE student(
	   id INTEGER,
	   name_surname VARCHAR(30) NULL,	   
	   regular BIT NULL,
	   age SMALLINT NULL,	   
	   average_grade DECIMAL(9,3) NULL,
	   sex CHARACTER(3) NULL,
	   description VARCHAR(200) NULL,
	   starting_hour DATETIME NULL,
	   sign_up_date DATETIME NULL,
	   born_date DATETIME NULL,
	  CONSTRAINT pk_students_id PRIMARY KEY (id)
	) ;
'.

	
	scriptDDL add:  'CREATE TABLE signature(
	code INTEGER, 
	id_student INTEGER,
	name CHAR(35) NULL,
	observations VARCHAR(255) NULL,
	course_grade INTEGER NULL,
	final_grade INTEGER NULL,
	CONSTRAINT pk_signatures_code PRIMARY KEY (code)
)  '.


	scriptDDL add:  
'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	code_signature INTEGER,
	starting_date DATETIME NULL,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, code_signature)
) '.


"		scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.  
		
			scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES materia(codigo)'."
	
	"scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES alumno(id)'.
	"
	
	self scriptsDDL: scriptDDL. 
	
	scriptDrops add: 'DROP TABLE course'.
	scriptDrops add: 'DROP TABLE signature'. 
	scriptDrops add: 'DROP TABLE student'.
	
	self scriptsDrops: scriptDrops.! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1	DATETIME,
			date2    DATETIME)'.
	^ scriptDDL! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:58'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1	DATETIME,
			date2    DATETIME)'.
	^ scriptDDL! !

!DBXMsSQLFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:38'!
createConnection
self connectionSettings: (DBXConnectionSettings
				host: 'SQLSERVER_TDS'
				"host: '169.254.96.198'"
				port: '3004'
				database: 'sodbxtest'
				userName: 'crapodino'
				userPassword: 'florynano').
	self platform: DBXMSSQLPlatform new.! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:37'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATETIME,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMsSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:31'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATETIME,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXMySQLFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

DBXMySQLFacility subclass: #DBXMySQL4Facility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXMySQL4Facility methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/5/2009 20:17'!
createConnection
self connectionSettings: (DBXConnectionSettings
			host: '127.0.0.1'
			port: '3306'
			database: 'sodbxtest'
			userName: 'sodbxtest'
			userPassword: 'sodbxtest').
self platform: DBXMySQL4Platform new.


! !

!DBXMySQLFacility class methodsFor: 'instance creation' stamp: 'HMC 1/8/2009 17:08'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXMySQLFacility methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 00:56'!
addTestScripts
| scriptDDL scriptDrops  |
	scriptDDL := OrderedCollection new. 
	scriptDrops := OrderedCollection new. 
	

	scriptDDL add: 'CREATE TABLE student(
	   id INTEGER AUTO_INCREMENT,
	   username VARCHAR(10),
	   pass VARCHAR(50),
	   mail VARCHAR(50),
	   name_surname VARCHAR(30),	   
	   regular BOOLEAN,
	   age SMALLINT,	   
	   average_grade DECIMAL(9,3),
	   sex CHARACTER(3),
	   description VARCHAR(200),
	   starting_hour TIME,
	   sign_up_date DATETIME,
	   born_date DATE,
	  CONSTRAINT pk_students_id PRIMARY KEY (id)
	) ENGINE = InnoDB ;
'.
"The InnoDB engine is in order to have transaction in this table"
	
	scriptDDL add:  'CREATE TABLE signature(
	code INTEGER, 
	id_student INTEGER,
	name CHAR(100),
	observations VARCHAR(255),
	course_grade INTEGER,
	final_grade INTEGER,
	CONSTRAINT pk_signatures_code PRIMARY KEY (code)
) ENGINE = InnoDB '.
"The InnoDB engine is in order to have transaction in this table"

	scriptDDL add:  
'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	signature_code INTEGER,
	starting_date DATE,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, signature_code)
) ENGINE = InnoDB '.
"The InnoDB engine is in order to have transaction in this table"

"		scriptDDL add: 'ALTER TABLE course
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_student) REFERENCES alumno(id)'.  
		
			scriptDDL add: 'ALTER TABLE course
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (signature_code) REFERENCES signature(code)'."
	
	scriptDDL add: 'ALTER TABLE signature
	ADD CONSTRAINT se_st_fk FOREIGN KEY (id_student) REFERENCES student(id)'.
	
	self scriptsDDL: scriptDDL. 
	
	scriptDrops add: 'DROP TABLE IF EXISTS course CASCADE'.
	scriptDrops add: 'DROP TABLE IF EXISTS signature CASCADE'. 
	scriptDrops add: 'DROP TABLE IF EXISTS student CASCADE'.

	self scriptsDrops: scriptDrops.
! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMySQLFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:50'!
createConnection
self connectionSettings: (DBXConnectionSettings
			host: '127.0.0.1'
			port: '3306'
			database: 'sodbxtest'
			userName: 'sodbxtest'
			userPassword: 'sodbxtest').
self platform: DBXMySQLPlatform new.


! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:37'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	DATETIME)'.
	^ scriptDDL! !

!DBXMySQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:18'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2    TIME,
			date3 	DATETIME,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2, date3)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: Time current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXOdbcMSSQLFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOdbcMSSQLFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:46'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXOdbcMSSQLFacility methodsFor: 'tests' stamp: 'HMC 9/2/2009 22:28'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	
	scriptDDL add: 'CREATE TABLE student(
	   id INTEGER,
	   name_Surname VARCHAR(30) NULL,	   
	   regular BIT NULL,
	   age SMALLINT NULL,	   
	   average_grade DECIMAL(9,3) NULL,
	   sex CHARACTER(3) NULL,
	   description VARCHAR(200) NULL,
	   starting_hour DATETIME NULL,
	   sign_up_date DATETIME NULL,
	   born_date DATETIME NULL,
	  CONSTRAINT pk_students_id PRIMARY KEY (id)
	) ;
'.
	scriptDDL add: 'CREATE TABLE signature(
	code INTEGER, 
	id_student INTEGER,
	name CHAR(35) NULL,
	observations VARCHAR(255) NULL,
	course_grade INTEGER NULL,
	final_grade INTEGER NULL,
	CONSTRAINT pk_signatures_code PRIMARY KEY (code)
)  '.
	scriptDDL add: 'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	code_signature INTEGER,
	starting_date DATETIME NULL,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, code_signature)
) '.
	"scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. 
	
	scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES
	materia(codigo)'. "
	"scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. "
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE course'.
	scriptDrops add: 'DROP TABLE signature'.
	scriptDrops add: 'DROP TABLE student'.
	self scriptsDrops: scriptDrops! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'MMP 2/3/2009 01:20'!
bigBenchmarkScriptSelect
	! !

!DBXOdbcMSSQLFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:50'!
createConnection
	self connectionSettings: (DBXConnectionSettings 
		host: 'MSSQL'
		port: '3004'
		database: 'sodbxtest'
		userName: 'crapodino'
		userPassword: 'florynano').	
	self platform: DBXOdbcPlatform new.! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript! !

!DBXOdbcMSSQLFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript: aNumber ! !

DBXBackendFacility subclass: #DBXOdbcPostgreFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOdbcPostgreFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:45'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXOdbcPostgreFacility methodsFor: 'tests' stamp: 'HMC 9/2/2009 22:31'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE student(
	   id SERIAL,
	   name_surname VARCHAR,	
	   username VARCHAR(10),
        pass VARCHAR(200),
	   mail VARCHAR(50),
        regular BOOLEAN,
	   age SMALLINT,	   
	   average_grade DECIMAL(9,3),
	   sex CHARACTER(3),
	   description VARCHAR,
	   starting_hour TIME,
	   sign_up_date TIMESTAMP,
	   born_date DATE,
	  CONSTRAINT pk_students_id PRIMARY KEY (id)
	)'.
	scriptDDL add: 'CREATE TABLE signature(
	code INTEGER,
	id_student INTEGER, 
	name CHAR(100),
	observations VARCHAR(255),
	course_grade INTEGER,
	final_grade INTEGER,
	CONSTRAINT pk_signatures_code PRIMARY KEY (id_student, code)
)'.
	scriptDDL add: 'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	code_signature INTEGER,
	starting_date DATE,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, code_signature)
)'.
	"scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. scriptDDL add: 'ALTER TABLE curso
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (codigo_materia) REFERENCES
	materia(codigo)'. "
	scriptDDL add: 'ALTER TABLE signature
	ADD CONSTRAINT se_st_fk FOREIGN KEY (id_student) REFERENCES student(id)'.
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE course'.
	scriptDrops add: 'DROP TABLE signature'.
	scriptDrops add: 'DROP TABLE student'.
	self scriptsDrops: scriptDrops! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 22:57'!
bigBenchmarkScriptInsert
	! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 2/3/2009 01:20'!
bigBenchmarkScriptSelect
	! !

!DBXOdbcPostgreFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 17:54'!
createConnection
	self connectionSettings:( DBXConnectionSettings 
		host: 'sodbxtest'
		port: '5432'
		database: 'sodbxtest'
		userName: 'sodbxtest'
		userPassword: 'sodbxtest').
	self platform: DBXOdbcPlatform new.! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript! !

!DBXOdbcPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:29'!
tinyBenchmarkScript: aNumber ! !

DBXBackendFacility subclass: #DBXOracleFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXOracleFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:45'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXOracleFacility methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/14/2009 01:27'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE table student (
    id               NUMBER NOT NULL,
    name_surname  VARCHAR2(4000),
    username VARCHAR2(10),
    pass VARCHAR2(50),
    mail VARCHAR2(50),
    regular          NUMBER(1),
    age             NUMBER,
    average_grade         NUMBER(9,3),
    sex             VARCHAR2(4000),
    description      VARCHAR2(4000),
    starting_hour     TIMESTAMP,
    sign_up_date       DATE,
    born_date DATE,
    constraint  student_PK primary key (id)
)
'.
	scriptDDL add: 'CREATE table signature (
    code        NUMBER NOT NULL,
    id_student INTEGER NOT NULL,
    name        VARCHAR2(4000),
    observations VARCHAR2(4000),
    course_grade NUMBER,
    final_grade NUMBER,
    constraint  signature_pk primary key (code)
)'.
	scriptDDL add: 'CREATE table course (
    id_course       NUMBER NOT NULL,
    id_student      NUMBER,
    code_signature NUMBER,
    starting_date   DATE,
    constraint  course2_pk primary key (id_course)
)'.
	scriptDDL add: 'CREATE SEQUENCE student_id_seq 
 	       start with 1 
  	      increment by 1 
   	     nomaxvalue'.
	"scriptDDL add: 
	'CREATE TRIGGER alumno_insert_trigger
	before insert on alumno
	for each row
	begin
	select alumno_id_seq.nextval into :new.id from dual;
	end'."
	"
	scriptDDL add: '
	alter table curso add constraint
	co_ao_fk foreign key (id_alumno) references alumno (id)
	'. 
	
	scriptDDL add: 'alter table curso add constraint
	co_ma_fk foreign key (codigo_materia) references materia (codigo)
	'.
	
	scriptDDL add: 'ALTER TABLE materia
	ADD CONSTRAINT ma_ao_fk FOREIGN KEY (id_alumno) REFERENCES
	alumno(id)'. "
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE course CASCADE CONSTRAINTS'.
	scriptDrops add: 'DROP TABLE signature CASCADE CONSTRAINTS'.
	scriptDrops add: 'DROP TABLE student CASCADE CONSTRAINTS'.
	scriptDrops add: 'DROP TRIGGER student_insert_trigger'.
	scriptDrops add: 'DROP SEQUENCE student_id_seq'.
	self scriptsDrops: scriptDrops! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:17'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXOracleFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 18:01'!
createConnection
self connectionSettings: (DBXConnectionSettings
				host: '127.0.0.1'
				port: '1521'
				database: 'xe'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest').
	self platform: DBXOraclePlatform new.! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:26'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXOracleFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:24'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXPostgreFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXPostgreFacility class methodsFor: 'as yet unclassified' stamp: 'MMP 2/3/2009 01:49'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXPostgreFacility methodsFor: 'tests' stamp: 'MarianoMartinezPeck 2/12/2010 18:23'!
addTestScripts
| scriptDDL scriptDrops |
scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE student(
   	   id SERIAL,
	   name_surname VARCHAR,	
	   username VARCHAR(10),
         pass VARCHAR(200),
	   mail VARCHAR(50),
         regular BOOLEAN,
	   age SMALLINT,	   
	   average_grade DECIMAL(9,3),
	   sex CHARACTER(3),
	   description VARCHAR,
	   starting_hour TIME,
	   sign_up_date TIMESTAMP,
	   born_date DATE,
	   CONSTRAINT pk_students_id PRIMARY KEY (id)
	)'.
	
	scriptDDL add: 'CREATE TABLE signature(
	code INTEGER,
	id_student INTEGER, 
	name CHAR(100),
	observations VARCHAR(255),
	course_grade INTEGER,
	final_grade INTEGER,
	CONSTRAINT pk_signatures_code PRIMARY KEY (id_student, code)
)'.

	scriptDDL add: 'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	signature_code INTEGER,
	starting_date DATE,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, signature_code)
)'.


	scriptDDL add: 'CREATE SEQUENCE sequence_1 START 1'.

"	scriptDDL add: 'ALTER TABLE course
	ADD CONSTRAINT co_ao_fk FOREIGN KEY (id_student) REFERENCES student(id)'.
	scriptDDL add: 'ALTER TABLE course
	ADD CONSTRAINT co_ma_fk FOREIGN KEY (signature_code) REFERENCES signature(code)'."
	scriptDDL add: 'ALTER TABLE signature
	ADD CONSTRAINT se_st_fk FOREIGN KEY (id_student) REFERENCES student(id)'.
	
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE IF EXISTS course CASCADE'.
	scriptDrops add: 'DROP TABLE IF EXISTS signature CASCADE'.
	scriptDrops add: 'DROP TABLE IF EXISTS student CASCADE'.
	scriptDrops add: 'DROP SEQUENCE sequence_1'.
	self scriptsDrops: scriptDrops.! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:09'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:09'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXPostgreFacility methodsFor: 'connection' stamp: 'HMC 1/8/2009 18:03'!
createConnection
	self	connectionSettings: (DBXConnectionSettings
				host: '127.0.0.1'
				port: '5432'
				database: 'sodbxtest'
				userName: 'sodbxtest'
				userPassword: 'sodbxtest').
	self platform: DBXPostgresPlatform new! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:12'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXPostgreFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:13'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

DBXBackendFacility subclass: #DBXSqliteFacility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXSqliteFacility class methodsFor: 'as yet unclassified' stamp: 'HMC 1/8/2009 17:45'!
new
	self error: 'Use facilityForTest or facilityForBenchmark'
! !

!DBXSqliteFacility methodsFor: 'tests' stamp: 'HMC 9/2/2009 22:30'!
addTestScripts
	| scriptDDL scriptDrops |
	scriptDDL := OrderedCollection new.
	scriptDrops := OrderedCollection new.
	scriptDDL add: 'CREATE TABLE student(
	   id INTEGER,
	   name_surname CHARACTER VARYING(30),	   
	   username VARCHAR(10),
        pass VARCHAR(10),
        mail VARCHAR(50),
        regular BOOLEAN,
	   age SMALLINT,	   
	   average_grade DECIMAL(9,3),
	   sex CHARACTER(3),
	   description CHARACTER VARYING(200),
	   starting_hour TIME,
	   sign_up_date TIMESTAMP,
	   born_date DATE,
	  CONSTRAINT pk_students_id PRIMARY KEY (id)
	)'.
	scriptDDL add: 'CREATE TABLE signature(
	code INTEGER PRIMARY KEY,
	id_student INTEGER,
	name CHARACTER VARYING(50),
	course_grade INTEGER,
	final_grade INTEGER,
	observations CHARACTER VARYING(255)
)'.
	scriptDDL add: 'CREATE TABLE course(
	id_course INTEGER,
	id_student INTEGER,
	code_signature INTEGER,
	starting_date DATE,
	CONSTRAINT pk_courses_id_course PRIMARY KEY (id_student, code_signature)
)'.
	self scriptsDDL: scriptDDL.
	scriptDrops add: 'DROP TABLE course'.
	scriptDrops add: 'DROP TABLE signature'.
	scriptDrops add: 'DROP TABLE student'.
	self scriptsDrops: scriptDrops! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:18'!
bigBenchmarkScriptInsert
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'MMP 1/12/2009 23:18'!
bigBenchmarkScriptSelect
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
			CREATE TABLE big_benchmark_select (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXSqliteFacility methodsFor: 'connection' stamp: 'aaa 11/4/2009 19:56'!
createConnection
	self
		connectionSettings: (DBXConnectionSettings
				host: SmalltalkImage current imagePath, '/'
				port: ''
				database: 'sodbxtest.db'
				userName: ''
				userPassword: '').
	self platform: DBXSqlitePlatform new! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'MMP 1/11/2009 22:01'!
tinyBenchmarkScript
	| scriptDDL |
	scriptDDL := OrderedCollection new.
	scriptDDL add: '
				CREATE TABLE tiny_benchmark_insert (
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2 	TIMESTAMP)'.
	^ scriptDDL! !

!DBXSqliteFacility methodsFor: 'benchmarks' stamp: 'HMC 1/9/2009 13:28'!
tinyBenchmarkScript: aNumber 
	| script |
	script := OrderedCollection new.
	script add: '
		CREATE TABLE tiny_benchmark_' , aNumber asString , ' (
			id 		INTEGER,
			num1 	REAL,
			num2 	FLOAT,
			num3 	DECIMAL(8,2),
			num4 	SMALLINT,
			str1 	CHAR(10),
			str2 	VARCHAR(255),
			date1 	DATE,
			date2    TIME,
			date3 	TIMESTAMP,
			PRIMARY KEY (id))'.
	1
		to: aNumber
		do: [:i | script
				add: ('INSERT INTO tiny_benchmark_' , aNumber asString , ' 
					(id, num1, num2, num3, num4, str1, str2, date1, date2, date3)
				VALUES 
					({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10})' format: (OrderedCollection new add: i asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asFloat asDbxString;
							 add: i asDbxString;
							 add: i asString asDbxString;
							 add: i asString asDbxString;
							 add: Date current asDbxString;
							 add: Time current asDbxString;
							 add: DateAndTime current asDbxString;
							 yourself))].
	^ script! !

Object subclass: #DBXBaseResult
	instanceVariableNames: 'connection handle description querySettings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXBaseResult class methodsFor: 'instance creation' stamp: 'HMC 9/27/2008 15:23'!
new
	self error: 'You must instanciate a subclass of DBXBaseResult'! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
connection
	^ connection! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'MMP 5/27/2009 02:11'!
connection: aConnection
	connection := aConnection! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
description
	^description! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
description: aDescription 
	description := aDescription
! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
handle
	^handle! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:18'!
handle: aHandle 
	handle := aHandle
! !

!DBXBaseResult methodsFor: 'initialization' stamp: 'MMP 2/2/2009 20:13'!
initializeConnection: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings 
	super initialize.
	connection := aConnection.
	handle := aNumber.
	description := aDescription.
	querySettings := aQuerySettings.! !

!DBXBaseResult methodsFor: 'testing' stamp: 'MMP 6/4/2009 22:04'!
isDBXMultiStatementResultSetIterator
	^ false! !

!DBXBaseResult methodsFor: 'testing' stamp: 'MMP 6/4/2009 22:03'!
isResult
	^ false! !

!DBXBaseResult methodsFor: 'testing' stamp: 'MMP 6/4/2009 22:03'!
isResultSet
	^ false! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'HMC 9/27/2008 15:19'!
platform
	^self connection platform! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'MMP 2/2/2009 20:12'!
querySettings
	^ querySettings! !

!DBXBaseResult methodsFor: 'accessing' stamp: 'MMP 2/2/2009 20:12'!
querySettings: anObject
	querySettings := anObject! !

!DBXBaseResult methodsFor: 'finalization' stamp: 'MMP 6/1/2009 20:23'!
releaseResult
	"It will release all the resources associated with a query, if there is any"
	self subclassRisponsability! !

DBXBaseResult subclass: #DBXMultiStatementResultSetIterator
	instanceVariableNames: 'open lastResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXMultiStatementResultSetIterator class methodsFor: 'instance creation' stamp: 'MMP 6/1/2009 21:43'!
new
	self error: 'Use #on:querySettings:'! !

!DBXMultiStatementResultSetIterator class methodsFor: 'instance creation' stamp: 'MMP 5/27/2009 02:18'!
on: aConnection querySettings: aQuerySettings
	^(self basicNew)
		initializeConnection: aConnection 
			querySettings: aQuerySettings;
		yourself.
! !

!DBXMultiStatementResultSetIterator methodsFor: 'enumerating' stamp: 'MMP 6/1/2009 20:34'!
allResultsDo: aBlock
	"For each result it evaluates the block"
	| result |
	[ result := self next.
	  result notNil ] 
	whileTrue: [ aBlock value: result ]! !

!DBXMultiStatementResultSetIterator methodsFor: 'finalize' stamp: 'MMP 6/1/2009 20:25'!
finalize
	self isOpen ifTrue: [ self finalizeResults ]! !

!DBXMultiStatementResultSetIterator methodsFor: 'finalize' stamp: 'MMP 5/27/2009 02:33'!
finalizeResults
	"It will release all the results of the multistatment query"
	| result |
	self isOpen
		ifTrue: [[ result := self next.
	  			result notNil ] 
			whileTrue: [ result finalize ].
			self internalBeClosed]! !

!DBXMultiStatementResultSetIterator methodsFor: 'initialize' stamp: 'MMP 5/27/2009 02:30'!
initializeConnection: aConnection querySettings: aQuerySettings
	super initialize.
	connection := aConnection.
	querySettings := aQuerySettings.
	open := ValueHolder new contents: false.
	self internalBeOpen.! !

!DBXMultiStatementResultSetIterator methodsFor: 'private' stamp: 'MMP 5/27/2009 02:22'!
internalBeClosed
	open contents: false! !

!DBXMultiStatementResultSetIterator methodsFor: 'private' stamp: 'MMP 5/27/2009 02:22'!
internalBeOpen
	open contents: true! !

!DBXMultiStatementResultSetIterator methodsFor: 'testing' stamp: 'MMP 6/4/2009 22:04'!
isDBXMultiStatementResultSetIterator
	^ true! !

!DBXMultiStatementResultSetIterator methodsFor: 'testing' stamp: 'MMP 6/1/2009 20:25'!
isOpen
	"Returns if the DBXMultiStatementResultSetIterator is open or not."
	^open contents! !

!DBXMultiStatementResultSetIterator methodsFor: 'accessing' stamp: 'MMP 5/28/2009 00:35'!
lastResult
	^ lastResult! !

!DBXMultiStatementResultSetIterator methodsFor: 'accessing' stamp: 'MMP 5/28/2009 00:35'!
lastResult: anObject 
	lastResult := anObject! !

!DBXMultiStatementResultSetIterator methodsFor: 'processing' stamp: 'MMP 6/1/2009 20:35'!
next
	"Obtains the next DBXBaseResult of the multistatement query"
	lastResult ifNotNil: [ 
		"I must finalize the previous result (if there is) before processing the next one"
		lastResult finalize ].
	lastResult := self connection processNextResultSetMultiStatement: self querySettings.
	^ lastResult
! !

!DBXMultiStatementResultSetIterator methodsFor: 'release' stamp: 'MMP 6/1/2009 20:09'!
releaseResult
	"It will release all the results of the multistatment query"
	| result |
	self isOpen
		ifTrue: [[ result := self next.
	  			result notNil ] 
			whileTrue: [ result releaseResult ].
			self internalBeClosed]! !

DBXBaseResult subclass: #DBXResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResult class methodsFor: 'instance creation' stamp: 'MMP 8/16/2008 20:11'!
new
	self error: 'Use #on:handle:description:'! !

!DBXResult class methodsFor: 'instance creation' stamp: 'MMP 2/2/2009 19:15'!
on: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription
			querySettings: aQuerySettings;
		yourself.! !

!DBXResult methodsFor: 'testing' stamp: 'MMP 6/4/2009 22:04'!
isResult
	^ true! !

!DBXResult methodsFor: 'release' stamp: 'MMP 6/1/2009 20:03'!
releaseResult
	"Maybe in a future this method could do something"! !

!DBXResult methodsFor: 'accessing' stamp: 'MMP 5/31/2009 20:34'!
rowsAffected
	"Returns the number of rows that have been changed by the current statement. Affected rows are only returned for DELETE, INSERT or UPDATE statements and their concrete number depends on the database implementation. 
	
	This value depends on the type of query:

    * DDL query: It will always be zero.
    * Insert query: It will always be one.
    * Delete and update: Returns the number of rows that have been changed by the current statement. However, their concrete number depends on the database implementation. Instead returning the number of rows which are matched by the WHERE clause, MySQL for example does only count the rows whose values have really been changed. "
	
	^self description rowsAffected! !

DBXBaseResult subclass: #DBXResultSet
	instanceVariableNames: 'open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXResultSet class methodsFor: 'instance creation' stamp: 'MMP 6/1/2009 21:43'!
new
	self error: 'Use #on:handle:description:querySettings:'! !

!DBXResultSet class methodsFor: 'instance creation' stamp: 'MMP 1/31/2009 20:39'!
on: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings
	^(self basicNew)
		initializeConnection: aConnection 
			handle: aNumber
			description: aDescription
			querySettings: aQuerySettings;
		yourself.! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'MMP 4/13/2009 01:10'!
allRowsDo: aBlock 
	"It will execute the block to each row from the collection. It is different from rowsDo: because allRowsDo, first obtain (query) all the rows and then iterates them and evaluates the block. On the other hand, rowsDo: goes row by row executing the block."
	| rows |
	rows := self rows.
	rows do: aBlock! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 6/1/2009 20:28'!
columnCount
	"Returns the number of columns affected in the query. It will be the number of columns you specify in the select statement"
	^self description columnCount! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:29'!
columnDescriptionAt: anIndex
	"Returns the column description at that index.
	IMPORTANT: The index starts in 1."
	^self description columnDescriptionAt: anIndex! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 12/22/2008 20:54'!
columnDescriptionWithName: aName 
	"Returns the column description with that name. If a column with that name was not in select statement a DBXError will be thrown"
	^ [self columnDescriptions
		detect: [:each | each name sameAs: aName]]
		on: Error
		do: [SqueakDBXError signal: 'A column with that name was not found' ]! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:31'!
columnDescriptions
	"Returns the column description of ALL the affected columns"
	^self description columnDescriptions! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:47'!
finalize
	"Will finalize the DBXResultSet object"
	self isOpen ifTrue: [ self finalizeResultSet ]! !

!DBXResultSet methodsFor: 'finalization' stamp: 'MMP 8/16/2008 20:46'!
finalizeResultSet
	"It will release resources and change internal state"
	self platform releaseResultSet: self.
	self internalBeClosed.! !

!DBXResultSet methodsFor: 'initialization' stamp: 'MMP 2/2/2009 20:14'!
initializeConnection: aConnection handle: aNumber description: aDescription querySettings: aQuerySettings 
	super
		initializeConnection: aConnection
		handle: aNumber
		description: aDescription
		querySettings: aQuerySettings.
	open := ValueHolder new contents: false.
	self internalBeOpen.! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeClosed
	open contents: false! !

!DBXResultSet methodsFor: 'private' stamp: 'EL 6/27/2008 09:01'!
internalBeOpen
	open contents: true! !

!DBXResultSet methodsFor: 'testing' stamp: 'MMP 8/16/2008 20:31'!
isOpen
	"Returns if the DBXResultSet is open or not."
	^open contents! !

!DBXResultSet methodsFor: 'testing' stamp: 'MMP 6/4/2009 22:04'!
isResultSet
	^ true! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 5/31/2009 19:26'!
nextRow
	"it returns the next row of the resultSet. If there is no more row, it returns nil. 
	
	VERY IMPORTANT THINGS:

    * After doing a select query you should call nextRow till it returns nil. If you don't do this, you will get a segmentation fault in your next query. You have to do this no matter which number of rows you have got. Suppose you are looking for some record and you find it in the second one. The number of rows is 10. In this case, you should call nextRow 10 times, no matter you found the record in the second one. This limitation is in the database client library. We assume that someone has to do this (retrieve all results before execute another query): openDBX, database client library, SqueakDBX or SqueakDBX user. So, we decided SqueakDBX should do this. The other approach was the SqueakDBX user should do it and if it doesn't do it, SqueakDBX throws an error. In conclusion, you DON'T need to call nextRow till nil its returned, the framework will do it for you in your next query.
    * Some queries return more than one resultSet. This situation will be transparent for SqueakDBX user. nextRow will automatically obtain next resultSet when needed. 

"
	| row |
	self isOpen
		ifFalse: [ SqueakDBXError signal: 'The resultSet must be open to obtain the next row but it is closed' ].
	row := self platform moveNext: self.
	^ row! !

!DBXResultSet methodsFor: 'release' stamp: 'MMP 6/1/2009 20:04'!
releaseResult
	"It will release all the resources of all the resultsSets associated with a query."
	self isOpen
		ifTrue: [self platform releaseAllQueryResultSets: self.
			self internalBeClosed]! !

!DBXResultSet methodsFor: 'accessing' stamp: 'MMP 8/16/2008 20:43'!
rows
	"It returns in an OrderedCollection, ALL the rows of all the resultSets of a query"
	| results |
	results := OrderedCollection new.
	self rowsDo: [ :each| 
		results add: each ].
	^results! !

!DBXResultSet methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 20:44'!
rowsDo: aBlock
	"It will execute the block to each row"
	| row |
	[ row := self nextRow.
	  row notNil ] 
	whileTrue: [ aBlock value: row ]! !

Object subclass: #DBXBenchmark
	instanceVariableNames: 'times mutex querySetting benchPriority'
	classVariableNames: 'Facility'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXBenchmark class methodsFor: 'defaults' stamp: 'MMP 2/3/2009 01:18'!
defaultFacility
	^DBXPostgreFacility facilityForBenchmark! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 8/20/2008 09:44'!
defaultInserts
	^800! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'EL 8/20/2008 09:44'!
defaultRows
	^10! !

!DBXBenchmark class methodsFor: 'defaults' stamp: 'MMP 1/11/2009 22:17'!
defaultRuns
	^10! !

!DBXBenchmark class methodsFor: 'accessing' stamp: 'EL 8/20/2008 09:26'!
facility
	^ Facility ifNil: [ Facility := self defaultFacility ]! !

!DBXBenchmark class methodsFor: 'accessing' stamp: 'EL 8/20/2008 09:26'!
facility: anObject
	Facility := anObject! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'MMP 6/29/2009 22:08'!
benchPriority
	^ benchPriority! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'MMP 6/29/2009 22:08'!
benchPriority: anObject
	benchPriority := anObject! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/20/2008 18:40'!
collect: aBlock
	self runs timesRepeat: [
		| timeExpended |
		timeExpended := MessageTally time: aBlock.
		mutex critical: [ times add: timeExpended ]]! !

!DBXBenchmark methodsFor: 'private' stamp: 'MMP 7/2/2009 10:54'!
collectedTimeAverage
	^((times inject: 0 into: [ :v :each | v + each ]) / self class defaultRuns) asFloat! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/20/2008 09:30'!
createDbxConnection
	| connection |
	connection := DBXConnection
		platform: self facility platform
		settings: self facility connectionSettings.
	connection connect.
	connection open.
	
	^connection! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 8/20/2008 09:27'!
facility
	^self class facility! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:32'!
findBenchmarks
	^self class allSelectors asSortedCollection asOrderedCollection select: [:each | 
		('benchmark*' match: each) and: [each numArgs isZero]]! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 10/12/2009 14:44'!
initialize
	super initialize.
	mutex := Monitor new. ! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MMP 8/2/2009 20:12'!
initializeDatabase
	| conn |
	conn := self createDbxConnection.
	self prepareData: conn rows: 10.
	self prepareData: conn rows: 100.
	self prepareData: conn rows: 1000.
	self prepareData: conn rows: 10000.
	self prepareInsert: conn.
	conn close.! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:58'!
log: aString
	Transcript show: aString; cr.! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 8/20/2008 17:21'!
performIfExists: aSelector
	(self class allSelectors includes: aSelector)
		ifTrue: [ self perform: aSelector ]! !

!DBXBenchmark methodsFor: 'private' stamp: 'EL 7/1/2008 21:18'!
prepareCollector
	times := OrderedCollection new.
	! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MMP 1/20/2009 23:47'!
prepareData: aConnection rows: aNumber
	[ aConnection execute: 'DROP TABLE tiny_benchmark_', aNumber asString ]
	on: DBXError do: [ :e | "DROP fails" ].
	
		(self facility tinyBenchmarkScript: aNumber)
		do: [:script | aConnection execute: script].
	! !

!DBXBenchmark methodsFor: 'initialization' stamp: 'MMP 1/20/2009 23:47'!
prepareInsert: aConnection
	[ aConnection execute: 'DROP TABLE tiny_benchmark_insert' ]
	on: DBXError do: [ :e | "DROP fails" ].

	(self facility tinyBenchmarkScript)
		do: [:script | aConnection execute: script].
! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'MMP 6/23/2009 22:04'!
querySetting
	^ querySetting ifNil: [ DBXQuerySettings default ] ifNotNil: [ querySetting ].! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'MMP 6/23/2009 22:02'!
querySetting: anObject
	querySetting := anObject! !

!DBXBenchmark methodsFor: 'running' stamp: 'MMP 7/1/2009 21:52'!
run: aSelector
	self prepareCollector.
	self setUp.
	self setUpFor: aSelector.
	self collect: [ self perform: aSelector ].
	self tearDownFor: aSelector.
	self tearDown.
	mutex critical: [
		self log: aSelector, ': ', self collectedTimeAverage asString, ' AVG' ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 19:16'!
runAll
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self run: each ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'MMP 6/24/2009 20:49'!
runAll: aQuerySetting
	self querySetting: aQuerySetting.
	self runAll.! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 21:10'!
runAllForked
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self runForked: each ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'MMP 6/29/2009 22:08'!
runAllForked: aPriorityNumber
	self benchPriority: aPriorityNumber.
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self runForked: each priority: aPriorityNumber ].! !

!DBXBenchmark methodsFor: 'running' stamp: 'MMP 6/23/2009 22:02'!
runAllForked: aPriorityNumber querySetting: aQuerySetting
	self querySetting: aQuerySetting.
	self log: 'Benchmarking: ', self class name, ' (', self runs asString, ' runs)'.
	self findBenchmarks do: [ :each | 
		self runForked: each priority: aPriorityNumber].! !

!DBXBenchmark methodsFor: 'running' stamp: 'MMP 6/29/2009 22:21'!
runForked: aSelector
	self benchPriority: Processor userBackgroundPriority.
	self runForked: aSelector priority: self benchPriority.! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 21:51'!
runForked: aSelector priority: aPriorityNumber
	[ self run: aSelector ] forkAt: aPriorityNumber.! !

!DBXBenchmark methodsFor: 'accessing' stamp: 'EL 7/1/2008 21:31'!
runs
	^self class defaultRuns ! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 09:28'!
setUp
	! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 17:22'!
setUpFor: aSelector
	self performIfExists: ('setUp', aSelector capitalized) asSymbol! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 7/2/2008 11:55'!
tearDown! !

!DBXBenchmark methodsFor: 'running' stamp: 'EL 8/20/2008 17:22'!
tearDownFor: aSelector
	self performIfExists: ('tearDown', aSelector capitalized) asSymbol! !

DBXBenchmark subclass: #DBXBigBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXBigBenchmarks class methodsFor: 'defaults' stamp: 'MMP 6/24/2009 20:47'!
defaultRuns
	^1! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 6/23/2009 22:18'!
benchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	100000 timesRepeat: [ 
		connection execute: 
			'INSERT INTO big_benchmark_insert
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')'
		querySettings: self querySetting ].
	connection close.	! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 6/23/2009 22:18'!
benchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	(connection execute: 'SELECT * FROM big_benchmark_select'
		querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].
	connection := self createDbxConnection.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:12'!
initialize
	super initialize.
	self initializeDatabase.
	self initializeConnection.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:14'!
initializeConnection
	connection := self createDbxConnection.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:24'!
initializeDatabase
self setUpBenchmarkInsert100000.
self setUpBenchmarkSelect100000.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 23:10'!
setUpBenchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	[ connection execute: 'DROP TABLE big_benchmark_insert' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptInsert do: 
		[ :script | 
		connection execute: script ].
	connection close! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 23:13'!
setUpBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	[ connection execute: 'DROP TABLE big_benchmark_select' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptSelect do: 
		[ :script | 
		connection execute: script ].
	100000 timesRepeat: 
		[ connection execute: 'INSERT INTO big_benchmark_select
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].
	connection close! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/12/2009 22:55'!
tearDownBenchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_insert'.
	connection close.! !

!DBXBigBenchmarks methodsFor: 'running' stamp: 'MMP 1/20/2009 23:36'!
tearDownBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_select'.
	connection close.! !

DBXBenchmark subclass: #DBXMultipleForksBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXMultipleForksBenchmarks class methodsFor: 'as yet unclassified' stamp: 'MMP 7/1/2009 21:39'!
defaultRuns
	^3! !

!DBXMultipleForksBenchmarks methodsFor: 'as yet unclassified' stamp: 'MMP 7/1/2009 22:15'!
benchmarkSelect100000
	| connection |
	Transcript show: 'benchmarkSelect100000'; cr.
	connection := self createDbxConnection.
	(connection execute: 'SELECT * FROM big_benchmark_select'
		querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXMultipleForksBenchmarks methodsFor: 'as yet unclassified' stamp: 'MMP 7/9/2009 18:24'!
collect: aBlock
|sem time|
sem := Semaphore new.

	1 to: self runs do: [:i |
		[
		time := MessageTally time: aBlock.
		mutex critical: [ times add: time ].
		sem signal.
		] fork		
	].

	self runs timesRepeat: [sem wait]
! !

!DBXMultipleForksBenchmarks methodsFor: 'as yet unclassified' stamp: 'MMP 6/29/2009 21:54'!
setUpBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	[ connection execute: 'DROP TABLE big_benchmark_select' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptSelect do: 
		[ :script | 
		connection execute: script ].
	100000 timesRepeat: 
		[ connection execute: 'INSERT INTO big_benchmark_select
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].
	connection close! !

!DBXMultipleForksBenchmarks methodsFor: 'as yet unclassified' stamp: 'MMP 7/1/2009 20:14'!
tearDownBenchmarkSelect100000
	| connection |
	Transcript show: 'aaaaa '; cr.
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_select'.
	connection close.! !

DBXBenchmark subclass: #DBXTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'MMP 6/24/2009 20:50'!
benchmarkInsert
	self class defaultInserts timesRepeat: [ 
		connection execute: 
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')'
			querySettings: self querySetting ]
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'MMP 6/24/2009 20:51'!
benchmarkInsertConverted
	| date dateAndTime |
	
	date := Date current. 
	dateAndTime := DateAndTime current. 
	1 to: self class defaultInserts do: [ :i |  
		connection execute: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: dateAndTime asDbxString;
						yourself)
			) querySettings: self querySetting. ]
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'MMP 6/24/2009 20:51'!
benchmarkSelect10
	(connection execute: 'SELECT * FROM tiny_benchmark_10' querySettings: self querySetting )
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'MMP 6/24/2009 20:51'!
benchmarkSelect100
	(connection execute: 'SELECT * FROM tiny_benchmark_100' querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'MMP 6/24/2009 20:51'!
benchmarkSelect1000
	(connection execute: 'SELECT * FROM tiny_benchmark_1000' querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'MMP 8/2/2009 20:12'!
benchmarkSelect10000
	(connection execute: 'SELECT * FROM tiny_benchmark_10000' querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 8/20/2008 18:41'!
initialize
	super initialize.
	self initializeDatabase.
	self initializeConnection.! !

!DBXTinyBenchmarks methodsFor: 'initialization' stamp: 'HMC 8/20/2009 23:29'!
initializeConnection
	connection := self createDbxConnection.
! !

!DBXTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 09:34'!
setUp
	self prepareInsert: connection.! !

DBXBenchmark subclass: #MysqlBigBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!MysqlBigBenchmarks class methodsFor: 'defaults' stamp: 'HMC 8/20/2009 23:43'!
defaultRuns
	^1! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:43'!
benchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	100000 timesRepeat: [ 
		connection execute: 
			'INSERT INTO big_benchmark_insert
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')'
		querySettings: self querySetting ].
	connection close.	! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:43'!
benchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	(connection execute: 'SELECT * FROM big_benchmark_select'
		querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].
	connection := self createDbxConnection.! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:45'!
initialize
	super initialize.
	DBXBenchmark facility: DBXMySQLFacility facilityForBenchmark.
	self initializeDatabase.
	self initializeConnection.! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:45'!
initializeConnection
	| spec |
	spec := JdmConnectionSpec new initialize database: 'sodbxtest';				
				host: (NetNameResolver addressForName: 'localhost');
				 port: 3306;
				 user: 'sodbxtest';
				 password: 'sodbxtest'.
	connection := JdmConnection on: spec.! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/21/2009 00:17'!
setUpBenchmarkInsert100000
	| conn |
	conn := self createDbxConnection.
	[ conn execute: 'DROP TABLE big_benchmark_insert' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptInsert do: 
		[ :script | 
		conn execute: script ].
	conn close! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:43'!
setUpBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	[ connection execute: 'DROP TABLE big_benchmark_select' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptSelect do: 
		[ :script | 
		connection execute: script ].
	100000 timesRepeat: 
		[ connection execute: 'INSERT INTO big_benchmark_select
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].
	connection close! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:43'!
tearDownBenchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_insert'.
	connection close.! !

!MysqlBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:43'!
tearDownBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_select'.
	connection close.! !

DBXBenchmark subclass: #MysqlTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 17:47'!
benchmarkInsert
	| statement |
	statement := connection createStatement.
	self class defaultInserts
		timesRepeat: [statement executeQuery: 'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')']! !

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 18:57'!
benchmarkInsertConverted
	| date dateAndTime statement |
	
	date := Date current. 
	dateAndTime := DateAndTime current. 
	statement := connection createStatement.
	1 to: self class defaultInserts do: [ :i |  
		statement executeQuery: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: dateAndTime asDbxString;
						yourself)) ]
! !

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 18:53'!
benchmarkSelect10
	| statement resultSet dic |
	statement := connection createStatement.
	resultSet := statement executeQuery: 'SELECT * FROM tiny_benchmark_10'.
	[resultSet next]
		whileTrue: [dic := resultSet currentRowAsDictionary]! !

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 18:54'!
benchmarkSelect100
	| statement resultSet dic |
	statement := connection createStatement.
	resultSet := statement executeQuery: 'SELECT * FROM tiny_benchmark_100'.
	[resultSet next]
		whileTrue: [dic := resultSet currentRowAsDictionary]! !

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 18:54'!
benchmarkSelect1000
	| statement resultSet dic |
	statement := connection createStatement.
	resultSet := statement executeQuery: 'SELECT * FROM tiny_benchmark_1000'.
	[resultSet next]
		whileTrue: [dic := resultSet currentRowAsDictionary]! !

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'MMP 8/2/2009 21:36'!
benchmarkSelect10000
	| statement resultSet dic |
	statement := connection createStatement.
	resultSet := statement executeQuery: 'SELECT * FROM tiny_benchmark_10000'.
	[resultSet next]
		whileTrue: [dic := resultSet currentRowAsDictionary]! !

!MysqlTinyBenchmarks methodsFor: 'initialization' stamp: 'HMC 4/11/2009 17:07'!
initialize
	DBXBenchmark facility: DBXMySQLFacility facilityForBenchmark.
	super initialize.
	self initializeDatabase.
	self initializeConnection.! !

!MysqlTinyBenchmarks methodsFor: 'initialization' stamp: 'HMC 4/11/2009 17:10'!
initializeConnection
	| spec |
	spec := JdmConnectionSpec new initialize database: 'sodbxtest';				
				host: (NetNameResolver addressForName: 'localhost');
				 port: 3306;
				 user: 'sodbxtest';
				 password: 'sodbxtest'.
	connection := JdmConnection on: spec.! !

!MysqlTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 16:54'!
setUp
	| conn |
	conn := self createDbxConnection.
	self prepareInsert: conn.
	conn close.! !

DBXBenchmark subclass: #PGBigBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!PGBigBenchmarks class methodsFor: 'defaults' stamp: 'HMC 8/13/2009 23:53'!
defaultRuns
	^1! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:53'!
benchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	100000 timesRepeat: [ 
		connection execute: 
			'INSERT INTO big_benchmark_insert
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')'
		querySettings: self querySetting ].
	connection close.	! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:53'!
benchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	(connection execute: 'SELECT * FROM big_benchmark_select'
		querySettings: self querySetting)
		ifNotNilDo: [ :resultSet | resultSet rowsDo: [ :each | each values ] ].
	connection := self createDbxConnection.! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/20/2009 23:35'!
initialize
	super initialize.
	DBXBenchmark facility: DBXPostgreFacility facilityForBenchmark.
	self initializeDatabase.
	self initializeConnection.! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:55'!
initializeConnection
	connection := PGConnection new
		connectionArgs: (PGConnectionArgs new
			hostname: 'localhost';
			portno: 5432;
			databaseName: 'sodbxtest';
			userName: 'sodbxtest';
			password: 'sodbxtest');
		yourself.
	connection startup.
! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/21/2009 00:12'!
setUpBenchmarkInsert100000
	| conn |
	conn := self createDbxConnection.
	[ conn execute: 'DROP TABLE big_benchmark_insert' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptInsert do: 
		[ :script | 
		conn execute: script ].
	conn close! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/21/2009 00:13'!
setUpBenchmarkSelect100000
	| conn |
	conn := self createDbxConnection.
	[ conn execute: 'DROP TABLE big_benchmark_select' ] 
		on: DBXError
		do: 
			[ :e | 
			"DROP fails"
			 ].
	self facility bigBenchmarkScriptSelect do: 
		[ :script | 
		conn execute: script ].
	100000 timesRepeat: 
		[ conn execute: 'INSERT INTO big_benchmark_select
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ].
	conn close! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:53'!
tearDownBenchmarkInsert100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_insert'.
	connection close.! !

!PGBigBenchmarks methodsFor: 'running' stamp: 'HMC 8/13/2009 23:53'!
tearDownBenchmarkSelect100000
	| connection |
	connection := self createDbxConnection.
	connection execute: 'DROP TABLE big_benchmark_select'.
	connection close.! !

DBXBenchmark subclass: #PGTinyBenchmarks
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Benchmark'!

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 10:16'!
benchmarkInsert
	self class defaultInserts timesRepeat: [ 
		connection execute: 
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES 
				(1.0, 1.0, 1.0, 1, ''test'', ''test'', ''2008-01-01'', ''2008-01-01 10:00:00'')' ]
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 10:11'!
benchmarkInsertConverted
	| date dateAndTime |
	
	date := Date current. 
	dateAndTime := DateAndTime current. 
	1 to: self class defaultInserts do: [ :i |  
		connection execute: (
			'INSERT INTO tiny_benchmark_insert  
				(num1, num2, num3, num4, str1, str2, date1, date2)
			VALUES ({1}, {2}, {3}, {4}, {5}, {6}, {7}, {8})' 
					format: (OrderedCollection new
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asFloat asDbxString;
						add: i asDbxString;
						add: i asString asDbxString;
						add: i asString asDbxString;
						add: date asDbxString;
						add: dateAndTime asDbxString;
						yourself)) ]
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'HMC 4/11/2009 18:54'!
benchmarkSelect10
	(connection  execute: 'SELECT * FROM tiny_benchmark_10') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:53'!
benchmarkSelect100
	(connection  execute: 'SELECT * FROM tiny_benchmark_100') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 11:54'!
benchmarkSelect1000
	(connection  execute: 'SELECT * FROM tiny_benchmark_1000') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'MMP 8/2/2009 20:37'!
benchmarkSelect10000
	(connection  execute: 'SELECT * FROM tiny_benchmark_10000') lastResultSet 
		in: [ :resultSet |
			resultSet rows do: [ :each | each data ] ]  ! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'HMC 4/11/2009 17:07'!
initialize
	DBXBenchmark facility: DBXPostgreFacility facilityForBenchmark.
	super initialize.
	self initializeDatabase.
	self initializeConnection! !

!PGTinyBenchmarks methodsFor: 'initialization' stamp: 'EL 7/26/2008 13:07'!
initializeConnection
	connection := PGConnection new
		connectionArgs: (PGConnectionArgs new
			hostname: 'localhost';
			portno: 5432;
			databaseName: 'sodbxtest';
			userName: 'sodbxtest';
			password: 'sodbxtest');
		yourself.
	connection startup.
! !

!PGTinyBenchmarks methodsFor: 'running' stamp: 'EL 8/20/2008 09:35'!
setUp
	| conn |
	conn := self createDbxConnection.
	self prepareInsert: conn.
	conn close.! !

Object subclass: #DBXColumnDescription
	instanceVariableNames: 'type dbxType name size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'HMC 8/16/2008 21:16'!
name: aString dbxType: aNumber type: aType
"this instantiates a new DBXColumnDescription with a type size of zero"
	^self name: aString dbxType: aNumber type: aType size: 0! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'HMC 8/16/2008 21:18'!
name: aNameString dbxType: aNumber type: aTypeSymbol size: aTypeSizeNumber
"this instantiates a new DBXColumnDescription, whitch will hold the name, data type and size of the data type the rows from the database have"
	^(super new)
		name: aNameString;
		type: aTypeSymbol;
		size: aTypeSizeNumber;
		yourself.! !

!DBXColumnDescription class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 11:58'!
new
	self error: 'Use caption:type:'! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:56'!
dbxType
"this is the data type of this column, according to its data type from the database"
	^ dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 8/3/2008 08:45'!
dbxType: anObject
	dbxType := anObject! !

!DBXColumnDescription methodsFor: 'testing' stamp: 'HMC 8/16/2008 20:54'!
isLarge
"see DBXPlatform isLarge"
	^DBXPlatform isLarge: self dbxType! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:57'!
name
"this is the name of this column, according to its database name, "
	^name! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:49'!
name: aString
	name := aString! !

!DBXColumnDescription methodsFor: 'printing' stamp: 'EL 6/27/2008 20:45'!
printOn: aStream
	aStream nextPut: $(.
	self name printOn: aStream.
	aStream nextPut: $:.
	self type printOn: aStream.
	aStream nextPut: $).! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:15'!
size
"size of the data type"
	^size! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 6/27/2008 19:50'!
size: aNumber
	size := aNumber! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 20:59'!
type
"type of the data that a column description holds"
	^ type! !

!DBXColumnDescription methodsFor: 'accessing' stamp: 'EL 3/31/2008 11:24'!
type: anObject
	type := anObject! !

Object subclass: #DBXConnection
	instanceVariableNames: 'platform settings handle open connected result transactionOpened encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnection class methodsFor: 'initialization' stamp: 'MMP 4/15/2008 00:37'!
initialize
	"DBConnection initialize"

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!DBXConnection class methodsFor: 'logging' stamp: 'EL 5/12/2008 18:50'!
log: message
	Transcript show: message; cr.! !

!DBXConnection class methodsFor: 'instance creation' stamp: 'EL 7/1/2008 16:51'!
platform: aPlatform settings: aConnectionSettings
	^self new
		platform: aPlatform;
		settings: aConnectionSettings;
		yourself! !

!DBXConnection class methodsFor: 'system startup' stamp: 'MMP 9/14/2008 20:03'!
shutDown
	self
		allInstancesDo: [:each | each shutDown]! !

!DBXConnection class methodsFor: 'system startup' stamp: 'EL 7/1/2008 20:52'!
startUp
	"Right now i do nothing in the startup. Perhaps in a future I should open the connections that were closed when the image was down"
"	self allInstancesDo: [ :each| each startUp ]."! !

!DBXConnection methodsFor: 'comparing' stamp: 'EL 5/12/2008 18:45'!
= aDBXConnection
	^ self handle = aDBXConnection handle.! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/4/2009 00:33'!
authenticationMethod
	^ settings method! !

!DBXConnection methodsFor: 'release' stamp: 'Mariano 3/28/2010 16:32'!
cleanUp
"It cleanUps all the necessary stuff from the connection so that it can be safetly used in another context, without needing to close it and open it again. For example, if the last query with this connection, did not finish to get all resultSets and raws, it will do it. If there was a transaction opened, it will be rollbacked.
This methos is useful for a ConnectionPool. When someone gives to back a connection (because it is not used anymore) con can send this message and after this, the connection should be perfectly avaiable for another user."
	self rollbackCurrentTransaction.
	self releasePreviousResult.
	! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'Mariano 3/27/2010 22:11'!
close
	"It closes the connection releasing all the results. It will probably free tcp/ip database connection. You must re open it in order to execute more queries"
	self isOpen
		ifFalse: [SqueakDBXError signal: 'The connection is not open. Try opening it first'].
	self releasePreviousResult.
	self platform closeConnection: self.
	transactionOpened := false.
	self internalBeClosed! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'Mariano 3/27/2010 21:05'!
commit
	"executes a commit statement"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot commit if the connection is not open' ].
	self result ifNotNil: [ self releaseResult ].
	aResult := self platform commit: self.
	transactionOpened := false.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MarianoMartinezPeck 9/1/2010 20:04'!
connect
	"This is the first method that must be called to a connection. It connects to database host and creates all the data structure for a connection. After it, you can call open. You cannot connect an already connected connection"
	self isConnected
		ifTrue: [SqueakDBXError signal: 'You are already connected. Try disconnecting first' ].
	self validateSettingsForConnect.
	"WARNING This is the only place where we have direct access to
	handles... "
	handle := self platform createConnection: self.
	
	self platform class isAutomaticConnectionReleaseOnGC ifTrue: [
		SqueakDBXSmalltalkDialect current addObjectToGarbageCollect: self].
	
	self internalBeConnected.
	
! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 3/1/2009 15:43'!
connectAndOpen
"Take into consideration that using this method you cannot specify special options because 
many of them should be called between connect and open operations
In case you don't want to use any SqueakDBX special options, you can use this message. However, we recommend to use connect and open separately"	
	self connect.
	self open.! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/4/2009 00:32'!
database
	^ settings database! !

!DBXConnection methodsFor: 'encoding' stamp: 'PanuSuominen 9/10/2010 09:52'!
decodeString: aByteArray
	"Decodes system string from encoded representation."

	^ encoder isNil ifTrue:[aByteArray ] ifFalse: [encoder convertFromSystemString: aByteArray].! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:42'!
disconnect
	" Disconnect from database releasing all resultSets. No operation will be permitted after it. It must be call when you finish using the connection. If the connection wasn't close, it will do it. In order to do a disconnection, the connection must be connected'"
	self isConnected
		ifFalse: [^ nil].
	self isOpen
		ifTrue: [self close].
	self releaseConnection.
	self internalBeDisconnected.
	handle := nil! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableCompression
	"It tries to enable Compression option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions compression.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 6/1/2009 21:05'!
enableEncryption: aEncryptionOption
"It tries to enable Encryption option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions encryption.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:29'!
enableMultipleStatements
"It tries to enable Multiple Statements option. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions multipleStatements! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:30'!
enablePagedResults
"It tries to enable paged results. If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	^self enableSpecialOption: DBXSpecialOptions pagedResults.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/9/2009 16:56'!
enableSpecialModes: modes 
	"It tries to enable specific modes. For example MySQL special modes (http://dev.mysql.com/doc/refman/5.0/en/server-sql-mode.html). If it can, it activates the option, returns true and you can use that option. If not, it will return false. So you must ask the return on this method in order to now what to do."
	(self isOptionSupportedByPlattform: DBXSpecialOptions specialModes) ifTrue: 
		[ self platform 
			setOption: DBXSpecialOptions specialModes
			value: modes
			on: self.
		^ true ].
	^ false! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:34'!
enableSpecialOption: specialOption 
	"It returns if the specialOption could be enable or not.
	Before enabling a specific option, I must be sure the current backend
	support it"
	(self isOptionSupportedByPlattform: specialOption)
		ifTrue: [self platform
				setOption: specialOption
				value: true
				on: self.
				^true.].
		^false.
! !

!DBXConnection methodsFor: 'encoding' stamp: 'PanuSuominen 9/10/2010 09:53'!
encodeString: aString
	"Encodes system string to some format"

	^ encoder isNil ifTrue:[aString] ifFalse:[ encoder convertToSystemString: aString].! !

!DBXConnection methodsFor: 'query' stamp: 'Mariano 3/27/2010 20:23'!
execute: aString 
	"This message is used for ALL type of query: SQL, DML and DDL.
	Depending on the type of query it will return DBXResult or
	DBXResultSet. 
	The queries sent to the server must be understood by the DBMS because
	there is no translation done between the different dialects of SQL for
	example. 
	To execute a query you must be connected and open.
	You DON'T need to call nextRow till nil its returned, the framework will
	do it for you in your next query. 
	If you want multistatement queries, you must use executeMultiStatement:
	
	"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot execute a query if the connection is not open' ].
	self releasePreviousResult.
	aResult := self platform 
		executeStatement: aString
		on: self.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'query' stamp: 'Mariano 3/27/2010 20:25'!
execute: aString querySettings: aQuerySettings 
	"Same as execute, but it ads a query settings.
	A query settigs has two things: pageSize and timeout.
	
	Page size: Dependent on the native
	database library, it may be possible to retrieve all rows at once (if the
	page size parameter is zero), one by one or more than one row at once.
	All positive values including zero are allowed as values for the page size If
	paging (more than one row at once) is not supported by the backend, it
	will use one by one or all at once if this is the only option provided.
	
	Timeout: Restricts the time SqueakDBX is waiting for a result form the server. 
	It may be nil to wait until a result arrives. Otherwise, it can contain any number 
	of seconds and microseconds to wait for.
	
	"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot execute a query if the connection is not open' ].
	self releasePreviousResult.
	aResult := self platform 
		executeStatement: aString
		on: self
		querySettings: aQuerySettings.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 6/1/2009 21:13'!
executeDDLScript: aDDLScript 
"Its very common you need to execute a complete DDL script: create, drop or alter tables. In these cases, you don't have any interesting results from each query. In such a case, you should use this method. Remember SqueakDBX doesn't do any translation so your statement delimiter must be understood by the backend. In order to know which delimiter we use, you can see the message queryDelimiter of the current platform backend, for example DBXPostgresPlatform.
This message doesn't use the multistatements option of openDBX, it is all done by SqueakDBX so you don't have to care about it"

	| ddlStatements |
	ddlStatements := aDDLScript findTokens: self platform queryDelimiter.
	ddlStatements
		do: [:ddlStatement | self execute: ddlStatement]! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 6/1/2009 21:14'!
executeMultiStatement: aString
	"This message is used when you must use multistatement, stored procedures or functions.
	It returns a DBXMultiStatementResultSetIterator. 
	The queries sent to the server must be understood by the DBMS because
	there is no translation done between the different dialects of SQL for
	example. 
	To execute a query you must be connected and open.
	
	You DON'T need to call next till nil its returned, the framework will
	do it for you in your next query.
	"
		
	| multiStatmentIterator |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot execute a query if the connection is not open' ].
	self result ifNotNil: [ self result releaseResult ].
	multiStatmentIterator := self platform 
		executeMultiStatement: aString
		on: self.
	self result: multiStatmentIterator.
	^ self result! !

!DBXConnection methodsFor: 'finalization' stamp: 'MMP 8/12/2008 01:18'!
finalize
	" If it is connected, it will disconnect it"
	self isConnected ifTrue: [ self disconnect ]! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 3/30/2008 14:41'!
handle
	^handle! !

!DBXConnection methodsFor: 'comparing' stamp: 'MMP 5/1/2008 18:37'!
hash
	^ self handle hash! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/4/2009 00:18'!
host
	^ settings host! !

!DBXConnection methodsFor: 'initialization' stamp: 'PanuSuominen 9/10/2010 10:03'!
initialize
	super initialize.
	"These ValueHolder are very important and you cannot change them. If you instantiate a DBXConnection and never do the disconnect, SqueakDBX will do it whe the object is garbage collected. How SqueakDBX do that? DBXConnection is registered in the default WeakRegistry. So, when you call connect we add the object to that registry. In that moment a clone is generated from the original object. Suppose you then do the disconnect to the original object. If we don't use ValueHolder, the clone will have other objects for open and connected and because of this, the disconnect will be called twice, generating an openDBX error.' "
	open := ValueHolder new contents: false.
	connected := ValueHolder new contents: false.
	result := nil.
	transactionOpened := false.! !

!DBXConnection methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:59'!
initializePlatform: aPlatform settings: aConnectionSettings handle: aNumber
	platform := aPlatform.
	settings := aConnectionSettings.
	handle := aNumber.
	self internalBeConnected.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeClosed
	open contents: false! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeConnected
	connected contents: true.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeDisconnected
	connected contents: false.! !

!DBXConnection methodsFor: 'private' stamp: 'EL 6/27/2008 08:58'!
internalBeOpen
	open contents: true.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isConnected
	^connected contents.! !

!DBXConnection methodsFor: 'testing' stamp: 'MMP 4/25/2008 00:44'!
isOpen
	^open contents.! !

!DBXConnection methodsFor: 'options' stamp: 'MMP 8/12/2008 01:32'!
isOptionSupportedByPlattform: specialOption 
"It returns if the specialOption is supported by the backend"
	^self platform
		getOption: specialOption
		on: self.! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'PanuSuominen 9/2/2010 21:14'!
open
	"Opens the connection. You must first do a connect and you cannot call this method if the connection is already open.. This method will probably opens the tcp/ip database connection. After calling this method, you should be able to send queries"
	self isConnected ifFalse: [
		SqueakDBXError signal: 'You are not connected. Try connecting first'].
	self isOpen ifTrue: [ 
		SqueakDBXError signal: 'The connection is already open'].
	self validateSettingsForOpen.
	"If it's a fatal error, it means it couldn't open the connection, therefore, we just disconnect it and signal the error again"
	[ self platform openConnection: self.] 
		on: DBXFatalError 
		do: [ :aFatalError | 
			self disconnect.
			aFatalError signal ].
	self internalBeOpen.
	self setEncoding.! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/10/2008 01:06'!
platform
	^platform! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
platform: aPlatform
	platform := aPlatform! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/4/2009 00:18'!
port
	^ settings port! !

!DBXConnection methodsFor: 'query' stamp: 'MMP 6/4/2009 01:30'!
processNextResultSetMultiStatement: aQuerySettings
	"proccess and obtains the next resultset"
	^ self platform processNextResultSet: self querySettings: aQuerySettings! !

!DBXConnection methodsFor: 'encoding' stamp: 'PanuSuominen 9/2/2010 21:21'!
queryEncoding
	"I return prefered encoding for my self. I need the help of my platform to do it but it
	is possible that the platform has no idea about the encoding. "
	^(self platform queryEncoding: self).! !

!DBXConnection methodsFor: 'connection open/close' stamp: 'MMP 12/22/2008 20:51'!
reOpen: aConnectionSettings
	"It simply do a close and an open with the new connectionSettings. 
	Suppouse you have a DBXConnection connected and open. Sometimes it may be necessary to connect to a different database (schema) or re-authenticate using different credentials. In such a case you can use this message"
	self isConnected ifFalse: [
		SqueakDBXError signal: 'You are not connected. Try connecting first' ].
	self isOpen ifFalse: [ 
		SqueakDBXError signal: 'The connection must be open in order to reOpen it' ].
	self close.
	self settings: aConnectionSettings.
	self open.! !

!DBXConnection methodsFor: 'release' stamp: 'MMP 6/4/2009 00:43'!
releaseConnection
	self platform disconnectConnection: self! !

!DBXConnection methodsFor: 'finalization' stamp: 'Mariano 3/27/2010 22:06'!
releasePreviousResult
	"If there is, I must release the previous query"
	self result ifNotNil: [ self result releaseResult ].
	self result: nil.! !

!DBXConnection methodsFor: 'release' stamp: 'MMP 6/1/2009 21:31'!
releaseResult
	 self result releaseResult ! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 2/2/2009 19:14'!
result
	^ result! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 2/2/2009 19:14'!
result: anObject 
	result := anObject! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'Mariano 3/27/2010 21:04'!
rollback
	"executes a rollback statement"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot rollback if the connection is not open' ].
	self result ifNotNil: [ self releaseResult ].
	aResult := self platform rollback: self.
	transactionOpened := false.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'Mariano 3/27/2010 21:07'!
rollbackCurrentTransaction
	transactionOpened ifTrue: [self rollback].
	transactionOpened := false.! !

!DBXConnection methodsFor: 'encoding' stamp: 'PanuSuominen 9/10/2010 09:59'!
setEncoding
	"Sets the encoding based on encoding strategy."

	self settings encodingStrategy isNil
		ifFalse: [ encoder := self settings encodingStrategy encoderFor: self ]! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:42'!
settings
	^ settings! !

!DBXConnection methodsFor: 'accessing' stamp: 'EL 7/1/2008 16:54'!
settings: aConnectionSettings
	settings := aConnectionSettings! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 6/1/2009 21:22'!
shutDown
	"This message is called when the object is garbage collected. In case the connection was connected, but not disconnected, it will be disconnected"
	 self isConnected ifTrue: [
		 [self disconnect] on: Error do: [:e | Transcript show: e ] ]
! !

!DBXConnection methodsFor: 'transactional manage' stamp: 'Mariano 3/27/2010 21:04'!
startTransaction
	"executes a start transaction statement"
	| aResult |
	self isOpen ifFalse: 
		[ SqueakDBXError signal: 'You cannot start a transaction if the connection is not open' ].
	self result ifNotNil: [ self releaseResult ].
	aResult := self platform startTransaction: self.
	transactionOpened := true.
	self result: aResult.
	^ self result! !

!DBXConnection methodsFor: 'running' stamp: 'MMP 8/12/2008 01:54'!
startUp
	"till now, nothing is done on the startup"! !

!DBXConnection methodsFor: 'accessing' stamp: 'Mariano 3/27/2010 21:39'!
transactionOpened 
	^ transactionOpened ! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/4/2009 00:32'!
userName
	^ settings userName! !

!DBXConnection methodsFor: 'accessing' stamp: 'MMP 6/4/2009 00:33'!
userPassword
	^ settings userPassword! !

!DBXConnection methodsFor: 'validating' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForConnect
	self settings validatePort.! !

!DBXConnection methodsFor: 'validating' stamp: 'MMP 7/10/2008 23:25'!
validateSettingsForOpen
	self settings method.! !

Object subclass: #DBXConnectionSettings
	instanceVariableNames: 'host port database userName userPassword method encodingStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:13'!
host: aHost port: aPort
	^ self basicNew
		initializeHost: aHost 
			port: aPort;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'PanuSuominen 9/10/2010 10:25'!
host: aHost port: aPort database: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aHost 
			port: aPort 
			database: aDatabase 
			userName: aUsername  
			userPassword: aPassword
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'PanuSuominen 9/10/2010 10:26'!
host: aHost port: aPort database: aDatabase userName: aUsername userPassword: aPassword encodingStrategy: encodingStrategy
	^ self basicNew
		initializeHost: aHost 
			port: aPort 
			database: aDatabase 
			userName: aUsername  
			userPassword: aPassword;
			encodingStrategy: encodingStrategy;
		yourself! !

!DBXConnectionSettings class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 09:32'!
host: aDatabase userName: aUsername userPassword: aPassword
	^ self basicNew
		initializeHost: aDatabase 
			userName: aUsername  
			userPassword: aPassword
		yourself! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
database
	^ database! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
database: anObject
	database := anObject! !

!DBXConnectionSettings methodsFor: 'encoding' stamp: 'PanuSuominen 9/10/2010 10:29'!
encodingStrategy
	"See encodingStrategy:"
	^encodingStrategy.
! !

!DBXConnectionSettings methodsFor: 'encoding' stamp: 'PanuSuominen 9/1/2010 18:35'!
encodingStrategy: anObject
	"Encoding strategy used to determine actaul TextConverter to be used with database connections. Encoding strategy must be able to respond #encoderFor: -message and return TextConverter."

	encodingStrategy := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
host
	^ host! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
host: anObject
	host := anObject! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:11'!
initializeHost: aHost port: aPort
	self initialize.
	host := aHost.
	port := aPort! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:12'!
initializeHost: aHost port: aPort database: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	host := aHost.
	port := aPort.
	database := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'initialization' stamp: 'EL 6/29/2008 09:13'!
initializeHost: aDatabaseName userName: aUserName userPassword: aPassword
	self initialize.
	database  := aDatabaseName.
	userName := aUserName.
	userPassword := aPassword.! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/11/2008 00:24'!
method
	^ method ifNil: [ method := DBXAuthenticationMethod usernamePassword ]! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
method: anObject
	^ method := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 6/10/2008 00:50'!
port
	^ port! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
port: anObject
	port := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userName
	^ userName! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userName: anObject
	userName := anObject! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'EL 6/29/2008 09:07'!
userPassword
	^ userPassword! !

!DBXConnectionSettings methodsFor: 'accessing' stamp: 'MMP 7/9/2008 23:38'!
userPassword: anObject
	userPassword := anObject! !

!DBXConnectionSettings methodsFor: 'validating' stamp: 'MMP 12/22/2008 20:54'!
validateMethod
	self method notNil ifTrue: 
		[ self method = DBXAuthenticationMethod usernamePassword ifFalse: [ SqueakDBXError signal: 'The only supported method is zero' ] ]! !

!DBXConnectionSettings methodsFor: 'validating' stamp: 'MMP 6/1/2009 22:15'!
validatePort
	(self port notNil and: [ port ~= ''] )
		ifTrue: [(self port asNumber > 0)
			ifFalse: [SqueakDBXError signal: 'The port must be a positive number']]! !

Object subclass: #DBXEncodingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding'!

DBXEncodingStrategy subclass: #DBXAutomaticEncoding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding'!

!DBXAutomaticEncoding commentStamp: '<historical>' prior: 0!
I am encoding strategy that asks the object about the encoding using message queryEncoding.!

!DBXAutomaticEncoding methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/25/2010 19:58'!
encoderFor: aConnection 
	| encoding |
	encoding := aConnection queryEncoding.
	^TextConverter newForEncoding: encoding.! !

!DBXEncodingStrategy methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 18:21'!
encoderFor: anObject
	"I will return instance of TextConverter to convert data related to given object.
	The method of deciding how to encode the data depends on the implementation."
	self subclassResponsibility.! !

!DBXEncodingStrategy methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 18:17'!
encodingFor: anObject
	"I will return instance of TextConverter to convert data related to given object.
	The method of deciding how to encode the data depends on the implementation."
	self subclassResponsibility.! !

DBXEncodingStrategy subclass: #DBXNoEncoding
	instanceVariableNames: ''
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding'!

!DBXNoEncoding commentStamp: '<historical>' prior: 0!
I am encoding strategy for the cases where no encoding is required.!

!DBXNoEncoding class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 9/1/2010 18:31'!
instance
	^instance ifNil: [instance := self new].! !

!DBXNoEncoding methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/25/2010 19:33'!
encoderFor: anObject 
	^DBXNullTextConverter instance.! !

DBXEncodingStrategy subclass: #DBXStaticEncoding
	instanceVariableNames: 'encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Encoding'!

!DBXStaticEncoding commentStamp: '<historical>' prior: 0!
I am encoding strategy that simply returns predetermined TextConverter. Actually a copy of it.

Instance Variables:
	encoder	TextConverter which is copied when encoderFor: is called.!

!DBXStaticEncoding class methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/31/2010 20:52'!
newForEncoding: nameOfEncoding
	|o|
	o := self basicNew.
	o encoder: (TextConverter newForEncoding: nameOfEncoding).
	^o.! !

!DBXStaticEncoding methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/31/2010 20:50'!
encoder: aTextConverter 
	encoder := aTextConverter.! !

!DBXStaticEncoding methodsFor: 'as yet unclassified' stamp: 'PanuSuominen 8/31/2010 20:53'!
encoderFor: anObject
	^encoder copy.! !

Object subclass: #DBXEncryptionValues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXEncryptionValues class methodsFor: 'values' stamp: 'MMP 8/24/2008 16:58'!
always
	^2! !

!DBXEncryptionValues class methodsFor: 'values' stamp: 'MMP 8/23/2008 21:01'!
never
	^0! !

!DBXEncryptionValues class methodsFor: 'values' stamp: 'MMP 8/23/2008 21:01'!
try
	^1! !

Object subclass: #DBXErrorSeverity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXErrorSeverity class methodsFor: 'as yet unclassified' stamp: 'MMP 6/3/2009 23:59'!
isFatal: aErrorType
	^ aErrorType < 0! !

!DBXErrorSeverity class methodsFor: 'as yet unclassified' stamp: 'MMP 6/4/2009 00:02'!
isNotAnError: aErrorType
	^ aErrorType = 0! !

!DBXErrorSeverity class methodsFor: 'as yet unclassified' stamp: 'MMP 6/4/2009 00:02'!
isRecoverable: aErrorType
	^ aErrorType > 0! !

Object subclass: #DBXLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXLogger methodsFor: 'as yet unclassified' stamp: 'MMP 11/25/2008 01:32'!
log
	! !

Object subclass: #DBXPlatform
	instanceVariableNames: ''
	classVariableNames: 'Properties'
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

DBXPlatform class
	instanceVariableNames: 'dataTypesMap'!

!DBXPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the platform abstraction layer. 
I comunicate directly with OpenDBX, and provide a fplatform specific abstraction layer. !

DBXPlatform class
	instanceVariableNames: 'dataTypesMap'!

DBXPlatform subclass: #DBXFirebirdPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXFirebirdPlatform methodsFor: 'accessing' stamp: 'mariano 12/19/2009 20:13'!
backend
	^ 'firebird'! !

!DBXFirebirdPlatform methodsFor: 'resultSet' stamp: 'Mariano 12/20/2009 15:54'!
queryDelimiter
	^';'! !

!DBXFirebirdPlatform methodsFor: 'transactional manage' stamp: 'Mariano 12/20/2009 15:37'!
startTransaction
	^'SET TRANSACTION READ WRITE'! !

DBXPlatform subclass: #DBXMSSQLPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMSSQLPlatform methodsFor: 'accessing' stamp: 'MMP 11/30/2008 21:10'!
backend
	^'mssql'! !

!DBXMSSQLPlatform methodsFor: 'resultSet' stamp: 'MMP 12/2/2008 00:00'!
queryDelimiter
	^';'! !

!DBXMSSQLPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 23:12'!
startTransaction
	"It returns the start transaction statement most commonly used by the backends"
	^'BEGIN TRANSACTION'! !

DBXPlatform subclass: #DBXMySQLPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMySQLPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the MySQL specific platform definition. 

Instance Variables
	handle:		<Object>

handle
	- xxxxx
!

DBXMySQLPlatform subclass: #DBXMySQL4Platform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXMySQL4Platform methodsFor: 'options' stamp: 'MarianoMartinezPeck 10/5/2009 20:19'!
setNecessarySpecialOptions: aConnection 
	"To get MySQL4 working, you always need to enable a special mode with an empy string"
	aConnection enableSpecialModes: ''. ! !

!DBXMySQLPlatform class methodsFor: 'defaults' stamp: 'MarianoMartinezPeck 2/12/2010 20:20'!
createDataTypesMap
	^super createDataTypesMap
		at: 16r20 put: String; "CLOB"
		at: 16r2F put: ByteArray;  "BLOB"
		yourself
		! !

!DBXMySQLPlatform methodsFor: 'accessing' stamp: 'EL 6/27/2008 20:30'!
backend
	^'mysql'! !

!DBXMySQLPlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

DBXPlatform subclass: #DBXOdbcPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXOdbcPlatform methodsFor: 'accessing' stamp: 'MMP 11/30/2008 21:30'!
backend
	^'odbc'! !

!DBXOdbcPlatform methodsFor: 'resultSet' stamp: 'MMP 1/4/2009 23:47'!
queryDelimiter
	^';'! !

!DBXOdbcPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 23:12'!
startTransaction
	"It returns the start transaction statement most commonly used by the backends"
	^'BEGIN TRAN'! !

DBXPlatform subclass: #DBXOraclePlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXOraclePlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the Oracle specific platform definition. 

Instance Variables
	handle:		<Object>

handle
	- xxxxx
!

!DBXOraclePlatform class methodsFor: 'defaults' stamp: 'MarianoMartinezPeck 2/13/2010 18:20'!
createDataTypesMap
	^super createDataTypesMap
		at: 16r20 put: String; "CLOB"
		at: 16r2F put: ByteArray;  "BLOB"
		yourself
		! !

!DBXOraclePlatform methodsFor: 'accessing' stamp: 'MMP 8/6/2008 01:38'!
backend
	^'oracle'! !

!DBXOraclePlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

!DBXOraclePlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 23:12'!
startTransaction
	"This is a general approach for starting a transaction. If other approach is wanted, like SET TRANSACTION READ ONLY, you 	must do it manually like any other query."
	^'SET TRANSACTION READ WRITE'! !

!DBXPlatform class methodsFor: 'defaults' stamp: 'MMP 6/4/2009 23:38'!
createDataTypesMap
	"Creates and returns a map that maps Smalltalk classes to SQL datatypes.
	The 16r means it is hexadecimal."
	^Dictionary new
		at: 16r00 put: Boolean; "BOOLEAN"
		at: 16r01 put: Number; "SMALLINT"
		at: 16r02 put: Number; "INTEGER"
		at: 16r03 put: Number; "BIGINT"
		at: 16r07 put: Number; "DECIMAL"
		at: 16r08 put: Number; "REAL"
		at: 16r09 put: Number; "DOUBLE"
		at: 16r0F put: Number; "FLOAT"
		at: 16r10 put: String; "CHAR"
		at: 16r11 put: String; "NCHAR"
		at: 16r12 put: String; "VARCHAR"
		at: 16r13 put: String; "NVARCHAR"
		at: 16r20 put: (DBXTypeNotSupported type: #CLOB);
		at: 16r21 put: (DBXTypeNotSupported type: #NCLOB);
		at: 16r22 put: (DBXTypeNotSupported type: #XML);
		at: 16r2F put: (DBXTypeNotSupported type: #BLOB);
		at: 16r30 put: Time; "TIME"
		at: 16r31 put: Time; "TIMETZ"
		at: 16r32 put: TimeStamp; "TIMESTAMP"
		at: 16r33 put: TimeStamp; "TIMESTAMPTZ"
		at: 16r34 put: Date; "DATE"
		at: 16r35 put: (DBXTypeNotSupported type: #INTERVAL);
		at: 16r40 put: (DBXTypeNotSupported type: #ARRAY);
		at: 16r41 put: (DBXTypeNotSupported type: #MULTISET);
		at: 16r50 put: (DBXTypeNotSupported type: #DATALINK);
		at: 16rFF put: (DBXTypeNotSupported type: #UNKNOWN);
		yourself
! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'MMP 6/4/2009 23:37'!
dataTypeAt: aNumber
	"Returns the Smalltalk class associated with a particular SQL type."
	^self dataTypesMap at: aNumber ifAbsent: [ DBXTypeNotSupported code: aNumber ]! !

!DBXPlatform class methodsFor: 'accessing' stamp: 'MMP 6/4/2009 23:38'!
dataTypesMap
	"Returns a map that maps Smalltalk classes to SQL datatypes."
	^dataTypesMap ifNil: [ dataTypesMap := self createDataTypesMap ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MarianoMartinezPeck 9/1/2010 19:44'!
disableAutomaticConnectionReleaseOnGC
	self propertyAt: #automaticConnectionReleaseOnGC
 put: false! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MMP 9/28/2008 21:13'!
disableDebugMode
	self propertyAt: #debugMode put: false! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MarianoMartinezPeck 9/1/2010 19:44'!
enableAutomaticConnectionReleaseOnGC
	self propertyAt: #automaticConnectionReleaseOnGC
 put: true! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MMP 9/28/2008 21:13'!
enableDebugMode
	self propertyAt: #debugMode put: true! !

!DBXPlatform class methodsFor: 'testing' stamp: 'MarianoMartinezPeck 9/1/2010 19:45'!
isAutomaticConnectionReleaseOnGC

	^self propertyAt: #automaticConnectionReleaseOnGC ifAbsentPut: [ true ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:44'!
isDebugMode
	^self propertyAt: #debugMode ifAbsentPut: [ false ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 8/3/2008 08:53'!
isLarge: aNumber
	"Answer true if aNumber represents a large data object (BLOB, CLOB, NCLOB)"
	^#(16r20 16r21 16r2F) includes: aNumber! !

!DBXPlatform class methodsFor: 'logging' stamp: 'MMP 1/5/2009 21:07'!
log: messageBlockOrString
	self isDebugMode ifTrue: [
		Transcript show: messageBlockOrString value; cr.
		    "self log info: messageBlockOrString." ].! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:46'!
properties
	^Properties ifNil: [ Properties := Dictionary new ]! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:46'!
propertyAt: aSymbol
	^self properties at: aSymbol! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:47'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:47'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^self properties at: aSymbol ifAbsentPut: aBlock! !

!DBXPlatform class methodsFor: 'testing' stamp: 'EL 9/14/2008 08:47'!
propertyAt: aSymbol put: anObject
	^self properties at: aSymbol put: anObject! !

!DBXPlatform class methodsFor: 'defaults' stamp: 'MMP 6/4/2009 23:32'!
resetDataTypesMap
	dataTypesMap := nil.! !

!DBXPlatform methodsFor: 'accessing' stamp: 'MMP 3/1/2009 15:46'!
backend
	"Returns the name of the backend that OpenDBX understands for each RDBMS"
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 6/4/2009 00:42'!
closeConnection: aConnection
	"Closes the connection and throws a DBXError if an error occurs"
	| err |
	err := OpenDBX current apiUnbind: aConnection handle.
	self log: [ 'odbx_unbind called with values: handle = ', aConnection handle asString ].
	self verifyError: err handle: aConnection handle.
! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 22:37'!
commit
	"If a certain backend doesn't use this sintax, it must subclass and override this method."
	^ 'COMMIT'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 22:35'!
commit: aConnection
	"executes a commit statement on a connection"
	^self executeStatement: self commit on: aConnection.
! !

!DBXPlatform methodsFor: 'connection' stamp: 'MarianoMartinezPeck 9/1/2010 20:03'!
createConnection: aConnection 
	"It initializes and creates a handle for all further operations, and it is
	used within the OpenDBX library to identify the connection and to
	maintain connection information. Depending on the backend it can open
	a connection to the database server but often this is done not until
	performing authentication through 'openConnection:'
	throws an error if needed"
	| err handleArray handle |
	handleArray := WordArray with: 0.
	err := OpenDBX current
				apiInitialize: handleArray
				backend: self backend
				host: aConnection host
				port: aConnection port.
	self log: [ 'odbx_init called with values: backend = ', self backend, ' host = ', aConnection host, ' port = ', aConnection port asString ].
	handle := handleArray first.
	
	"If it fails here, it means it couldn't connect, so we let the signal pass'"	
	self verifyError: err handle: handle.	
	^ handle! !

!DBXPlatform methodsFor: 'private' stamp: 'MMP 12/22/2008 20:52'!
dbxSmallIntegerAsBoolean: aSmallInteger 
	aSmallInteger = 1 ifTrue: [ ^ true ].
	aSmallInteger = 0 ifTrue: [ ^ false ].
	SqueakDBXError signal: 'Cannot convert form SmallInteger to Boolean'! !

!DBXPlatform methodsFor: 'description' stamp: 'MarianoMartinezPeck 2/13/2010 15:24'!
descriptionForColumn: anIndex handle: aHandle on: aConnection
	"Returns a DBXColumnDescription of the column at anIndex from the resultset with aHandle from aConnection."
	"anIndex is Zero based"
	| columnName dbxType |
	columnName := OpenDBX current apiQueryColumnName: aHandle index: anIndex.
	"self log: 'apiQueryColumnName called with values: handle = ', aHandle asString, ' index = ', anIndex asString."
	dbxType := OpenDBX current apiQueryColumnType: aHandle index: anIndex. 
	"self log: 'apiQueryColumnType called with values: handle = ', aHandle asString, ' index = ', anIndex asString."
	^DBXColumnDescription 
		name: columnName
		dbxType: dbxType
		type: (self class dataTypeAt: dbxType).! !

!DBXPlatform methodsFor: 'description' stamp: 'MMP 6/4/2009 22:42'!
descriptionForResult: aHandle on: aConnection
	"Returns a DBXResultDescription of the query"
	| rowsAffected |
	rowsAffected := OpenDBX current apiQueryRowsAffected: aHandle.
	self log: [ 'odbx_rows_affected: called with values: resultSet handle = ', aHandle asString ].
	self  verifyError: rowsAffected on: aConnection. 
	^DBXResultDescription new
		rowsAffected: rowsAffected;
		yourself.
! !

!DBXPlatform methodsFor: 'description' stamp: 'MMP 6/4/2009 22:42'!
descriptionForResultSet: aHandle on: aConnection 
	"Returns a DBXResultSetDescription of the query"
	| description columnCount |
	columnCount := OpenDBX current apiQueryColumns: aHandle.
	self log: [ 'odbx_column_count: called with values: resultSet handle = ', aHandle asString ].
	self verifyError: columnCount on: aConnection.
	description := DBXResultSetDescription new.
	0 to: columnCount - 1
		do: [:i | description
				addColumnDescription: (self
						descriptionForColumn: i
						handle: aHandle
						on: aConnection)].
	^ description! !

!DBXPlatform methodsFor: 'connection' stamp: 'MMP 6/4/2009 00:52'!
disconnectConnection: aConnection 
	"It releases all the resources associated with a connection"
	| err |
	err := OpenDBX current apiFinalize: aConnection handle.
	self log: 
		[ 'odbx_finish: called with values: handle = ' , aConnection handle asString ].
	self 
		verifyError: err
		handle: aConnection handle! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 23:09'!
endDBXResult: aConnection querySettings: aQuerySettings
	"Releases all query resultsSets a query may return by iterating them.
	Each resultSet is Closed and all allocated memory by the OpenDBX
	library is freed ."
	| resultCode |	
	[self
		nextResultSet: aConnection
		querySettings:  aQuerySettings
		onReturn: [:handle :code | 
			code = OpenDBX resultWithRows
				ifTrue: [ self releaseResultSet: handle connection: aConnection  ].
			resultCode := code]]
	doWhileFalse: [resultCode = OpenDBX resultDone].
	
! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 6/4/2009 23:11'!
errorCode: err handle: aHandle
	"This method manage errors that have occurred before a correct connection is created" 
	| type description |
	description := OpenDBX current apiError: aHandle number: err.
	description ifNil: [ description := 'Uknown message' ].
	type := OpenDBX current apiErrorType: aHandle number: err.
	"This method should only be called when there is no DBXConnection yet created with a valid handle.
	Because of this I don't have to release resultsets or things like that, just signal"
	(DBXErrorSeverity isFatal: type)
		ifTrue: [ DBXFatalError signal: description ].
	(DBXErrorSeverity isRecoverable: type)
		ifTrue: [ DBXRecoverableError signal: description ].
! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 6/4/2009 23:11'!
errorCode: err on: aConnection 
	"This method manage errors that have occurred after a correct connection is created" 
	| type description |
	description := OpenDBX current apiError: aConnection handle number: err.
	description ifNil: [ description := 'Uknown message' ].
	type := OpenDBX current apiErrorType: aConnection handle number: err.
	(DBXErrorSeverity isFatal: type)
		ifTrue: [
			"I have to close and disconnect the connection. They will also take care of releasing the results"
			aConnection close.
			aConnection disconnect.
			DBXFatalError signal: description].
	(DBXErrorSeverity isRecoverable: type)
		ifTrue: [
			"In this case I must free the resources of the results. 
			It may be the case where we have an error in the first query on a connection. In this case, the result is in 			nil so I can use the default query setting."
			aConnection result ifNil: [
				self endDBXResult: aConnection querySettings: DBXQuerySettings default .
			] ifNotNil: [
				self endDBXResult: aConnection querySettings: aConnection result querySettings .
			].
		DBXRecoverableError signal: description.
		].

! !

!DBXPlatform methodsFor: 'multistatement' stamp: 'MMP 6/4/2009 00:22'!
executeMultiStatement: aQuery on: aConnection 
	"It executes a multistatement query using the connection and can be used to retrieve all resultsets. 
	There are some important things:
    * this method returns a DBXMultiStatementResultSetIterator
    * The queries sent to the server must be understood by the DBMS because there is no translation done between the 	different dialects of SQL for example."
	^self executeMultiStatement: aQuery on: aConnection querySettings: DBXQuerySettings default.
! !

!DBXPlatform methodsFor: 'multistatement' stamp: 'PanuSuominen 9/1/2010 20:01'!
executeMultiStatement: aString on: aConnection querySettings: aQuerySettings 
	"This is similar to executeStatement: aString on: aConnection querySettings: aQuerySettings 
	with the difference that in this case the SAME query settings is used for all the subqueries of
	the multistatement query."
	| err multiStatmentIterator encodedQuery|
	encodedQuery := (aConnection encodeString: aString).
	err := OpenDBX current 
		apiQuery: aConnection handle
		query: encodedQuery 
		length: encodedQuery size.
	self log: 'odbx_query: called with values: handle = ' , aConnection handle asString , ' query = ' , aString.
	self 
		verifyError: err
		on: aConnection.
	multiStatmentIterator := DBXMultiStatementResultSetIterator 
		on: aConnection querySettings: aQuerySettings.
	^ multiStatmentIterator! !

!DBXPlatform methodsFor: 'query' stamp: 'MMP 1/31/2009 20:30'!
executeStatement: aQuery on: aConnection 
	"It executes the query using the connection and retrieve al rows at once (no pagination is used). 
	
There are some important things:

    * this method returns a DBXResultSet if it was a select statement and a DBXResult in case the query was an update, delete, insert, create, drop or any other DML query.
    * The queries sent to the server must be understood by the DBMS because there is no translation done between the different dialects of SQL for example. But this is desired!! It adds no further level of complexity to the library and your program which slows down your real work. Usually only a few statements with varying values are used in programs and the easiest way make them adaptable to different databases by the users is to get them from a configuration file, strategy pattern or whatever. "

	^self executeStatement: aQuery on: aConnection querySettings: DBXQuerySettings default.
! !

!DBXPlatform methodsFor: 'query' stamp: 'PanuSuominen 9/1/2010 20:01'!
executeStatement: aString on: aConnection querySettings: aQuerySettings 
	"After executing a query, we will then want to retrieve the results. It may be possible to retrieve all rows at once, one by one or more than one row at once. All positive values including zero are allowed as values for a page size. As this is a special option that not all the engines support you must enable this feature using DBXConnection #enablePagedResults. If paging (more than one row at once) is not supported by the backend, it will use 'one by one' or 'all at once' if this is the only option provided."
	| err result encodedQuery |
	encodedQuery := (aConnection encodeString: aString).
	err := OpenDBX current
				apiQuery: aConnection handle
				query: encodedQuery
				length: encodedQuery size.
	self log: 'odbx_query: called with values: handle = ', aConnection handle asString, ' query = ', aString.
	self verifyError: err on: aConnection.
	result := self processNextResultSet: aConnection querySettings: aQuerySettings.

	"If the result is a DBXResult, I must end the resultset. If the result is nil, it will probably 	be a query of transaction, like begin transaction or rollback"
	(result isNil not and: [ result isResult]) 
		ifTrue: [ self endDBXResult: aConnection querySettings: aQuerySettings. ].
	^ result.
! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'PanuSuominen 9/2/2010 21:24'!
fieldRawValue: anIndex on: aResultSet
	"Returns the value of the column at anIndex of the current row from aResultSet"
	| value |
	value := OpenDBX current apiQueryFieldValue: (aResultSet handle) index: (anIndex - 1).
	^value isNil ifTrue:[value] ifFalse:[aResultSet connection decodeString: value].! !

!DBXPlatform methodsFor: 'options' stamp: 'MMP 2/4/2009 23:44'!
getOption: anOption on: aConnection 
	"It asks the backend if an specific option is supported or not"
	| err isSupported |
	isSupported := WordArray with: 0.
	err := OpenDBX current 
		apiGetOption: aConnection handle
		option: anOption
		value: isSupported.
	self 
		verifyError: err
		on: aConnection.
	^ self dbxSmallIntegerAsBoolean: (isSupported first)! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:10'!
largeFieldRawValue: anIndex on: aResultSet
	self halt: 'not yet implemented'.! !

!DBXPlatform methodsFor: 'logging' stamp: 'EL 9/14/2008 08:49'!
log: messageBlockOrString
	self class log: messageBlockOrString! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:11'!
moveNext: aResultSet 
	"Moves the aResultSet one more row and this row is returned."
	| err |
	err := OpenDBX current apiQueryFetchRow: aResultSet handle.
	self log: ['odbx_row_fetch: called with values: resultSet handle = ', aResultSet handle asString].
	self log: ['odbx_row_fetch call returned ', err asString].
	self verifyError: err on: aResultSet connection.
	err = OpenDBX rowDone
		ifTrue: [ ^ nil ]
		ifFalse: [^ DBXRow on: aResultSet]! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:44'!
nextResultSet: aResultSet ifDone: aBlock
	"Returns the next resultSet from the last resultSet. When there is no more resultSets, 
	the block is evaluated." 
	^ self
		nextResultSet: aResultSet connection
		querySettings: aResultSet querySettings
		onReturn: [:handle :code | code = OpenDBX resultDone
				ifTrue: [aBlock value]]! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MarianoMartinezPeck 9/30/2009 12:12'!
nextResultSet: aConnection querySettings: aQuerySettings onReturn: aBlock 
	"Returns the next resultSet from the last resultSet. When there is no more resultSets, 
	the block is evaluated." 
	| handle err handleArray |
	handleArray := WordArray with: 0.

	err := OpenDBX current
				apiQueryResult: aConnection handle
				handle: handleArray
				timeout: aQuerySettings timeoutAsDBXTimeSpec
				chunk: aQuerySettings pageSize.
	self log: [
		'odbx_result: called with values:',
			' handle = ', aConnection handle asString, 
			' chunk = ', aQuerySettings pageSize asString,
			String cr, 
		'odbx_result call return: ', err asString ].
	
	self verifyError: err on: aConnection.
	handle := handleArray first.
	self log: [ 'odbx_result resultSet handle returned: ', handle asString ].
	aBlock notNil
		ifTrue: [aBlock value: handle value: err].
	^ handle! !

!DBXPlatform methodsFor: 'connection' stamp: 'MarianoMartinezPeck 10/5/2009 20:11'!
openConnection: aConnection 
	"'createConnection: should be called first'"
	"It opens the connection, by associating the handle created by
	'createConnection:' to a specific database after the server verified and
	accepted the user credentials. All further operations will (normally)
	only affect the tables and records within this database. The operations
	may be limited to certain subset depending on the privileges granted to
	the given user account. If 'openConnection:' succeeds, it also enables
	compatibility to the ANSI SQL standard if this is possible for the database
	server implementation."
	| err |
	
	self setNecessarySpecialOptions: aConnection. 
	
	err := OpenDBX current 
		apiBind: aConnection handle
		database: aConnection database
		name: aConnection userName
		password: aConnection userPassword
		method: aConnection authenticationMethod.
	self log: 
		[ 'odbx_bind: called with values:' , ' handle = ' , aConnection handle asString , ' database = ' , aConnection database , ' userName = ' , aConnection userName , ' userPassword = ' , aConnection userPassword ].

	self 
		verifyError: err
		handle: aConnection handle.
	^ true! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 7/1/2009 22:00'!
processNextResultSet: aConnection querySettings: aQuerySettings
	"Gets the next resultSet of the query. Depending on the type of query, it will return a DBXResult or DBXResultSet.
	If there is a timeout, it will cicle till this is finished."
	| returnCode |
	[self
		nextResultSet: aConnection
		querySettings: aQuerySettings
		onReturn: [:handle :code | 
			returnCode := code.
			code = OpenDBX resultWithRows
				ifTrue: [ ^ self processResultWithRows: aConnection
					 resultHandle: handle 
					querySettings: aQuerySettings].
			code = OpenDBX resultWithoutRows
				ifTrue: [ ^ self processResultWithoutRows: aConnection
					 resultHandle: handle
					 querySettings: aQuerySettings].
			code = OpenDBX resultDone ifTrue: [^ nil].
			
			(code = OpenDBX resultTimeout) ifTrue: [ (Delay forMilliseconds: (aQuerySettings timeout asMiliseconds)) wait  ].
			
			]] 	doWhileTrue: [returnCode = OpenDBX resultTimeout].
		
		SqueakDBXError signal: 'Uknown problem with executeStatement'.! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:31'!
processResultWithRows: aConnection resultHandle: aHandle querySettings: aQuerySettings	
	"Process a result with rows and returns a DBXResultSet"
	| description |
	description := self descriptionForResultSet: aHandle on: aConnection.
	^ DBXResultSet
		on: aConnection
		handle: aHandle
		description: description
		querySettings: aQuerySettings	
	! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:31'!
processResultWithoutRows: aConnection resultHandle: aHandle querySettings: aQuerySettings	
	"Process a query with a result without rows and returns a DBXResult"
	| description err |
	description := self descriptionForResult: aHandle on: aConnection.
	err := OpenDBX current apiQueryFinalize: aHandle.
	self log: [ 'odbx_result_finish: called with values: resultSet handle = ', aHandle asString ].			
	self log: [ 'odbx_result_finish call returned ', err asString ].
	^ DBXResult
		on: aConnection
		handle: aHandle
		description: description
		querySettings: aQuerySettings.! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:32'!
queryDelimiter
	" Returns the delimiter of the query. For example, ';' . But this depends on the backend"
	^self subclassResponsibility! !

!DBXPlatform methodsFor: 'encoding' stamp: 'PanuSuominen 9/10/2010 09:55'!
queryEncoding: aConnection
	"Method should use platorm spesific way to determine what is the encoding used to talk with the server using.
	Method should return the name of the encoding."

	self subclassResponsibility.! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 22:34'!
releaseAllQueryResultSets: aResultSet 
	"Releases all query resultsSets a query may return by iterating them.
	Each resultSet is Closed and all allocated memory by the OpenDBX
	library is freed ."
	self releaseResultSet: aResultSet.
	self endDBXResult: aResultSet connection querySettings: aResultSet querySettings! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 23:06'!
releaseResultSet: aResultSet 
	"Closes a resultSet and all allocated memory by the OpenDBX library is
	freed . In case you want to realese all query resultSets, yo must call
	realeseAllQueryResultSets: "
	self releaseResultSet: aResultSet handle connection: aResultSet connection! !

!DBXPlatform methodsFor: 'resultSet' stamp: 'MMP 6/4/2009 23:03'!
releaseResultSet: aResultSetHandle connection: aConnection
	"Closes a resultSet and all allocated memory by the OpenDBX library is
	freed . In case you want to realese all query resultSets, yo must call
	realeseAllQueryResultSets: "
	| err |
	err := OpenDBX current apiQueryFinalize: aResultSetHandle.
	self log: [ 'odbx_result_finish: called with values: resultSet handle = ', aResultSetHandle asString ].
	self verifyError: err on: aConnection! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 22:37'!
rollback
	"If a certain backend doesn't use this sintax, it must subclass and override this method."
	^ 'ROLLBACK'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 22:35'!
rollback: aConnection
	"executes a rollback statement on a connection"
	^self executeStatement: self rollback on: aConnection.! !

!DBXPlatform methodsFor: 'options' stamp: 'MarianoMartinezPeck 10/5/2009 20:12'!
setNecessarySpecialOptions: aConnection 
	"This message will be called ALWAYS just before opening the connection. This can be used when you need to enable or disable ALWAYS a particular number of special options. The particular platform subclass can override this method to do this. For example, to get MySQL4 working, you always need to enable a special mode. Look for DBXMySQLPlatform>>setNecessarySpecialOptions for an example"
	! !

!DBXPlatform methodsFor: 'options' stamp: 'MMP 2/3/2009 01:25'!
setOption: anOption value: anObject on: aConnection 
	"It enables an specific option for a connection."
	| err value |
	(anObject class = True) ifTrue: [value := ByteArray with: anObject asBit ].
	(anObject class = False) ifTrue: [value := ByteArray with: anObject asBit ].
	(anObject class = SmallInteger) ifTrue: [value := ByteArray with: anObject].
	(anObject class = ByteString) ifTrue: [value := anObject ].
	err := OpenDBX current
				apiSetOption: aConnection handle
				option: anOption
				value: value.
	self verifyError: err on: aConnection! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 22:36'!
startTransaction
	"It returns the start transaction statement most commonly used by the backends. If a certain backend
	doesn't use this sintax, it must subclass and override this method."
	^'START TRANSACTION'! !

!DBXPlatform methodsFor: 'transactional manage' stamp: 'MMP 6/4/2009 22:36'!
startTransaction: aConnection
	"Starts a transaction on a connection"
	^self executeStatement: self startTransaction on: aConnection.! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 6/4/2009 00:11'!
verifyError: err handle: aHandle
	"If verifies if a returned number of a call to an openDBX function, is an error or not. If true, a DBXError or any 	subclass is thrown with the associated openDBX message for that error.
	Sometimes I don't have the DBXConnection object created or even with the handle set (for example when creating
	the conenction. In this case, You should use this method. If you have the connection created and set a handle
	you must use verifyError: err on: aConnection "
	err < 0
		ifTrue: [ self errorCode: err handle: aHandle]! !

!DBXPlatform methodsFor: 'error handling' stamp: 'MMP 6/3/2009 23:47'!
verifyError: err on: aConnection 
	"It verifies if a returned number of a call to an OpenDBX function, is an
	error or not. If true, a DBXError or any subclass is thrown with the associated OpenDBX
	message for that error."
	err < 0
		ifTrue: [self errorCode: err on: aConnection]! !

DBXPlatform subclass: #DBXPostgresPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXPostgresPlatform commentStamp: 'EL 8/16/2008 09:53' prior: 0!
I am the PostgreSQL specific platform definition. 

Instance Variables
!

!DBXPostgresPlatform class methodsFor: 'defaults' stamp: 'MarianoMartinezPeck 2/12/2010 18:18'!
createDataTypesMap
	^super createDataTypesMap
		at: 16r20 put: String; "CLOB"
		yourself
		! !

!DBXPostgresPlatform methodsFor: 'accessing' stamp: 'EL 6/27/2008 20:30'!
backend
	^'pgsql'! !

!DBXPostgresPlatform methodsFor: 'resultSet' stamp: 'MMP 8/11/2008 23:15'!
queryDelimiter
	^';'! !

!DBXPostgresPlatform methodsFor: 'encoding' stamp: 'PanuSuominen 9/3/2010 21:02'!
queryEncoding: aConnection
	| result enc |
	[ 
	result := aConnection execute: 'SHOW CLIENT_ENCODING'.
	enc := result nextRow rawValueAt: 1 ]
		on: DBXRecoverableError do: [
			Error signal: 'Querying encoding from Postgresql server failed!!'.
			];
		ensure: [ result ifNotNil: [ result releaseResult ] ].
	^ enc! !

DBXPlatform subclass: #DBXSqlitePlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXSqlitePlatform class methodsFor: 'defaults' stamp: 'MarianoMartinezPeck 2/12/2010 22:18'!
createDataTypesMap
	^super createDataTypesMap
		at: 16r20 put: String; "CLOB"
		at: 16r2F put: ByteArray;  "BLOB"
		yourself
		! !

!DBXSqlitePlatform methodsFor: 'accessing' stamp: 'MMP 9/9/2008 01:39'!
backend
	^'sqlite3'! !

!DBXSqlitePlatform methodsFor: 'resultSet' stamp: 'MMP 5/27/2009 02:46'!
executeMultiStatement: aString on: aConnection querySettings: aQuerySettings 
	^ super executeMultiStatement: aString on: aConnection querySettings: (aQuerySettings timeout: nil) ! !

!DBXSqlitePlatform methodsFor: 'resultSet' stamp: 'MMP 4/6/2009 21:38'!
executeStatement: aString on: aConnection querySettings: aQuerySettings
	^ super executeStatement: aString on: aConnection querySettings: (aQuerySettings timeout: nil)! !

!DBXSqlitePlatform methodsFor: 'resultSet' stamp: 'MMP 9/17/2008 23:28'!
queryDelimiter
	^';'! !

!DBXSqlitePlatform methodsFor: 'transactional manage' stamp: 'MMP 9/16/2008 01:22'!
startTransaction
	^'BEGIN TRANSACTION'! !

Object subclass: #DBXQuerySettings
	instanceVariableNames: 'pageSize timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXQuerySettings class methodsFor: 'default' stamp: 'MMP 6/1/2009 21:57'!
default
	"returns the default querySettings. This is used when you call DBXConnection>>execute:"
	^ self pageSize: self defaultPageSize timeout: self defaultTimeout 
! !

!DBXQuerySettings class methodsFor: 'default' stamp: 'MMP 1/31/2009 20:30'!
defaultPageSize
	^ 0! !

!DBXQuerySettings class methodsFor: 'default' stamp: 'MMP 7/1/2009 22:17'!
defaultTimeout
	"10 miliseconds"
	^DBXQueryTimeout seconds: 0 microseconds: 10.! !

!DBXQuerySettings class methodsFor: 'instance creation' stamp: 'MMP 4/6/2009 21:03'!
pageSize: aPageSize
	^(super new)
		pageSize: aPageSize;
		timeout: self defaultTimeout;
		yourself.! !

!DBXQuerySettings class methodsFor: 'instance creation' stamp: 'MMP 4/6/2009 01:52'!
pageSize: aPageSize timeout: aQueryTimeout 
	^(super new)
		pageSize: aPageSize;
		timeout: aQueryTimeout;
		yourself.! !

!DBXQuerySettings class methodsFor: 'instance creation' stamp: 'MMP 4/6/2009 21:02'!
timeout: aQueryTimeout 
	^(super new)
		pageSize: self defaultPageSize;
		timeout: aQueryTimeout;
		yourself.! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 1/31/2009 20:03'!
pageSize
	^ pageSize! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 1/31/2009 20:03'!
pageSize: anObject
	pageSize := anObject! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 4/6/2009 01:50'!
timeout
	^ timeout! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 4/6/2009 01:50'!
timeout: anObject
	timeout := anObject! !

!DBXQuerySettings methodsFor: 'accessing' stamp: 'MMP 4/7/2009 00:17'!
timeoutAsDBXTimeSpec
	^self timeout ifNotNil: [self timeout asTimeSpec].! !

Object subclass: #DBXQueryTimeout
	instanceVariableNames: 'seconds microseconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXQueryTimeout class methodsFor: 'instance creation' stamp: 'MMP 4/7/2009 00:08'!
seconds: seconds 
	^ self new
		seconds: seconds;
		microseconds: 0;
		yourself! !

!DBXQueryTimeout class methodsFor: 'instance creation' stamp: 'MMP 4/7/2009 00:07'!
seconds: seconds microseconds: microseconds 
	^ self new
		seconds: seconds;
		microseconds: microseconds;
		yourself! !

!DBXQueryTimeout methodsFor: 'accessing' stamp: 'MMP 6/29/2009 21:14'!
asMiliseconds
	^ (self seconds * 1000) + (((self microseconds / 1000) asFloat) integerPart asInteger )! !

!DBXQueryTimeout methodsFor: 'accessing' stamp: 'MMP 4/7/2009 00:06'!
asTimeSpec
	^ DBXTimeSpec seconds: self seconds nseconds: self microseconds ! !

!DBXQueryTimeout methodsFor: 'accessing' stamp: 'MMP 4/6/2009 01:36'!
microseconds
	^ microseconds! !

!DBXQueryTimeout methodsFor: 'accessing' stamp: 'MMP 4/6/2009 01:36'!
microseconds: anObject
	microseconds := anObject! !

!DBXQueryTimeout methodsFor: 'accessing' stamp: 'MMP 4/6/2009 01:36'!
seconds
	^ seconds! !

!DBXQueryTimeout methodsFor: 'accessing' stamp: 'MMP 4/6/2009 19:50'!
seconds: anObject 
	seconds := anObject! !

Object subclass: #DBXResultDescription
	instanceVariableNames: 'rowsAffected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:02'!
rowsAffected
"number of rows that have been changed by the current statement"
	^rowsAffected! !

!DBXResultDescription methodsFor: 'accessing' stamp: 'EL 6/29/2008 12:52'!
rowsAffected: aNumber
	rowsAffected := aNumber ! !

Object subclass: #DBXResultSetDescription
	instanceVariableNames: 'columnDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Description'!

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:09'!
addColumnDescription: aColumnDescription
"it adds a new column description to the column descriptions collection"
	self columnDescriptions add: aColumnDescription! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:10'!
columnCount
"this allows you to know the number of columns for each row retrieved from the database"
	^self columnDescriptions size! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:11'!
columnDescriptionAt: anIndex
"returns the column description holded in 'anIndex' position"
	^self columnDescriptions at: anIndex! !

!DBXResultSetDescription methodsFor: 'accessing' stamp: 'HMC 8/16/2008 21:12'!
columnDescriptions
"Collection of column descriptions"
	^columnDescriptions ! !

!DBXResultSetDescription methodsFor: 'initialization' stamp: 'HMC 8/16/2008 21:09'!
initialize
"this DBXResultSetDescription will contain a collection of its own column descriptions, retrieved from the database"
	super initialize.
	columnDescriptions := OrderedCollection new.! !

Object subclass: #DBXRow
	instanceVariableNames: 'resultSet rawValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Structure'!

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 3/31/2008 10:21'!
new
	self error: 'Use #onResultSet:'! !

!DBXRow class methodsFor: 'instance creation' stamp: 'EL 6/29/2008 11:27'!
on: aResultSet
	^(self basicNew)
		initializeResultSet: aResultSet;
		yourself.
		! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/27/2008 22:01'!
columnDescriptionAt: anIndex
	^self resultSet columnDescriptionAt: anIndex! !

!DBXRow methodsFor: 'private' stamp: 'MarianoMartinezPeck 2/13/2010 15:24'!
columnDescriptionType: anIndex
	^(self columnDescriptionAt: anIndex) type! !

!DBXRow methodsFor: 'private' stamp: 'MMP 8/23/2008 18:27'!
columnDescriptionWithName: columnName
	^self resultSet columnDescriptionWithName: columnName


 ! !

!DBXRow methodsFor: 'private' stamp: 'MMP 12/22/2008 20:55'!
columnIndex: aString 
	self resultSet columnDescriptions
		withIndexDo: [:each :index | (each name sameAs: aString)
				ifTrue: [^ index]].
	SqueakDBXError signal: 'A column with that name was not found'.
! !

!DBXRow methodsFor: 'private' stamp: 'EL 8/19/2008 13:38'!
convertValueAt: anIndex 
	^ (self rawValueAt: anIndex)
		ifNotNilDo: [:columnValue | (self columnDescriptionType: anIndex)
			fromDbxString: columnValue]! !

!DBXRow methodsFor: 'initialization' stamp: 'MMP 8/16/2008 21:15'!
initializeResultSet: aResultSet
	"It initialize a Row receiving a result set. We need the result set in order to ask the information about the column descriptions"
	super initialize.
	resultSet := aResultSet.
	self initializeRow.
	! !

!DBXRow methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 2/13/2010 15:24'!
initializeRow
	"Initialize the row. All the row values will be set."
	rawValues := Array new: self resultSet columnCount.
	self resultSet columnDescriptions withIndexDo: [ :each :i|
		each isLarge
			ifTrue: [ SqueakDBXError signal: 'Large objects not supported yet' ]
			ifFalse: [ rawValues at: i put: (self platform fieldRawValue: i  on: self resultSet) ] ]! !

!DBXRow methodsFor: 'private' stamp: 'EL 6/29/2008 12:19'!
platform
	^self resultSet platform! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:06'!
rawValueAt: anIndex
	"It returns the value of the raw at the specified index. No conversion is here, so all values will be String"
	^rawValues at: anIndex! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:07'!
rawValueNamed: aString
	"It returns the value of the raw with the specified name. No conversion is here, so all values will be String"
	^self rawValueAt: (self columnIndex: aString) ! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:07'!
rawValues
	"It returns the values of all the raw. No conversion is here, so all values will be String"
	^rawValues! !

!DBXRow methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 21:09'!
rawValuesDo: aBlock
	"It will execute the block on all the row values. No conversion is here, so all values will be String"
	^self rawValues do: aBlock! !

!DBXRow methodsFor: 'accessing' stamp: 'EL 3/31/2008 10:22'!
resultSet
	^ resultSet! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:11'!
valueAt: anIndex
	"It returns the value of the raw at the specified index. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self convertValueAt: anIndex 
! !

!DBXRow methodsFor: 'accessing' stamp: 'MMP 8/16/2008 21:11'!
valueNamed: aString
	"It returns the value of the raw with the specified name. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self convertValueAt: (self columnIndex: aString).
! !

!DBXRow methodsFor: 'accessing' stamp: 'test 1/8/2009 18:08'!
values
	"It returns the all the values of the raw. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self rawValues withIndexCollect: [ :each :index | 
		each ifNotNil: [
			(self columnDescriptionType: index) fromDbxString: each ] ]! !

!DBXRow methodsFor: 'enumerating' stamp: 'MMP 8/16/2008 21:12'!
valuesDo: aBlock
	"It will execute the block on all the row values. Each string returned from openDBX will be converted, if supported, to Squeak types"
	^self values do: aBlock! !

Object subclass: #DBXSpecialOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
compression
	"0x0022 in hexadecimal in openDBX. But we need it as decimal"
	^16r0022! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
encryption
	 "0x0010 in hexadecimal in openDBX. But we need it as decimal"
	^16r0010! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
multipleStatements
	 "0x0020 in hexadecimal in openDBX. But we need it as decimal"
	^16r0020! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 7/18/2008 19:21'!
pagedResults
 	"0x0021 in hexadecimal in openDBX. But we need it as decimal"
	^16r0021! !

!DBXSpecialOptions class methodsFor: 'options' stamp: 'MMP 8/18/2008 16:19'!
specialModes
	"0x0023 in hexadecimal in openDBX. But we need it as decimal"
	^16r0023
! !

Object subclass: #DBXTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-Tests'!

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 5/26/2009 21:14'!
show: result
	result class = DBXResult
		ifTrue: [self showResult: result].
	result class = DBXResultSet
		ifTrue: [self showResultSet: result].
	result class = DBXMultiStatementResultSetIterator
		ifTrue: [self showMultiStatementResultSetIterator: result ].! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 5/26/2009 21:17'!
showMultiStatementResultSetIterator: anIterator
	anIterator allResultsDo: [ :each | self show: each ].
	! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MMP 7/18/2008 22:25'!
showResult: result 
	Transcript show: 'They were affected ' , result rowsAffected asString, ' rows';
		 cr! !

!DBXTranscript class methodsFor: 'stream extensions' stamp: 'MarianoMartinezPeck 10/13/2009 18:09'!
showResultSet: resultSet 
	| stream |
	stream := String new writeStream.
	resultSet columnDescriptions
		do: [:each | stream nextPutAll: each name]
		separatedBy: [stream nextPutAll: ' | '].
	Transcript show: stream contents;
		 cr.
	resultSet
		rowsDo: [:row | 
			stream := String new writeStream.
			row values
				do: [:each | stream nextPutAll: each asDbxString]
				separatedBy: [stream nextPutAll: ' | '].
			Transcript show: stream contents;
				 cr]! !

Object subclass: #DBXTypeNotSupported
	instanceVariableNames: 'code type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenDBX-Core-API'!

!DBXTypeNotSupported commentStamp: 'EL 8/3/2008 08:33' prior: 0!
I'm an unsupported data type

Instance Variables
!

!DBXTypeNotSupported class methodsFor: 'instance creation' stamp: 'EL 8/14/2008 09:33'!
code: aNumber
	^self new
		code: aNumber;
		yourself! !

!DBXTypeNotSupported class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/5/2008 08:45'!
fromDbxString: aString
	self error: 'Type not supported'! !

!DBXTypeNotSupported class methodsFor: 'instance creation' stamp: 'EL 8/14/2008 09:33'!
type: aSymbol
	^self new
		type: aSymbol;
		yourself! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
code
	^ code! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
code: anObject
	code := anObject! !

!DBXTypeNotSupported methodsFor: 'dbx' stamp: 'MMP 12/22/2008 20:56'!
fromDbxString: aString
	self type 
		ifNotNil: [ SqueakDBXError signal: ('Unsupported data type: {1}, trying to parse: {2}' format: {self type. aString}) ]
		ifNil: [ SqueakDBXError signal: ('Unknown data type: {1}, trying to parse: {2}' format: {self code. aString}) ]
		
	
! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
type
	^ type! !

!DBXTypeNotSupported methodsFor: 'accessing' stamp: 'EL 8/14/2008 09:32'!
type: anObject
	type := anObject! !

!Object class methodsFor: '*OpenDBX-Core' stamp: 'EL 8/2/2008 12:09'!
fromDbxString: aString
	self subclassResponsibility! !

!Object methodsFor: '*OpenDBX-Core' stamp: 'EL 8/3/2008 08:18'!
asDbxString
	^ self printString! !
DBXTimeSpec initialize!
DBXConnection initialize!
